(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



BeginPackage["Aerodynamics`AirfoilGeometry`",{"Aerodynamics`CartesianVectors`","Aerodynamics`Graphics`"}];


AirfoilGeometry::usage="AirfoilGeometry is a package providing functions to specify airfoil shape, discretize the airfoil and compute geometric properties of the discretizated airfoil.";


AirfoilFromDataFile::usage="AirfoilFromDataFile[filename] imports data from a file and rearranges the data to conform to the conventions used in Aerodynamics.";


AirfoilInteriorQ::usage="AirfoilInteriorQ[{x, z},rp] returns True if the point {x, z} is interior to the discretized airfoil specified by the collection of vectors rp, False if not.";


AirfoilSurfacePoints::usage = "AirfoilSurfacePoints[spline, x] returns a collection of vectors on the surface of an airfoil, where the airfoil is described by a b=spline.  Locations of points on the surface of the airfoil are determined from a list of x values.
AirfoilSurfacePoints[properties] returns a collection of vectors on the surface of an airfoil specified by list of thickness and camber properties.
AirfoilSurfacePoints[t, tau, theta] returns a collection of vectors on the surface of a van de Vooren airfoil of thickness parameter t and trailing-edge angle tau corresponding to a list of theta values in the range 0 to Pi.";


ConstantSpacing::usage="ConstantSpacing is a value for the option Layout in the function NDiscretizeUnitSegment.";


CosineSpacing::usage="CosineSpacing is a value for the option Layout in the function NDiscretizenitSegment.";


FitAirfoil::usage="FitAirfoil[rD] fits a b-spline to a collection of vectors rD spedifying points on the surface of an airfoil.";


HalfCosineSpacing::usage="HalfCosineSpacing is a value for the option Layout for the function NDiscretizeUnitSegment.";


Layout::usage="Layout is an option of NDiscretizeUnitSegment providing some flexibility for discretizing an airfoil.";


NACA4DigitAirfoil::usage = "NACA4DigitAirfoil[id, x] computes a nested list of thickness and camber propereties at a list of x values for the NACA airfoil identified by the four-digit identification number id.";


NDiscretizeUnitSegment::usage="NDiscretizeUnitSegment[n] returns a list of n+1 numbers in the range from zero to one dividing the unit segment into n subsegments.
NDiscretizeUnitSegment[n,np] returns the list of numbers to precision np.";


PanelAngles::usage="PanelAngles[rP] returns a list of angles that the connected panels located by the collection of vectors rP make with the x axis. ";


PanelLengths::usage="PanelLengths[rP] returns a list of lengths of the connected panels located by the collection of vectors rP.";


PanelNormals::usage="PanelNormals[rp] returns a collection of outward unit normal vectors to the connected panels located by the collection of vectors rp.";


PanelOffset::usage = "PanelOffset is an option for the functions NDiscretizeUnitSegment and PanelPoints allowing flexibility in locating points.";


PanelPoints::usage="PanelPoints[rp] returns a collection of vectors locating points on panels specified by endpoints, rp.";


ThickAirfoilQ::usage="ThickAirfoilQ[rp] returns True if the airfoil specified by the collection of vectors, rp has thickness, False if it does not.";


TrailingEdgeAngle::usage=
"TrailingEdgeAngle[rp] returns the angle between the two trailiing-edge panels of the airfoil specified by the collection of vectors rp.";


XToTheta::usage="XToTheta[t, tau, x] converts a list of x values to a list of theta values using the van de Vooren transformation for an airfoil of thickness t and trailing-edge angle tau.";


AirfoilGeometry::cv="Argument must be of data type CartesianVectors.";


AirfoilGeometry::id="First argument identifies the member of the `1` airfoil family and must be `2`.";


AirfoilGeometry::prop="Argument must be a nested list of thickness and camber properties, usually provided by functions such as NACA4DigitAirfoil.";


AirfoilGeometry::xlist1="Argument must specify discretized x values with a simple list of values between 0 and 1.";


AirfoilGeometry::xlistm="`1` argument must specify discretized x values with a simple list of values between 0 and 1.";


AirfoilGeometry::parameter="Parameter list for spline is not ordered as expected, probably causing an error in locating panel endpoints for specified discretization.";


NDiscretizeUnitSegment::arg="Replace `1` with a positive integer.";


NDiscretizeUnitSegment::args="Both arguments must be positive integers.";


NDiscretizeUnitSegment::layout="Replace `1` with ConstantSpacing, HalfCosineSpacing or CosineSpacing.";


NDiscretizeUnitSegment::range="Replace `1` with number in the range 0 \[LessEqual] n < 1.";


Begin["Aerodynamics`AirfoilGeometry`Private`"];


Unprotect[AirfoilFromDataFile,AirfoilGeometry,AirfoilInteriorQ,FitAirfoil,PanelAngles,PanelNormals,PanelPoints,AirfoilSurfacePoints,ConstantSpacing,CosineSpacing,HalfCosineSpacing,Layout,NACA4DigitAirfoil,NDiscretizeUnitSegment,PanelLengths,PanelOffset,ThickAirfoilQ,TrailingEdgeAngle,XToTheta];


SetAttributes[{AirfoilFromDataFile,PanelAngles,PanelNormals,PanelPoints,AirfoilSurfacePoints,NACA4DigitAirfoil,PanelLengths,XToTheta},NumericFunction]


SetAttributes[{PanelNormals,PanelPoints,PanelLengths,ThickAirfoilQ,TrailingEdgeAngle},Listable]


Options[NDiscretizeUnitSegment]={Layout->ConstantSpacing,PanelOffset->0.0};


Options[PanelPoints]={PanelOffset->0.5};


dcall:NDiscretizeUnitSegment[n_Integer?Positive,opts___?OptionQ]:=Module[{layout,panelOffset,temp,xEnd,\[CapitalDelta]x,valid=Map[First,Options[NDiscretizeUnitSegment]]},Scan[If[!MemberQ[valid,First[#]],Message[NDiscretizeUnitSegment::optx,ToString[First[#]],ToString[Unevaluated[dcall]]]]&,Flatten[{opts}]];{layout,panelOffset}={Layout,PanelOffset}/.Flatten[{opts}]/.Options[NDiscretizeUnitSegment];temp=Range[0.,1,N[1/n]];xEnd=Switch[layout,ConstantSpacing,temp,HalfCosineSpacing,1-Cos[\[Pi] temp/2],CosineSpacing,(1-Cos[\[Pi] temp])/2,_,Message[NDiscretizeUnitSegment::layout,layout]];If[TrueQ[panelOffset==0],xEnd,If[TrueQ[0<panelOffset<1],\[CapitalDelta]x=Drop[xEnd-RotateRight[xEnd],1];Drop[xEnd,-1]+panelOffset \[CapitalDelta]x,Message[NDiscretizeUnitSegment::range,panelOffset]]]]


dcall:NDiscretizeUnitSegment[n_Integer?Positive,p_Integer?Positive,opts___?OptionQ]:=Module[{layout,panelOffset,temp,xEnd,\[CapitalDelta]x,valid=Map[First,Options[NDiscretizeUnitSegment]]},Scan[If[!MemberQ[valid,First[#]],Message[NDiscretizeUnitSegment::optx,ToString[First[#]],ToString[Unevaluated[dcall]]]]&,Flatten[{opts}]];{layout,panelOffset}={Layout,PanelOffset}/.Flatten[{opts}]/.Options[NDiscretizeUnitSegment];temp=Range[N[0,p],1,N[1/n,p]];xEnd=Switch[layout,ConstantSpacing,temp,HalfCosineSpacing,1-Cos[\[Pi] temp/2],CosineSpacing,(1-Cos[\[Pi] temp])/2,_,Message[NDiscretizeUnitSegment::layout,layout]];If[TrueQ[panelOffset==0],xEnd,If[TrueQ[0<panelOffset<1],\[CapitalDelta]x=Drop[xEnd-RotateRight[xEnd],1];Drop[xEnd,-1]+panelOffset \[CapitalDelta]x,Message[NDiscretizeUnitSegment::range,panelOffset]]]]


NDiscretizeUnitSegment[n_, opts___?OptionQ]:=Message[NDiscretizeUnitSegment::arg,n]


NDiscretizeUnitSegment[n_,p_, opts___?OptionQ]:=Message[NDiscretizeUnitSegment::args]


NDiscretizeUnitSegment[x___,opts___?OptionQ]:=Message[NDiscretizeUnitSegment::argb,"NDiscretizeUnitSegment",Length[{x}],"1","2"]


AirfoilFromDataFile[file_String]:=Module[{convention,data,n,orderedPoints,points},
(* use ToExpression to handle cases where a number is enclosed in parentheses  *)
data=Cases[Import[file,"Table"]//ToExpression//Quiet,{_Real,_Real}];
(* ignore a "long" trailing edge panel whose endpoint is specified as a real number *)
data=If[Last[data][[1]]<5,data,Most[data]];
(* identify the two numbering conventions used in data files *)
convention=If[data[[2,1]]<=.001,"ForeToAft","Counterclockwise"];
orderedPoints=Switch[
convention,
"Counterclockwise",Reverse[data],
"ForeToAft",
{n,points}={IntegerPart[First[data][[1]]],Rest[data]};
Join[Reverse[Take[points,-(n-1)]],Take[points,n]]];
MakeCartesianVectors[Transpose[orderedPoints]]]


NACA4DigitAirfoil[id_Integer?NonNegative/;id<10000,x_?VectorQ/;(Max[x]<=1 && Min[x]>=0)]:= Module[{ idDigits, m,  p,prec, t,xx,xAft,xFore,zCamber,zCamberAft,zCamberFore,zThick,\[Theta]Camber,\[Theta]CamberAft,\[Theta]CamberFore,\[Theta]Thick},
prec=Min[Map[Precision,x]];
{a0,a1,a2,a3,a4}=Map[(SetPrecision[#,prec])& ,{0.2969,-0.126,-0.3516,0.2843,-0.1015}];
idDigits=ToExpression[Characters[ToString[PaddedForm[id, 4, NumberPadding-> "0", NumberSigns-> {"",""}]]]];
m=SetPrecision[0.01*idDigits[[1]],prec];
p=SetPrecision[0.1*idDigits[[2]],prec];
t=SetPrecision[0.01*FromDigits[{idDigits[[3]],idDigits[[4]]}],prec];
zThick= 5t(a0 Sqrt[x]+a1 x+a2 x^2+a3 x^3+a4 x^4);
\[Theta]Thick= If[x[[1]]==0.,xx=Rest[x];
Prepend[ArcTan[ 5 t (a0/(2Sqrt[xx])+a1+2a2 xx+3a3 xx^2+4a4 xx^3) ],N[\[Pi]/2,prec]],ArcTan[ 5 t (a0/(2Sqrt[x])+a1+2a2 x+3a3 x^2+4a4 x^3) ]];
If[p==0,zCamber=\[Theta]Camber=0.*x,xFore=Select[x,#<=p&];
xAft=Part[x,Range[Length[xFore]+1,Length[x]]];
zCamberFore=(m/p^2)(2 p*xFore-xFore^2);
zCamberAft=(m/(1-p)^2)((1-2 p)+2 p*xAft-xAft^2);
\[Theta]CamberFore= ArcTan[(2m/p^2)( p-xFore)];
\[Theta]CamberAft= ArcTan[(2m)/(1-p)^2 (p-xAft)];
zCamber=Join[zCamberFore,zCamberAft];
\[Theta]Camber=Join[\[Theta]CamberFore,\[Theta]CamberAft]];
 {x,zThick, \[Theta]Thick, zCamber, \[Theta]Camber}]


NACA4DigitAirfoil[id_Integer?NonNegative/;id<10000,x_]:=Message[AirfoilGeometry::xlistm,"Second"]


NACA4DigitAirfoil[id_,x_]:=Message[AirfoilGeometry::id,"NACA 4-digit","a positive 4-digit integer"]


NACA4DigitAirfoil[x_]/;Length[{x}]==1:=Message[NACA4DigitAirfoil::argr,"NACA4DigitAirfoil",2]


NACA4DigitAirfoil[x___]:=Message[NACA4DigitAirfoil::argrx,"NACA4DigitAirfoil",Length[{x}],2]


AirfoilSurfacePoints[f_,x_List,opts___?OptionQ]:=
Module[{nT=50,cNewL,cNewU,fL,fU,optsFindRoot,tL,tP,tU,tS,xL,xML,xMU,xS,xTEL,xTEU,xU},
(* accept options of FindRoot *)
optsFindRoot=Sequence@@FilterRules[Flatten[{opts}],Options[FindRoot]];
(* locate parameter used to separate lower and upper surfaces *)
tS=t/.FindRoot[Apply[Divide,f'[t]]==0.,{t,0.48},Evaluated->False];
(* generate table of t-values and corresponding x-values *)
(* concentrate points near leading edge *)
tL=Reverse[tS(1-(1-Cos[0.5\[Pi] Range[0.,1,N[1/nT]]]))];
tU=tS+(1-tS)(1-Cos[0.5\[Pi] Range[0.,1,N[1/nT]]]);
{xL,xU}={Transpose[f/@tL][[1]],Transpose[f/@tU][[1]]};
(* interpolation functions *)
{fL,fU}={Interpolation[Transpose[{xL,tL}],InterpolationOrder->1],Interpolation[Transpose[{xU,tU}],InterpolationOrder->1]};
(* rescale x-values to be consistant with spline fit to airfoil *)
{xS,xTEL,xTEU}={f[tS][[1]],f[0][[1]],f[1][[1]]};
{cNewL,cNewU}={xTEL-xS,xTEU-xS};
{xML,xMU}={xS+cNewL x,xS+cNewU x};
(* parameter values corresponding to xML & xMU *)
tP=Join[Reverse[fL[xML]],Rest[fU[xMU]]];
If[OrderedQ[tP]==False,Message[AirfoilGeometry::parameter]];
(* construct collection of vectors locating panel endpoints *)
MakeCartesianVectors[Transpose[f/@tP]]]


AirfoilSurfacePoints[f_,x_List,zLE_Real,opts___?OptionQ]:=
Module[{nT=50,cNewL,cNewU,fL,fU,optsFindRoot,tL,tP,tU,tS,xL,xML,xMU,xS,xTEL,xTEU,xU},
(* accept options of FindRoot *)
optsFindRoot=Sequence@@FilterRules[Flatten[{opts}],Options[FindRoot]];
(* locate parameter used to separate lower and upper surfaces *)
tS=t/.FindRoot[f[t][[2]]==zLE,{t,0.5},Evaluated->False];
(* generate table of t-values and corresponding x-values *)
(* concentrate points near leading edge *)
tL=Reverse[tS(1-(1-Cos[0.5\[Pi] Range[0.,1,N[1/nT]]]))];
tU=tS+(1-tS)(1-Cos[0.5\[Pi] Range[0.,1,N[1/nT]]]);
{xL,xU}={Transpose[f/@tL][[1]],Transpose[f/@tU][[1]]};
(* interpolation functions *)
{fL,fU}={Interpolation[Transpose[{xL,tL}],InterpolationOrder->1],Interpolation[Transpose[{xU,tU}],InterpolationOrder->1]};
(* rescale x-values to be consistant with spline fit to airfoil *)
{xS,xTEL,xTEU}={f[tS][[1]],f[0][[1]],f[1][[1]]};
{cNewL,cNewU}={xTEL-xS,xTEU-xS};
{xML,xMU}={xS+cNewL x,xS+cNewU x};
(* parameter values corresponding to xML & xMU *)
tP=Join[Reverse[fL[xML]],Rest[fU[xMU]]];
If[OrderedQ[tP]==False,Message[AirfoilGeometry::parameter]];
(* construct collection of vectors locating panel endpoints *)
MakeCartesianVectors[Transpose[f/@tP]]]


AirfoilSurfacePoints[f_,x_List,opts___?OptionQ]:=
Module[{nT=50,cNewL,cNewU,fL,fU,optsFindRoot,tL,tP,tU,tS,xL,xML,xMU,xS,xTEL,xTEU,xU},
(* accept options of FindRoot *)
optsFindRoot=Sequence@@FilterRules[Flatten[{opts}],Options[FindRoot]];
(* locate parameter used to separate lower and upper surfaces *)
tS=t/.FindRoot[Apply[Divide,f'[t]]==0.,{t,0.48},Evaluated->False];
(* generate table of t-values and corresponding x-values *)
(* concentrate points near leading edge *)
tL=Reverse[tS(1-(1-Cos[0.5\[Pi] Range[0.,1,N[1/nT]]]))];
tU=tS+(1-tS)(1-Cos[0.5\[Pi] Range[0.,1,N[1/nT]]]);
{xL,xU}={Transpose[f/@tL][[1]],Transpose[f/@tU][[1]]};
(* interpolation functions *)
{fL,fU}={Interpolation[Transpose[{xL,tL}],InterpolationOrder->1],Interpolation[Transpose[{xU,tU}],InterpolationOrder->1]};
(* rescale x-values to be consistant with spline fit to airfoil *)
{xS,xTEL,xTEU}={f[tS][[1]],f[0][[1]],f[1][[1]]};
{cNewL,cNewU}={xTEL-xS,xTEU-xS};
{xML,xMU}={xS+cNewL x,xS+cNewU x};
(* parameter values corresponding to xML & xMU *)
tP=Join[Reverse[fL[xML]],Rest[fU[xMU]]];
If[OrderedQ[tP]==False,Message[AirfoilGeometry::parameter]];
(* construct collection of vectors locating panel endpoints *)
MakeCartesianVectors[Transpose[f/@tP]]]


AirfoilSurfacePoints[prop_List] := Module[ { cn, sn, xLow, xUp, x, zCamb, zLow, zThick, zUp,  \[Theta]Camb },x=prop[[1,All ]]; zThick=prop[[2,All]]; zCamb=prop[[ 4,All]]; \[Theta]Camb=prop[[ 5,All]]; cn=Cos[\[Theta]Camb]; sn=Sin[\[Theta]Camb]; xUp=x-zThick*sn; zUp=zCamb+zThick*cn; xLow=x+zThick*sn; zLow=zCamb-zThick*cn; If[xUp == xLow && zUp == zLow, MakeCartesianVectors[{xUp, zUp}], If[x[[1]]==0,
MakeCartesianVectors[{Join[Reverse[xLow], Rest[xUp]],Join[Reverse[zLow],Rest[zUp]]}],
MakeCartesianVectors[{Join[Reverse[xLow], xUp], Join[Reverse[zLow],zUp]}]]]]


AirfoilSurfacePoints[t_,\[Tau]_,\[Theta]_List]:=Module[{a,k,rL,rU,z,\[Epsilon]},
{k,\[Epsilon]}={2-(\[Tau]/\[Pi]),t/2};
a=2^(1-k) (1+\[Epsilon])^(k-1);
z=(a ( E^(I \[Theta])-1)^k)/(2( E^(I \[Theta])-  \[Epsilon])^(k-1))+1;
rU=Reverse[ComplexToCartesianVectors[z]];(* upper surface *)
rL=MirrorXAxis[rU];(* lower surface *)
Join[Most[rL],rU]]


XToTheta[t_,\[Tau]_,x_List,n_:100]:=Module[{f,table,xTable,\[Theta]Table},
\[Theta]Table=N[Range[0,\[Pi],\[Pi]/n]];
xTable=Take[Components[AirfoilSurfacePoints[t,\[Tau],\[Theta]Table]][[1]],n+1];
table=Transpose[{xTable,\[Theta]Table}];
f=Interpolation[table,Method->"Spline"];
f[Reverse[x]]]


FitAirfoil[r_CartesianVectors?TwoDimQ]:=Module[{pts},
pts=Transpose[Components[r]];
Clear[BSplineParametrization];
BSplineParametrization[inputs_,p_]:=
Module[{diff,total},
diff=(Norm[#,p])&/@Differences[inputs];
total=Total[diff];
Accumulate[Prepend[diff/total,0]]];
Clear[ParameterAverageKnots];
ParameterAverageKnots[deg_,params_]:=Join[ConstantArray[params[[1]],deg+1],Table[1/deg Sum[params[[i]],{i,j,j+deg-1}],{j,2,Length[params]-deg}],ConstantArray[params[[-1]],deg+1]];
Clear[BSplineInterpolation];
Options[BSplineInterpolation]={
InterpolationOrder->3,
"ParametrizationOrder"->2};
Clear[BSplineInterpolation];
Options[BSplineInterpolation]={
InterpolationOrder->3,
"ParametrizationOrder"->2};
BSplineInterpolation[input_,OptionsPattern[]]:=Module[{d,p,params,knots,BasisMatrix,cpts},
d=OptionValue[InterpolationOrder];
p=OptionValue["ParametrizationOrder"];
params=BSplineParametrization[input,p];
knots=ParameterAverageKnots[d,params];
BasisMatrix=Table[BSplineBasis[{d,knots},j-1,params[[i]]],{i,Length[params]},{j,Length[params]}];
cpts=LeastSquares[BasisMatrix,input];
BSplineFunction[cpts,SplineDegree->d,SplineKnots->knots,Method->{"Extrapolation"->"Clamp"}]];
BSplineInterpolation[pts]]


PanelPoints[r_CartesianVectors?TwoDimQ,opts___?OptionQ]:=Module[{n,offset,\[CapitalDelta]r},{offset} = {PanelOffset} /.Flatten[ {opts}] /. Options[ PanelPoints ];n=Dimensions[r][[2]];
\[CapitalDelta]r=Drop[r-RotateRight[r],1];
Drop[r,-1]+offset*\[CapitalDelta]r]


PanelPoints[x_]:=Message[AirfoilGeometry::cv]


PanelPoints[x___]:=Message[PanelPoints::argx,"PanelPoints",Length[{x}]]


PanelNormals[r_CartesianVectors?TwoDimQ]:=Module[{n,\[CapitalDelta]r},
n=Dimensions[r][[2]];
\[CapitalDelta]r=Drop[r-RotateRight[r],1];
Normalize[Cross[\[CapitalDelta]r]]]


PanelNormals[x_]:=Message[AirfoilGeometry::cv]


PanelNormals[x___]:=Message[PanelNormals::argx,"PanelNormals",Length[{x}]]


PanelAngles[r_CartesianVectors?TwoDimQ]:=Module[{tx,tz},{tx,tz}=Components[Normalize[Drop[r-RotateRight[r],1]]];ArcTan[tx,tz]]


PanelAngles[x_]:=Message[AirfoilGeometry::cv]


PanelAngles[x___]:=Message[PanelAngles::argx,"PanelAngles",Length[{x}]]


PanelLengths[r_CartesianVectors?TwoDimQ]:=Module[{\[CapitalDelta]r},\[CapitalDelta]r=Drop[r-RotateRight[r],1];Sqrt[\[CapitalDelta]r.\[CapitalDelta]r]]


ThickAirfoilQ[r_CartesianVectors?TwoDimQ]:=Positive[Apply[Subtract,Take[Components[r][[1]],2]]]


ThickAirfoilQ[f_SplineFunction]:=Positive[f[1.][[1]]-f[2.][[1]]]


TrailingEdgeAngle[r_CartesianVectors?TwoDimQ]:=Module[{mag\[CapitalDelta]rF,mag\[CapitalDelta]rL,tQ,\[CapitalDelta]rF,\[CapitalDelta]rL},
tQ=ThickAirfoilQ[r];
If[tQ===True,
{\[CapitalDelta]rF,\[CapitalDelta]rL}={r[[2]]-r[[1]],r[[-2]]-r[[-1]]};
{mag\[CapitalDelta]rF,mag\[CapitalDelta]rL}={Sqrt[\[CapitalDelta]rF.\[CapitalDelta]rF],Sqrt[\[CapitalDelta]rL.\[CapitalDelta]rL]};
ArcCos[\[CapitalDelta]rF.\[CapitalDelta]rL/(mag\[CapitalDelta]rF mag\[CapitalDelta]rL)],
0]]


f[{x_,y_},{{x1_,y1_},{x2_,y2_}}]:=Module[{},Which[x2==x1,x-x1,y2==y1,y-y1,True,y-(y2-y1)/(x2-x1)x-(x2 y1-x1 y2)/(x2-x1)]]


IntersectionQ[{p_,q_},{{x1_,y1_},{x2_,y2_}}]:=Module[{pqOnEdge=False,yRange,fLeftTestPoint,fpq,tval},
yRange=y1<=q<=y2||y1>=q>=y2;
pqOnEdge=If[f[{p,q},{{x1,y1},{x2,y2}}]==0&&(x1<=p<=x2||x2<=p<=x1),True,False];
tval=If[yRange&&pqOnEdge==False&&y1!=y2,
fLeftTestPoint=f[{Min[x1,x2],q},{{x1,y1},{x2,y2}}];
fpq=f[{p,q},{{x1,y1},{x2,y2}}];
If[fLeftTestPoint fpq>0||fLeftTestPoint fpq==0&&p<x1,True,False],False];
Return[{pqOnEdge,tval}];
     ]


SpecialCases[{p_,q_},vertexList_]:=Module[{edges,horizontalEdges,contractedVertexList,contractedEdgeList,possibleSpecialCases,intersectingDoublets,specialCases},
edges=Partition[vertexList,2,1,1];
horizontalEdges=Cases[edges,{{x_,y_},{z_,y_}}][[All,2]];
contractedVertexList=Delete[vertexList,Flatten[(Position[vertexList,#]&)/@horizontalEdges,1]];
contractedEdgeList=Partition[contractedVertexList,3,1,2];
intersectingDoublets=Select[contractedEdgeList,(p<#[[2,1]]&)];
possibleSpecialCases=Select[intersectingDoublets,(#[[2,2]]==q&)];
specialCases=Select[possibleSpecialCases,(#[[1,2]]<#[[2,2]]<#[[3,2]]||#[[1,2]]>#[[2,2]]>#[[3,2]])&];
Return[Length@specialCases]
]


PolygonInteriorQ[{p_?NumericQ,q_?NumericQ},vertexList_/;Length@vertexList>2&&Length@Union@vertexList==Length@vertexList&&MatrixQ[vertexList,NumericQ]]:=Module[{edgeList,intersectionList,intersectionCount,specialCaseCount,truthValue},
edgeList=Partition[vertexList,2,1,1];
intersectionList=(IntersectionQ[{p,q},{{#1[[1,1]],#1[[1,2]]},{#1[[2,1]],#1[[2,2]]}}]&)/@edgeList;
truthValue=If[FreeQ[intersectionList[[All,1]],True],
intersectionCount=Count[intersectionList[[All,2]],True];
specialCaseCount=SpecialCases[{p,q},vertexList];
If[OddQ[intersectionCount-specialCaseCount],True,False],False];
Return[truthValue];
]


AirfoilInteriorQ[{x_,z_},r_CartesianVectors?TwoDimQ]:=PolygonInteriorQ[{x,z},If[First[r]==Last[r],
Transpose[Components[Most[r]]],
Transpose[Components[r]]]]


End[];


Protect[AirfoilFromDataFile,AirfoilGeometry,AirfoilInteriorQ,FitAirfoil,PanelAngles,PanelNormals,PanelPoints,AirfoilSurfacePoints,ConstantSpacing,CosineSpacing,HalfCosineSpacing,Layout,NACA4DigitAirfoil,NDiscretizeUnitSegment,PanelLengths,PanelOffset,ThickAirfoilQ,TrailingEdgeAngle,XToTheta];


EndPackage[]
