(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



BeginPackage["Aerodynamics`CartesianVectors`"];


CartesianVectors::usage="CartesianVectors is the name of a data type specifying a collection of n-dimensional vectors in a rectangular coordinate system.  CartesianVectors is also the name of the package defining the data type.";


ComplexToCartesianVectors::usage="ComplexToCartesianVectors[c] converts a list of complex numbers to a collection of two-dimensional vectors of the data type CartesianVectors.";


Components::usage="Components[v] selects the lists of components from a collection of vectors of the data type CartesianVectors.";


ExtendXyToXyz::usage="ExtendXyToXyz[v] extends a collection of two-dimensional vectors to three-dimensions by padding the z component with zeros.";


ExtendXzToXyz::usage="ExtendXzToXyz[v] extends a collection of two-dimensional vectors to three-dimensions by padding the y component with zeros.";


MakeCartesianVectors::usage="MakeCartesianVectors[{u1, u2, u3, ... }] constructs the data type CartesianVectors for a collection of n-dimensional vectors.  The structure of each list of components, ui, is either a simple list or a matrix. All lists in the input arguments must have the same dimensions.";


MirrorXAxis::usage="MirrorXAxis[r] reflects a collection of 2-D vectors through the x axis.";


MultiplyByList::usage="MultiplyByList[a, u] multiplies a collection of vectors u by the list a.";


NumberOfVectors::usage="NumberOfVectors[v] counts the number of vectors in a collection of vectors.";


ReplicateVector::usage="ReplicateVector[{x1,x2,x3,...,xn},m] returns a collection of vectors consisting of m copies of a single vector represented by a simple list.
ReplicateVector[v, m] returns a collection of vectors consisting of m copies of the collection of vectors v, whose components are simple lists.";


ThreeDimQ::usage="ThreeDimQ[v] returns True if v is a collection of three-dimensional vectors of the data type CartesianVectors, False if not.";


TwoDimQ::usage="TwoDimQ[v] returns True if v is a collection of two-dimensional vectors of the data type CartesianVectors, False if not.";


MakeCartesianVectors::form="Form of input is incorrect.  Enclose lists of components with {} to make one argument that is a list.";


MakeCartesianVectors::dimensions="The dimensions of the lists of components must be equal.";


MakeCartesianVectors::single="Mathematica notation may be used for a single vector.  For data type CartesianVectors, each component must be a list."


Begin["Aerodynamics`CartesianVectors`Private`"];


Unprotect[CartesianVectors,ComplexToCartesianVectors,Components,ExtendXyToXyz,ExtendXzToXyz,MakeCartesianVectors,MirrorXAxis,MultiplyByList,NumberOfVectors,ReplicateVector,ThreeDimQ,TwoDimQ];


SetAttributes[{CartesianVectors,ComplexToCartesianVectors,Components,ExtendXyToXyz,ExtendXzToXyz,MakeCartesianVectors,MirrorXAxis,MultiplyByList,NumberOfVectors,ReplicateVector},NumericFunction]


SetAttributes[{ExtendXzToXyz,ExtendXyToXyz},Listable]


MakeCartesianVectors[{vx_List,vy__List}]/;
Equal@@Dimensions/@{vx,vy}:=CartesianVectors@@{vx,vy}


MakeCartesianVectors[vx_List,vy__List]:=Message[MakeCartesianVectors::form,"MakeCartesianVectors"]


MakeCartesianVectors[{vx_List,vy__List}]:=Message[MakeCartesianVectors::dimensions,"MakeCartesianVectors"]


MakeCartesianVectors[v_?VectorQ]:=Message[MakeCartesianVectors::single,"MakeCartesianVectors"]


Components[CartesianVectors[vx_,vy__]]:=List@@CartesianVectors[vx,vy]


MultiplyByList[a_List,v_CartesianVectors]/;Length[a]===Length[v]:=MakeCartesianVectors[a*Components[v]]


MultiplyByList[a_List,v_CartesianVectors]/;Apply[Times,Dimensions[a]]==NumberOfVectors[v]:=MakeCartesianVectors[Map[a #&,Components[v]]]


MultiplyByList[v_CartesianVectors,a_List]:=MultiplyByList[a,v]


NumberOfVectors[v_CartesianVectors]:=Apply[Times,Drop[Dimensions[v],1]]


ReplicateVector[{x_,y__},n_Integer]:=MakeCartesianVectors[Map[Table[#,{n}]&,{x,y}]]


ReplicateVector[r_CartesianVectors,n_Integer]/;NumberOfVectors[r]==1:=MakeCartesianVectors[Transpose[Table[Flatten[Components[r]],{n}]]]


ReplicateVector[r_CartesianVectors,n_Integer]:=MakeCartesianVectors[Thread[Table[Components[r],{n}]]]


ThreeDimQ[v_CartesianVectors]:=Length[v]==3


ComplexToCartesianVectors[c_List]:=MakeCartesianVectors[{Re[c],Im[c]}]


ExtendXyToXyz[v_CartesianVectors?TwoDimQ]:=Module[{vz},
{vx,vy}=Components[v];
vz=0 vx;
MakeCartesianVectors[{vx,vy,vz}]]


ExtendXzToXyz[v_CartesianVectors?TwoDimQ]:=Module[{vy},
{vx,vz}=Components[v];
vy=0 vx;
MakeCartesianVectors[{vx,vy,vz}]]


MirrorXAxis[v_CartesianVectors?TwoDimQ]:=Module[{vx,vy},{vx,vy}=Components[v];MakeCartesianVectors[{Reverse[vx],-Reverse[vy]}]]


TwoDimQ[v_CartesianVectors]:=Length[v]==2


CartesianVectors /: u_CartesianVectors+v_CartesianVectors:=MakeCartesianVectors[(Components[u]+Components[v])]


CartesianVectors /: -v_CartesianVectors:=MakeCartesianVectors[(-Components[v])]


CartesianVectors /: a_*v_CartesianVectors/;Head[a]=!=CartesianVectors:=MakeCartesianVectors[(a*Components[v])]


CartesianVectors/:Append[u_CartesianVectors,elem_List]/;Dimensions[u][[1]]==Length[elem]:=MakeCartesianVectors[MapThread[Append,{Components[u],elem}]]


CartesianVectors/:Arrow[rT_CartesianVectors,rH_CartesianVectors]:=Arrow/@Transpose[{Transpose[Components[rT]],Transpose[Components[rH]]}]


CartesianVectors/:Cross[u_CartesianVectors,v___CartesianVectors]/;Length[Dimensions[u]]===2:=MakeCartesianVectors[Transpose[MapThread[Cross,Transpose/@Components/@{u,v}]]]


CartesianVectors/:Cross[u_CartesianVectors,v__CartesianVectors]/;Length[Dimensions[u]]===3:=
Module[{n},n=Last[Dimensions[u]];
MakeCartesianVectors[Map[Partition[#,n]&,Transpose[MapThread[Cross,Transpose/@{Flatten/@Components[u],Flatten/@Components[v]}]]]]]


CartesianVectors/:Cross[u_CartesianVectors?TwoDimQ]/;Length[Dimensions[u]]===3:=
Module[{n},n=Last[Dimensions[u]];MakeCartesianVectors[Map[Partition[#,n]&,Transpose[Cross/@Transpose[Flatten/@Components[u]]]]]]


CartesianVectors /: Dimensions[v_CartesianVectors]:=Dimensions[Components[v]]


CartesianVectors/:Dot[u_CartesianVectors,v_CartesianVectors]:=Plus@@@Transpose[Components[u]*Components[v]]


CartesianVectors/:Dot[v_CartesianVectors,a_List]/;Length[Dimensions[v]]===2:=Thread[Dot[Components[v],a]]


CartesianVectors/:Dot[v_CartesianVectors,a_List]/;Length[Dimensions[v]]===3:=MakeCartesianVectors[Transpose[Thread[Dot[Components[v],a]]]]


CartesianVectors/:Dot[a_List,v_CartesianVectors]:=Dot[v,a]


CartesianVectors/:Drop[v_CartesianVectors,n_Integer]:=MakeCartesianVectors[Map[Drop[#,n]&,Components[v]]]


CartesianVectors/:Drop[v_CartesianVectors,{n__Integer}]:=MakeCartesianVectors[Map[Drop[#,{n}]&,Components[v]]]


CartesianVectors/:First[v_CartesianVectors]/;Length[Dimensions[v]]===2:=First/@Components[v]


CartesianVectors/:First[v_CartesianVectors]/;Length[Dimensions[v]]===3:=CartesianVectors@@First/@Components[v]


CartesianVectors/:Flatten[v_CartesianVectors]:=MakeCartesianVectors[Map[Flatten,Components[v]]]


CartesianVectors/:Insert[u_CartesianVectors,elem_List,pos_Integer]/;Dimensions[u][[1]]==Length[elem]:=MakeCartesianVectors[Thread[f[Components[u],elem,pos]]/.f->Insert]


CartesianVectors/:Join[u_CartesianVectors,v_CartesianVectors]:=MakeCartesianVectors[MapThread[Join,{Components[u],Components[v]}]]


CartesianVectors/:Last[v_CartesianVectors]/;Length[Dimensions[v]]===2:=Last/@Components[v]


CartesianVectors/:Last[v_CartesianVectors]/;Length[Dimensions[v]]===3:=MakeCartesianVectors[Last/@Components[v]]


CartesianVectors/:Length[v_CartesianVectors]:=Length[Components[v]]


CartesianVectors/:ListPlot[r_CartesianVectors,opts___?OptionQ]:=ListPlot[Transpose[Components[r]],opts]


CartesianVectors/:ListVectorPlot[r_CartesianVectors,v_CartesianVectors,opts___?OptionQ]:=ListVectorPlot[Transpose[{Transpose[Components[r]],Transpose[Components[v]]}],opts]


CartesianVectors/:MatrixForm[v_CartesianVectors]:=CartesianVectors@@Map[MatrixForm,Components[v]]


CartesianVectors/:Most[v_CartesianVectors]:=MakeCartesianVectors[Most/@Components[v]]


CartesianVectors/:Normalize[v_CartesianVectors]/;Length[Dimensions[v]]===2:=MakeCartesianVectors[Transpose[Normalize/@Transpose[Components[v]]]]


CartesianVectors /:Outer[f_,u_CartesianVectors,v_CartesianVectors]:=MakeCartesianVectors[Table[Outer[f,Components[u][[i]],Components[v][[i]]],{i,1,Length[u]}]]


CartesianVectors/:Part[v_CartesianVectors,i_Integer]/;Length[Dimensions[v]]===2:=
Map[Part[#,i]&,Components[v]]


CartesianVectors/:Part[v_CartesianVectors,i_Integer]/;Length[Dimensions[v]]===3:=
MakeCartesianVectors[Map[Part[#,i]&,Components[v]]]


CartesianVectors/:Part[v_CartesianVectors,i_Integer,j_Integer]:=
v[[i]][[j]]


CartesianVectors/:Part[v_CartesianVectors,{i__Integer}]:=MakeCartesianVectors[List@@Map[Part[#,{i}]&,Components[v]]]


CartesianVectors/:Prepend[u_CartesianVectors,elem_List]/;Dimensions[u][[1]]==Length[elem]:=MakeCartesianVectors[List@@MapThread[Prepend,{Components[u],elem}]]


CartesianVectors/:ReplacePart[u_CartesianVectors,n_Integer->elem_?VectorQ]:=MakeCartesianVectors[MapThread[ReplacePart,{Components[u],Thread[n->elem]}]]


CartesianVectors/:ReplacePart[u_CartesianVectors,{rule__Rule}]:=Fold[ReplacePart,u,{rule}]


CartesianVectors/:Rest[v_CartesianVectors]:=MakeCartesianVectors[List@@Rest/@Components[v]]


CartesianVectors/:Reverse[v_CartesianVectors]:=MakeCartesianVectors[Map[Reverse,Components[v]]]


CartesianVectors/:RotateLeft[v_CartesianVectors]:=MakeCartesianVectors[RotateLeft/@Components[v]]


CartesianVectors/:RotateLeft[v_CartesianVectors,n_Integer]:=MakeCartesianVectors[Map[RotateLeft[#,n]&,Components[v]]]


CartesianVectors/:RotateLeft[v_CartesianVectors,{n__Integer}]:=MakeCartesianVectors[Map[RotateLeft[#,{n}]&,Components[v]]]


CartesianVectors/:RotateRight[v_CartesianVectors]:=MakeCartesianVectors[RotateRight/@Components[v]]


CartesianVectors/:RotateRight[v_CartesianVectors,n_Integer]:=MakeCartesianVectors[Map[RotateRight[#,n]&,Components[v]]]


 CartesianVectors/:RotateRight[v_CartesianVectors,{n__Integer}]:=MakeCartesianVectors[Map[RotateRight[#,{n}]&,Components[v]]]


CartesianVectors/:Scale[v_CartesianVectors,{sx_,sy__}]:=
Module[{p,ts},
p=Transpose[Components[v]];
ts=ScalingTransform[{sx,sy}];
MakeCartesianVectors[Transpose[ts[p]]]]


CartesianVectors/:Simplify[v_CartesianVectors]:=MakeCartesianVectors[Map[Simplify,Components[v]]]


CartesianVectors/:Take[v_CartesianVectors,i__Integer]:=MakeCartesianVectors[Map[Take[#,i]&,Components[v]]]


CartesianVectors/:Take[v_CartesianVectors,{i__Integer}]:=MakeCartesianVectors[Map[Take[#,{i}]&,Components[v]]]


CartesianVectors/:Translate[v_CartesianVectors?TwoDimQ,{x_,y__}]:=
Module[{p,tt},
p=Transpose[Components[v]];
tt=TranslationTransform[{x,y}];
MakeCartesianVectors[Transpose[tt[p]]]]


CartesianVectors/:Transpose[v_CartesianVectors]:=MakeCartesianVectors[Transpose/@Components[v]]


CartesianVectors/:ArcTan[r_CartesianVectors?TwoDimQ]:=Module[{x,y},{x,y}=Components[r];ArcTan[x,y]]


CartesianVectors/:Rotate[v_CartesianVectors?TwoDimQ,\[Theta]_]:=
Module[{p,tr},
p=Transpose[Components[v]];
tr=RotationTransform[\[Theta]];
CartesianVectors@@Transpose[tr[p]]]


CartesianVectors/:Rotate[v_CartesianVectors?TwoDimQ,\[Theta]_,{x_,z_}]:=
Translate[Rotate[Translate[v,{-x,-z}],\[Theta]],{x,z}]


CartesianVectors/:Rotate[v_CartesianVectors?TwoDimQ,\[Theta]_List]:=Module[{cn,sn,vx,vz},
{cn,sn}={Cos[\[Theta]],Sin[\[Theta]]};
{vx,vz}=Components[v];
CartesianVectors@@{cn*vx-sn*vz,+sn*vx+cn*vz}]


CartesianVectors/:Scale[v_CartesianVectors?TwoDimQ,s_]:=Scale[v,{s,s}]


Format[v_CartesianVectors]=Infix[v,"\[UpArrow]"];


End[];


Protect[CartesianVectors,ComplexToCartesianVectors,Components,ExtendXyToXyz,ExtendXzToXyz,MakeCartesianVectors,MirrorXAxis,MultiplyByList,NumberOfVectors,ReplicateVector,ThreeDimQ,TwoDimQ];


EndPackage[]
