(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



BeginPackage["Aerodynamics`Graphics`",{"Aerodynamics`CartesianVectors`"}];


Graphics::usage="Graphics is a package providing functions for plots where conventions typicall used in the aerodynamics community differ from those used in Mathematica.  Also included are utility graphics used in the Aerodynamics software.";


PlotAirfoil::usage="PlotAirfoil[rp] plots the airfoil defined by the collection of vectors rp.";


PlotConvergence::usage="PlotConvergence[np,c] plots a graph showing convergence properties for an aerodynamic coefficient.  The list of numbers of panel describing the discretized airfoil is denoted by np and the list of coefficients is denoted by c.  The coefficient is plotted versus the reciprocal of the number of panels, and a straight line is fit to the resulting points.  A reference value for the coefficient is determined by extrapolating the straight line to zero, and the function returns a list of the reference coefficient and the graphic.
PlotConvergence[np, c, m] plots a graph showing the convergence properties of an aerodynamic coefficient c.  Only the subset of data consisting of the m largest numbers of panels is used to determine the straight-line fit.";


PlotSurfacePressureCoefficient::usage="PlotSurfacePressureCoefficient[xc,cp] plots surface pressure coefficients at collocation points versus the x-components of vectors locating collocation points.
PlotSurfacePressureCoefficient[xc,cp,rp] plots surface pressure coefficients together with a plot of the discretized airfol specified by panel endpoints, rp.";


Begin["Aerodynamics`Graphics`Private`"];


Unprotect[PlotAirfoil,PlotConvergence,PlotSurfacePressureCoefficient];


Options[PlotConvergence]={Axes->None,Frame->True,FrameLabel->{"reciprocal of number of panels","C"},ImageSize->7 72,PlotRange->All,RotateLabel->False};


Options[PlotAirfoil]={AspectRatio->Automatic,Axes->False,Frame->True,FrameLabel->{"x","z"},FrameTicks->{Chop[Range[-1.2,1.6,0.2]],Chop[Range[-1.0,1.0,0.1]],None,Chop[Range[-1.0,1.0,0.1]]},ImageSize->{7. 72, 2.5 72},Joined->True,PlotRange->{{-0.05,1.05},{-0.1,0.201}},RotateLabel->False};


Options[PlotSurfacePressureCoefficient]={Frame->True,FrameLabel->{"x","\!\(\*SubscriptBox[\(C\), \(p\)]\)"},ImageSize->7 72,RotateLabel->False};


PlotAirfoil[r_CartesianVectors?TwoDimQ,opts___?OptionQ]:=Module[{aspectRatio,axes,frame,frameLabel,frameTicks,imageSize,joined,optionsPlotAirfoil,plotRange,rotateLabel},{aspectRatio,axes,frame,frameLabel,frameTicks,imageSize,joined,plotRange,rotateLabel}={AspectRatio,Axes,Frame,FrameLabel,FrameTicks,ImageSize,Joined,PlotRange,RotateLabel}/. Flatten[{opts}]/. Options[PlotAirfoil];optionsPlotAirfoil={AspectRatio->aspectRatio,Axes->axes,Frame->frame,FrameLabel->frameLabel,FrameTicks->frameTicks,ImageSize->imageSize,Joined->joined,PlotRange->plotRange,RotateLabel->rotateLabel};ListPlot[Transpose[Components[r]],optionsPlotAirfoil\[Union]{Sequence@@FilterRules[Flatten[{opts}],Options[ListPlot]]}]]


Options[PlotConvergence]={Axes->None,Frame->True,FrameLabel->{"reciprocal of number of panels","C"},ImageSize->7 72,PlotRange->All,RotateLabel->False};


PlotConvergence[n_List,c_List,opts:OptionsPattern[]]:=Module[{c0,data,fit,gC,gData,gEMinus,gFit,nIR},
(* I\[RightArrow]Inverse,  R\[RightArrow]Reverse *)
nIR=Reverse[1./n];
data=Transpose[{nIR,Reverse[c]}];
fit=LinearModelFit[data,{1,x},x];
c0=fit[0];
gData=ListPlot[data,PlotStyle->{Blue,AbsolutePointSize[5]}];
gFit=Plot[fit[x],{x,First[nIR],Last[nIR]}];
gEMinus=Plot[fit[x],{x,0,First[nIR]},PlotStyle->{Dashing[{0.01,0.01}]}];
gC=Show[gData,gFit,gEMinus,
Join[FilterRules[{opts},{Options[Graphics]}],Options[PlotConvergence]]];
{c0,gC}]


PlotConvergence[n_List,c_List,m_Integer,opts:OptionsPattern[]]:=Module[{axes,cRC,cRF,cR,c0,c1,dataC,dataF,fit,frame,frameLabel,gC,gData,gDataF,gEMinus,gEPlus,gFit,imageSize,nIR,nIRC,nIRF,nL,optionsPlotConvergence,plotRange,rotateLabel},
{axes,frame,frameLabel,imageSize,plotRange,rotateLabel}={Axes,Frame,FrameLabel,ImageSize,PlotRange,RotateLabel}/.Flatten[{opts}]/. Options[PlotConvergence];
optionsPlotConvergence={Axes->axes,Frame->frame,FrameLabel->frameLabel,ImageSize->imageSize,PlotRange->plotRange,RotateLabel->rotateLabel};
(* I\[RightArrow]Inverse, L\[RightArrow]Length, R\[RightArrow]Reverse *)
{nIR,cR,nL}={Reverse[1/n],Reverse[c],Length[n]};
(* C\[RightArrow]Coarse, F\[RightArrow]Fine *)
{nIRF,nIRC}=N[{Take[nIR,m],Take[nIR,m-nL]}];
{cRF,cRC}={Take[cR,m],Take[cR,m-nL]};
{dataC,dataF}={Transpose[{nIRC,cRC}],Transpose[{nIRF,cRF}]};
fit=LinearModelFit[dataF,{1,x},x];
{c0,c1}={fit[0],fit[Last[nIR]]};
gData=ListPlot[dataC,PlotStyle->{Red,AbsolutePointSize[5]}];
gDataF=ListPlot[dataF,PlotStyle->{Blue,AbsolutePointSize[5]}];
gFit=Plot[fit[x],{x,First[nIRF],Last[nIRF]}];
gEMinus=Plot[fit[x],{x,0,First[nIRF]},PlotStyle->{Dashing[{0.01,0.01}]}];
gEPlus=Plot[fit[x],{x,Last[nIRF],Last[nIRC]},PlotStyle->{Dashing[{0.01,0.01}]}];
gC=Show[gDataF,gData,gFit,gEMinus,gEPlus,
Join[FilterRules[{opts},{Options[Graphics]}],Options[PlotConvergence]]];
{c0,gC}]


PlotSurfacePressureCoefficient[x_?VectorQ,cp_?VectorQ,opts:OptionsPattern[]]:=Module[{cpMax,frame,frameLabel,frameTicks,imageSize,options,options1,plotRange,rotateLabel},
{frame,frameLabel,imageSize,rotateLabel}={Frame,FrameLabel,ImageSize,RotateLabel}/.Flatten[{opts}]/.Options[PlotSurfacePressureCoefficient];
cpMax=Ceiling[-Min[cp]];
plotRange={{-0.05,1.05},{-1.2,cpMax}};
frameTicks={Automatic,Transpose[{Range[-1,cpMax,1],ToString/@(-Range[-1,cpMax,1])}],None,None};
options1={Frame->frame,FrameLabel->frameLabel,FrameTicks->frameTicks,ImageSize->imageSize,PlotRange->plotRange,RotateLabel->rotateLabel};
options=options1\[Union]FilterRules[{opts},Options[ListPlot]];
ListPlot[Transpose[{x,-cp}],Sequence@@options]]


End[];


Protect[PlotAirfoil,PlotConvergence,PlotSurfacePressureCoefficient];


EndPackage[]
