(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



BeginPackage["Aerodynamics`InfluenceCoefficients`",{"Aerodynamics`CartesianVectors`"}];


InfluenceCoefficients::usage="InfluenceCoefficients is a package  containing functions to compute geometric influence coefficients for two-dimensional potential-flow point and line singularities.  Functions for velocity, velocity-potential and stream-function influence coefficients are defined for commonly used distributions of source, doublet and vortex singularities.";


UniformFlow::usage="UniformFlow[n, alpha] computes a collection of n uniform velocity vectors inclined at an angle alpha to the x axis.";


UniformFlowPhi::usage="UniformFlowPhi[rf, alpha] computes a list of velocity-potentials at rf for uniform flow inclined at an angle alpha to the x axis. ";


UniformFlowPsi::usage="UniformFlowPsi[rf, alpha] computes a list of stream-functions at rf for uniform flow inclined at an angle alpha to the x axis. ";


DisplacementVectors::usage="DisplacementVectors[ra, rb] computes the displacement vectors between all pairs of points for the two collections of vectors, ra and rb.";


ICVortexPoint::usage = "ICVortexPoint[rf, rp] computes velocity influence coefficients at field points rf, due to vortices at rp.";


ICPhiVortexPoint::usage="ICPhiVortexPoint[rf, rp] computes velocity-potential influence coefficients at field points rf, due to vortices at rp.";


ICPsiVortexPoint::usage="ICPsiVortexPoint[rf, rp] computes stream-function influence coefficients at field points rf, due to vortices at rp.";


ICVortexConstant::usage="ICVortexConstant[rf, rp] computes velocity influence coefficients at field points rf, due to connected vortex panels of constant strength whose endpoints are located by rp.";


ICPhiVortexConstant::usage="ICPhiVortexConstant[rf, rp] computes velocity-potential influence coefficients at field points rf due to connected vortex panels of constant strength whose endpoints are located by rp.";


ICPsiVortexConstant::usage="ICPsiVortexConstant[rf, rp] computes stream-function influence coefficients at field points rf due to connected vortex panels of constant strength whose endpoints are located by rp.";


ICVortexLinear::usage="ICVortexLinear[rf, rp] computes velocity influence coefficients at field points rf, due to connected vortex panels of linearly varying strength whose endpoints are located by rp.";


ICPhiVortexLinear::usage="ICPhiVortexLinear[rf, rp] computes velocity-potential influence coefficients at field points rf due to connected vortex panels of linear varying strength whose endpoints are located by rp.";


ICPsiVortexLinear::usage="ICPsiVortexLinear[rf, rp] computes stream-function influence coefficients at field points rf due to connected vortex panels of linear varying strength whose endpoints are located by rp.";


ICSourcePoint::usage="ICSourcePoint[rf, rp] computes velocity influence coefficients at field points rf, due to point sources at rp.";


ICPhiSourcePoint::usage="ICPhiSourcePoint[rf, rp] computes velocity-potential influence coefficients at field points rf, due to point sources at rp.";


ICPsiSourcePoint::usage="ICPsiSourcePoint[rf, rp] computes stream-function influence coefficients at field points rf, due to point sources at rp.";


ICSourceConstant::usage="ICSourceConstant[rf, rp] computes velocity influence coefficients at field points rf, due to connected source panels of constant strength whose endpoints are located by rp.";


ICPhiSourceConstant::usage="ICPhiSourceConstant[rf, rp] computes velocity-potential influence coefficients at field points rf due to connected source panels of constant strength whose endpoints are located by rp.";


ICPsiSourceConstant::usage="ICPsiSourceConstant[rf, rp] computes stream-function influence coefficients at field points rf due to connected source panels of constant strength whose endpoints are located by rp.";


ICSourceLinear::usage="ICSourceLinear[rf, rp] computes velocity influence coefficients at field points rf, due to connected source panels of linearly varying strength whose endpoints are located by rp.";


ICPhiSourceLinear::usage="ICPhiSourceLinear[rf, rp] computes velocity-potential influence coefficients at field points rf, due to connected source panels of linearly varying strength whose endpoints are located by rp.";


ICPsiSourceLinear::usage="ICPsiSourceLinear[rf, rp] computes stream-function influence coefficients at field points rf, due to connected source panels of linearly varying strength whose endpoints are located by rp.";


ICDoubletPoint::usage="ICDoubletPoint[rf, rp, uD] computes velocity nfluence coefficients at field points rf, due to doublets at rp. Orientation of doublets is specified by unit vectors uD.";


ICPhiDoubletPoint::usage="ICPhiDoubletPoint[rf, rp, uD] computes elocity-potential influence coefficients at field points rf, due to doublets at rp.  Orientation of doublets is specified by unit vectors uD.";


ICPsiDoubletPoint::usage="ICPsiDoubletPoint[rf, rp, ud] computes stream-function influence coefficients at field points rf, due to doublets at rp.  Orientation of doublets is specified by unit vectors ud.";


ICDoubletConstant::usage="ICDoubletConstant[rf, rp] computes velocity influence coefficients at field points rf due to connected doublet panels of constant strength whose endpoints are located by rp.";


ICPhiDoubletConstant::usage="ICPhiDoubletConstant[rf, rp] computes velocity-potential influence coefficients at field points rf, due to connected doublet panels of constant strength whose endpoints are located by rp.";


ICPsiDoubletConstant::usage="ICPsiDoubletConstant[rf, rp] computes stream-function influence coefficients at field points rf, due to connected doublet panels of constant strength whose endpoints are located by rp.";


ICDoubletLinear::usage="ICDoubletLinear[rf, rp] computes velocity influence coefficients at field points rf due to connected doublet panels of linearly varying strength whose end points are located by rp.";


ICPhiDoubletLinear::usage="ICPhiDoubletLinear[rf, rp] computes velocity-potential influence coefficients at field points rf due to connected doublet panels of linearly varying strength whose end points are located by rp.";


ICPsiDoubletLinear::usage="ICPsiDoubletLinear[rf, rp] computes stream-function influence coefficients at field points rf due to connected doublet panels of linearly varying strength whose end points are located by rp.";


ICDoubletQuadratic::usage="ICDoubletQuadratic[rf, rp] computes velocity influence coefficients at field points rf, due to connected doublet panels of quadratically varying strength whose endpoints are located by rp.";


ICPhiDoubletQuadratic::usage="ICPhiDoubletQuadratic[rf, rp] computes velocity-potential influence coefficients at field points rf due to connected doublet panels of quadratically varying strength whose endpoints are located by rp.";


ICPsiDoubletQuadratic::usage="ICPsiDoubletQuadratic[rf, rp] computes stream-function influence coefficients at field points rf due to connected doublet panels of quadratically varying strength whose endpoints are located by rp.";


TestArguments::usage="TestArguments[rf,rp] tests arguments for an influence-coefficient function, returning True if arguments are valid and a message if they are not.";


InfluenceCoefficients::dataType="Input arguments specifying locations of field points and singularities must be collections of two-dimensional vectors of the data type CartesianVectors.";


InfluenceCoefficients::lineSingularity="Input arguments specifying locations of line singularities must contain coordinates for at least two points.";


Begin["Aerodynamics`InfluenceCoefficients`Private`"];


Unprotect[DisplacementVectors,ICDoubletConstant,ICDoubletLinear,ICDoubletPoint,ICDoubletQuadratic,ICSourceConstant,ICSourceLinear,ICSourcePoint,ICVortexConstant,ICVortexLinear,ICVortexPoint,ICPhiDoubletConstant,ICPhiDoubletLinear,ICPhiDoubletQuadratic,ICPhiDoubletPoint,ICPhiSourceConstant,ICPhiSourceLinear,ICPhiSourcePoint,ICPhiVortexConstant,ICPhiVortexLinear,ICPhiVortexPoint,ICPsiDoubletConstant,ICPsiDoubletLinear,ICPsiDoubletQuadratic,ICPsiDoubletPoint,ICPsiSourceConstant,ICPsiSourceLinear,ICPsiSourcePoint,ICPsiVortexConstant,ICPsiVortexLinear,ICPsiVortexPoint,InfluenceCoefficients,TestArguments,UniformFlow,UniformFlowPhi,UniformFlowPsi];


SetAttributes[{DisplacementVectors,ICDoubletConstant,ICDoubletLinear,ICDoubletQuadratic,ICDoubletPoint,ICSourceConstant,ICSourceLinear,ICSourcePoint,ICVortexConstant,ICVortexLinear,ICVortexPoint,ICPhiDoubletConstant,ICPhiDoubletLinear,ICPhiDoubletQuadratic,ICPhiDoubletPoint,ICPhiSourceConstant,ICPhiSourceLinear,ICPhiSourcePoint,ICPhiVortexConstant,ICPhiVortexLinear,ICPhiVortexPoint,ICPsiDoubletConstant,ICPsiDoubletLinear,ICPsiDoubletQuadratic,ICPsiDoubletPoint,ICPsiSourceConstant,ICPsiSourceLinear,ICPsiSourcePoint,ICPsiVortexConstant,ICPsiVortexLinear,ICPsiVortexPoint,UniformFlow,UniformFlowPhi,UniformFlowPsi},NumericFunction]


displacementList=Compile[{{u,_Real,2},{v,_Real,2}},{Outer[Plus,u[[1]],-v[[1]]],Outer[Plus,u[[2]],-v[[2]]]}];


UniformFlow[1,\[Alpha]_]:={Cos[\[Alpha]],Sin[\[Alpha]]}


UniformFlowPhi[{xf:Except[_List],zf:Except[_List]},\[Alpha]_]:=xf Cos[\[Alpha]]+zf Sin[\[Alpha]]


UniformFlowPsi[{xf:Except[_List],zf:Except[_List]},\[Alpha]_]:=zf Cos[\[Alpha]]-xf Sin[\[Alpha]]


UniformFlow[n_Integer?Positive,\[Alpha]_]:=MakeCartesianVectors[{Table[Cos[\[Alpha]],{n}],Table[Sin[\[Alpha]],{n}]}]


UniformFlowPhi[rf_CartesianVectors?TwoDimQ,\[Alpha]_]:=Module[{x,z},{x,z}=Components[rf];x Cos[\[Alpha]]+z Sin[\[Alpha]]]


UniformFlowPsi[rf_CartesianVectors?TwoDimQ,\[Alpha]_]:=Module[{x,z},{x,z}=Components[rf];z Cos[\[Alpha]]-x Sin[\[Alpha]]]


DisplacementVectors[ra_CartesianVectors?TwoDimQ /; MatrixQ[Components[ra],MachineNumberQ],rb_CartesianVectors?TwoDimQ /; MatrixQ[Components[rb],MachineNumberQ]]:=MakeCartesianVectors[displacementList[Components[ra],Components[rb]]]


DisplacementVectors[ra_CartesianVectors?TwoDimQ,rb_CartesianVectors?TwoDimQ]:=Outer[Plus,ra,-rb]


ICVortexPoint[{xf:Except[_List],zf:Except[_List]},{xs:Except[_List],zs:Except[_List]}]:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},{{xs},{zs}}};
Flatten[Components[ICVortexPoint[rf,rs]]]]


ICPhiVortexPoint[{xf:Except[_List],zf:Except[_List]},{xs:Except[_List],zs:Except[_List]}]:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},{{xs},{zs}}};
ICPhiVortexPoint[rf,rs][[1,1]]]


ICPsiVortexPoint[{xf:Except[_List],zf:Except[_List]},{xs:Except[_List],zs:Except[_List]}]:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},{{xs},{zs}}};
ICPsiVortexPoint[rf,rs][[1,1]]]


ICVortexPoint[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
Flatten[ICVortexPoint[rf,rs]]]


ICPhiVortexPoint[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ic}=ICPhiVortexPoint[rf,rs];ic]


ICPsiVortexPoint[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ic}=ICPsiVortexPoint[rf,rs];ic]


ICVortexPoint[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPhiVortexPoint[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPsiVortexPoint[p___]:=Null/;!TrueQ[TestArguments[p]]


ICVortexPoint[rf_,rs_]:=Module[{rfs,rSq,x,z},
rfs=DisplacementVectors[rf,rs];
{x,z}=Components[rfs];
rSq=rfs.rfs;
MakeCartesianVectors[{z/(2\[Pi] rSq),-(x/(2\[Pi] rSq))}]]


ICPhiVortexPoint[rf_,rs_]:=Module[{r},
r=DisplacementVectors[rf,rs];
-(1/(2\[Pi]))ArcTan[r]]


ICPsiVortexPoint[rf_,rs_]:=Module[{r},
r=DisplacementVectors[rf,rs];
1/(4\[Pi]) Log[r.r]]


ICVortexConstant[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
ic=ICVortexConstant[rf,rs];
If[NumberOfVectors[ic]>1,Flatten[ic],Flatten[Components[ic]]]]


ICPhiVortexConstant[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
ic=ICPhiVortexConstant[rf,rs];
If[Dimensions[ic][[2]]>1,Flatten[ic],ic[[1,1]]]]


ICPsiVortexConstant[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
ic=ICPsiVortexConstant[rf,rs];
If[Dimensions[ic][[2]]>1,Flatten[ic],ic[[1,1]]]]


ICVortexConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPhiVortexConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPsiVortexConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICVortexConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPhiVortexConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPsiVortexConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICVortexConstant[rf_,rs_]:=Module[{ic,rfs,r1,r2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];ic=MakeCartesianVectors[{1/(2\[Pi]) (ArcTan[r2]-ArcTan[r1]),1/(4\[Pi]) Log[r2.r2/r1.r1]}];
Transpose[Rotate[Transpose[ic],\[Theta]p]]]


ICPhiVortexConstant[rf_,rs_]:=Module[{rfs,r1,r2,x,x2,z,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{x,z}=Components[r1];
x2=Components[r2][[1]];
1/(2\[Pi]) (x2 ArcTan[r2]-x ArcTan[r1]+z/2 Log[r2.r2/r1.r1])]


ICPsiVortexConstant[rf_,rs_]:=Module[{rfs,r1,r2,x,x2,z,\[Delta],\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Delta]=Rest[rs-RotateRight[rs]];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{x,z}=Components[r1];
x2=Components[r2][[1]];
1/(2\[Pi]) (z(ArcTan[r2]-ArcTan[r1])-1/2 (x2 Log[r2.r2]-x Log[r1.r1]))]


ICVortexLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb}=ICVortexLinear[rf,rs];
Which[NumberOfVectors[rs]==2,
{Flatten[Components[ica]],Flatten[Components[icb]]},
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb]}]]


ICPhiVortexLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb}=ICPhiVortexLinear[rf,rs];
Which[NumberOfVectors[rs]==2,Flatten[{ica,icb}],
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb]}]]


ICPsiVortexLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb}=ICPsiVortexLinear[rf,rs];
Which[NumberOfVectors[rs]==2,Flatten[{ica,icb}],
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb]}]]


ICVortexLinear[{xf:Except[_List],zf:Except[_List]},{xs_List,zs_List}]/;Dimensions[xs]==Dimensions[zs]=={2}:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},Transpose[{xs,zs}]};
Partition[Flatten[Components/@ICVortexLinear[rf,rs]],2]]


ICPhiVortexLinear[{xf:Except[_List],zf:Except[_List]},{xs_List,zs_List}]/;Dimensions[xs]==Dimensions[zs]=={2}:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},Transpose[{xs,zs}]};
ICPhiVortexLinear[rf,rs]//Flatten]


ICPsiVortexLinear[{xf:Except[_List],zf:Except[_List]},{xs_List,zs_List}]/;Dimensions[xs]==Dimensions[zs]=={2}:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},Transpose[{xs,zs}]};
ICPsiVortexLinear[rf,rs]//Flatten]


ICVortexLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPhiVortexLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPsiVortexLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICVortexLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPhiVortexLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPsiVortexLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICVortexLinear[rf_,rs_]:=Module[{fAT,fLog,ica,icb,rfs,r1,r2,x,x2,z,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
fAT=ArcTan[r2]-ArcTan[r1];
fLog=Log[r2.r2/r1.r1];
{x,z}=Components[r1];
x2=Components[r2][[1]];
ica=MakeCartesianVectors[1/(2\[Pi]) {fAT,1/2 fLog}];
icb=MakeCartesianVectors[1/(2\[Pi]) {x fAT+1/2 z fLog,1/2 x fLog-z fAT+x-x2}];
{Transpose[Rotate[Transpose[ica],\[Theta]p]],Transpose[Rotate[Transpose[icb],\[Theta]p]]}]


ICPhiVortexLinear[rf_,rs_]:=Module[{c,d,fLog,rfs,r1,r2,x,x2,z,\[Theta]p,\[Theta]1,\[Theta]2},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
fLog=Log[r2.r2/r1.r1];
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
1/(2\[Pi]) {(x2 \[Theta]2-x \[Theta]1+1/2 z fLog),1/2 (d z+(c-d^2)\[Theta]2-c \[Theta]1+x z fLog)}]


ICPsiVortexLinear[rf_,rs_]:=Module[{c,d,fAT,rfs,r1,r1Sq,r2,r2Sq,x,x2,z,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
fAT=ArcTan[r2]-ArcTan[r1];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
1/(2\[Pi]) {(z fAT-1/2 (x2 Log[r2Sq]-x Log[r1Sq])),
- (x d/2-x z fAT+1/4 ((c-d^2)Log[r2Sq]-c Log[r1Sq]))}]


ICSourcePoint[{xf:Except[_List],zf:Except[_List]},{xs:Except[_List],zs:Except[_List]}]:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},{{xs},{zs}}};
Flatten[Components[ICSourcePoint[rf,rs]]]]


ICPhiSourcePoint[{xf:Except[_List],zf:Except[_List]},{xs:Except[_List],zs:Except[_List]}]:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},{{xs},{zs}}};
ICPhiSourcePoint[rf,rs][[1,1]]]


ICPsiSourcePoint[{xf:Except[_List],zf:Except[_List]},{xs:Except[_List],zs:Except[_List]}]:=Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},{{xs},{zs}}};
ICPsiSourcePoint[rf,rs][[1,1]]]


ICSourcePoint[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
Flatten[ICSourcePoint[rf,rs]]]


ICPhiSourcePoint[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ic}=ICPhiSourcePoint[rf,rs];ic]


ICPsiSourcePoint[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ic}=ICPsiSourcePoint[rf,rs];ic]


ICSourcePoint[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPhiSourcePoint[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPsiSourcePoint[p___]:=Null/;!TrueQ[TestArguments[p]]


ICSourcePoint[rf_,rs_]:=Module[{rfs,rSq,x,z},
rfs=DisplacementVectors[rf,rs];
{x,z}=Components[rfs];
rSq=rfs.rfs;
MakeCartesianVectors[{x/(2\[Pi] rSq),z/(2\[Pi] rSq)}]]


ICPhiSourcePoint[rf_,rs_]:=Module[{r},
r=DisplacementVectors[rf,rs];
1/(4\[Pi]) Log[r.r]]


ICPsiSourcePoint[rf_,rs_]:=-Module[{r},
r=DisplacementVectors[rf,rs];
-(1/(2\[Pi]))ArcTan[r]]


ICSourceConstant[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
ic=ICSourceConstant[rf,rs];
If[NumberOfVectors[ic]>1,Flatten[ic],Flatten[Components[ic]]]]


ICPhiSourceConstant[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
ic=ICPhiSourceConstant[rf,rs];
If[Dimensions[ic][[2]]>1,Flatten[ic],ic[[1,1]]]]


ICPsiSourceConstant[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
ic=ICPsiSourceConstant[rf,rs];
If[Dimensions[ic][[2]]>1,Flatten[ic],ic[[1,1]]]]


ICSourceConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPhiSourceConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPsiSourceConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICSourceConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPhiSourceConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPsiSourceConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICSourceConstant[rf_,rs_]:=Module[{ic,r1,r2,rfs,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
ic=MakeCartesianVectors[{-(1/(4\[Pi]))Log[r2.r2/r1.r1],1/(2\[Pi]) (ArcTan[r2]-ArcTan[r1])}];
Transpose[Rotate[Transpose[ic],\[Theta]p]]]


ICPhiSourceConstant[rf_,rs_]:=ICPsiVortexConstant[rf,rs]


ICPsiSourceConstant[rf_,rs_]:=-ICPhiVortexConstant[rf,rs]


ICSourceLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb}=ICSourceLinear[rf,rs];
Which[NumberOfVectors[rs]==2,
{Flatten[Components[ica]],Flatten[Components[icb]]},
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb]}]]


(*ICSourceLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
Flatten/@Components/@ICSourceLinear[rf,rs]]*)


ICPhiSourceLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb}=ICPhiSourceLinear[rf,rs];
Which[NumberOfVectors[rs]==2,Flatten[{ica,icb}],
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb]}]]


(*ICPhiSourceLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
ICPhiSourceLinear[rf,rs]//Flatten]*)


ICPsiSourceLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb}=ICPsiSourceLinear[rf,rs];
Which[NumberOfVectors[rs]==2,Flatten[{ica,icb}],
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb]}]]


(*ICPsiSourceLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
ICPsiSourceLinear[rf,rs]//Flatten]*)


ICSourceLinear[{xf:Except[_List],zf:Except[_List]},{xs_List,zs_List}]/;Dimensions[xs]==Dimensions[zs]=={2}:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},Transpose[{xs,zs}]};
Partition[Flatten[Components/@ICSourceLinear[rf,rs]],2]]


ICPhiSourceLinear[{xf:Except[_List],zf:Except[_List]},{xs_List,zs_List}]/;Dimensions[xs]==Dimensions[zs]=={2}:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},Transpose[{xs,zs}]};
ICPhiSourceLinear[rf,rs]//Flatten]


ICPsiSourceLinear[{xf:Except[_List],zf:Except[_List]},{xs_List,zs_List}]/;Dimensions[xs]==Dimensions[zs]=={2}:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},Transpose[{xs,zs}]};
ICPsiSourceLinear[rf,rs]//Flatten]


ICSourceLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPhiSourceLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPsiSourceLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICSourceLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPhiSourceLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPsiVortexLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICSourceLinear[rf_,rs_]:=Module[{ica,icax,icaz,icb,icbx,icbz,x,x2,z,rfs,r1,r1Sq,r2,r2Sq,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
icax=-(1/(4\[Pi]))Log[r2.r2/r1.r1];
icaz=1/(2\[Pi]) (ArcTan[r2]-ArcTan[r1]);icbx=-(1/(2\[Pi]))((x-x2)-z(\[Theta]2-\[Theta]1)+x/2 Log[r2Sq/r1Sq]);icbz=1/(2\[Pi]) (x(\[Theta]2-\[Theta]1)+z/2 Log[r2Sq/r1Sq]);
ica=MakeCartesianVectors[{icax,icaz}];icb=MakeCartesianVectors[{icbx,icbz}];{Transpose[Rotate[Transpose[ica],\[Theta]p]],Transpose[Rotate[Transpose[icb],\[Theta]p]]}]


ICPhiSourceLinear[rf_,rs_]:=ICPsiVortexLinear[rf,rs]


ICPsiSourceLinear[rf_,rs_]:=-ICPhiVortexLinear[rf,rs]


ICDoubletPoint[{xf:Except[_List],zf:Except[_List]},{xs:Except[_List],zs:Except[_List]},{ux:Except[_List],uz:Except[_List]}]:=
Module[{rf,rs,uv},
{rf,rs,uv}=MakeCartesianVectors/@{{{xf},{zf}},{{xs},{zs}},{{ux},{uz}}};
Flatten[Components[ICDoubletPoint[rf,rs,uv]]]]


ICPhiDoubletPoint[{xf:Except[_List],zf:Except[_List]},{xs:Except[_List],zs:Except[_List]},{ux:Except[_List],uz:Except[_List]}]:=
Module[{ic,rf,rs,uv},
{rf,rs,uv}=MakeCartesianVectors/@{{{xf},{zf}},{{xs},{zs}},{{ux},{uz}}};
{{ic}}=ICPhiDoubletPoint[rf,rs,uv];ic]


ICPsiDoubletPoint[{xf:Except[_List],zf:Except[_List]},{xs:Except[_List],zs:Except[_List]},{ux:Except[_List],uz:Except[_List]}]:=Module[{ic,rf,rs,uv},
{rf,rs,uv}=MakeCartesianVectors/@{{{xf},{zf}},{{xs},{zs}},{{ux},{uz}}};
{{ic}}=ICPsiDoubletPoint[rf,rs,uv];ic]


ICDoubletPoint[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ,uv_CartesianVectors?TwoDimQ]:=
Module[{rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
Flatten[ICDoubletPoint[rf,rs,uv]]]


ICPhiDoubletPoint[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ,uv_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ic}=ICPhiDoubletPoint[rf,rs,uv];ic]


ICPsiDoubletPoint[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ,uv_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ic}=ICPsiDoubletPoint[rf,rs,uv];ic]


ICDoubletPoint[rf_,rs_,uv_]/;Head[rf]=!=CartesianVectors || Head[rs]=!=CartesianVectors || Length[rf]=!=2 || Length[rs]=!=2:=Message[InfluenceCoefficients::dataType]


ICPhiDoubletPoint[rf_,rs_,uv_]/;Head[rf]=!=CartesianVectors || Head[rs]=!=CartesianVectors || Length[rf]=!=2 || Length[rs]=!=2:=Message[InfluenceCoefficients::dataType]


ICPsiDoubletPoint[rf_,rs_,uv_]/;Head[rf]=!=CartesianVectors || Head[rs]=!=CartesianVectors || Length[rf]=!=2 || Length[rs]=!=2:=Message[InfluenceCoefficients::dataType]


ICDoubletPoint[x_]/;Length[{x}]==1:=Message[InfluenceCoefficients::argr,"ICDoubletPoint",3]


ICPhiDoubletPoint[x_]/;Length[{x}]==1:=Message[InfluenceCoefficients::argr,"ICPhiDoubletPoint",3]


ICPsiDoubletPoint[x_]/;Length[{x}]==1:=Message[InfluenceCoefficients::argr,"ICPsiDoubletPoint",3]


ICDoubletPoint[x___]:=Message[InfluenceCoefficients::argrx,"ICDoubletPoint",Length[{x}],3]


ICPhiDoubletPoint[x___]:=Message[InfluenceCoefficients::argrx,"ICDoubletPoint",Length[{x}],3]


ICPsiDoubletPoint[x___]:=Message[InfluenceCoefficients::argrx,"ICDoubletPoint",Length[{x}],3]


ICDoubletPoint[rf_,rs_,uv_]:=Module[{ic,rfs,rSq,x,z,\[Theta]},
\[Theta]=ArcTan[uv]-\[Pi]/2;
rfs=Transpose[Rotate[Transpose[DisplacementVectors[rf,rs]],\[Theta]]];
rSq=rfs.rfs;
{x,z}=Components[rfs];
ic=MakeCartesianVectors[{(x z)/(\[Pi] rSq^2),-((x^2-z^2)/(2\[Pi] rSq^2))}];
Transpose[Rotate[Transpose[ic],-\[Theta]]]]


ICPhiDoubletPoint[rf_,rs_,uv_]:=Module[{rfs,rSq,x,z,\[Theta]},
\[Theta]=ArcTan[uv]-\[Pi]/2;
rfs=Transpose[Rotate[Transpose[DisplacementVectors[rf,rs]],\[Theta]]];
rSq=rfs.rfs;
{x,z}=Components[rfs];
-(z/(2\[Pi] rSq))]


ICPsiDoubletPoint[rf_,rs_,uv_]:=Module[{rfs,rSq,x,z,\[Theta]},
\[Theta]=ArcTan[uv]-\[Pi]/2;
rfs=Transpose[Rotate[Transpose[DisplacementVectors[rf,rs]],\[Theta]]];
rSq=rfs.rfs;
{x,z}=Components[rfs];
-(x/(2\[Pi] rSq))]


ICDoubletConstant[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
ic=ICDoubletConstant[rf,rs];
If[NumberOfVectors[ic]>1,Flatten[ic],Flatten[Components[ic]]]]


ICPhiDoubletConstant[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
ic=ICPhiDoubletConstant[rf,rs];
If[Dimensions[ic][[2]]>1,Flatten[ic],ic[[1,1]]]]


ICPsiDoubletConstant[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ic,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
ic=ICPsiDoubletConstant[rf,rs];
If[Dimensions[ic][[2]]>1,Flatten[ic],ic[[1,1]]]]


ICDoubletConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPhiDoubletConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPsiDoubletConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICDoubletConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPhiDoubletConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPsiDoubletConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICDoubletConstant[rf_,rs_]:=Module[{ic,icx,icz,rfs,r1,r1Sq,r2,r2Sq,x,x2,z,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{icx,icz}={z/(2\[Pi]) (1/r2Sq-1/r1Sq),-(1/(2\[Pi]))(x2/r2Sq-x/r1Sq)};
ic=MakeCartesianVectors[{icx,icz}];
Transpose[Rotate[Transpose[ic],\[Theta]p]]]


ICPhiDoubletConstant[rf_,rs_]:=Module[{rfs,r1,r2,\[CapitalDelta]r,\[Theta]p,\[Theta]1,\[Theta]2},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
-(1/(2\[Pi]))(\[Theta]2-\[Theta]1)]


ICPsiDoubletConstant[rf_,rs_]:=Module[{rfs,r1,r2,\[CapitalDelta]r,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
1/(4\[Pi]) Log[r2.r2/r1.r1]]


ICDoubletLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb}=ICDoubletLinear[rf,rs];
Which[NumberOfVectors[rs]==2,
{Flatten[Components[ica]],Flatten[Components[icb]]},
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb]}]]


ICPhiDoubletLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb}=ICPhiDoubletLinear[rf,rs];
Which[NumberOfVectors[rs]==2,Flatten[{ica,icb}],
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb]}]]


ICPsiDoubletLinear[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb}=ICPsiDoubletLinear[rf,rs];
Which[NumberOfVectors[rs]==2,Flatten[{ica,icb}],
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb]}]]


ICDoubletLinear[{xf:Except[_List],zf:Except[_List]},{xs_List,zs_List}]/;Dimensions[xs]==Dimensions[zs]=={2}:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},Transpose[{xs,zs}]};
Partition[Flatten[Components/@ICDoubletLinear[rf,rs]],2]]


ICPhiDoubletLinear[{xf:Except[_List],zf:Except[_List]},{xs_List,zs_List}]/;Dimensions[xs]==Dimensions[zs]=={2}:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},Transpose[{xs,zs}]};
ICPhiDoubletLinear[rf,rs]//Flatten]


ICPsiDoubletLinear[{xf:Except[_List],zf:Except[_List]},{xs_List,zs_List}]/;Dimensions[xs]==Dimensions[zs]=={2}:=
Module[{rf,rs},
{rf,rs}=MakeCartesianVectors/@{{{xf},{zf}},Transpose[{xs,zs}]};
ICPsiDoubletLinear[rf,rs]//Flatten]


ICDoubletLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPhiDoubletLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPsiDoubletLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICDoubletLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPhiDoubletLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPsiDoubletLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICDoubletLinear[rf_,rs_]:=Module[{ica,icax,icaz,icb,icbx,icbz,x,x2,z,rfs,r1,r1Sq,r2,r2Sq,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
icax=z/(2\[Pi]) (1/r2Sq-1/r1Sq);
icaz=-(1/(2\[Pi]))(x2/r2Sq-x/r1Sq);ica=MakeCartesianVectors[{icax,icaz}];icbx=1/(2\[Pi]) ((z(x-x2))/r2Sq-(\[Theta]2-\[Theta]1));icbz=-(1/(2\[Pi]))((x2(x-x2))/r2Sq+1/2 Log[r2Sq/r1Sq]);icb=MakeCartesianVectors[{icbx,icbz}];{Transpose[Rotate[Transpose[ica],\[Theta]p]],Transpose[Rotate[Transpose[icb],\[Theta]p]]}]


ICPhiDoubletLinear[rf_,rs_]:=Module[{c,d,ic\[Phi]a,ic\[Phi]b,r1,r1Sq,r2,r2Sq,x,x2,z,rfs,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
ic\[Phi]a=-(1/(2\[Pi]))(\[Theta]2-\[Theta]1);
ic\[Phi]b=-(1/(2\[Pi]))(x(ArcTan[r2]-ArcTan[r1])+z/2 Log[r2.r2/r1.r1]);
{ic\[Phi]a,ic\[Phi]b}]


ICPsiDoubletLinear[rf_,rs_]:=Module[{c,d,ic\[Psi]a,ic\[Psi]b,r1,r1Sq,r2,r2Sq,x,x2,z,rfs,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
ic\[Psi]a=1/(4\[Pi]) Log[r2.r2/r1.r1];
ic\[Psi]b=1/(2\[Pi]) ((x-x2)-z(ArcTan[r2]-ArcTan[r1])+x/2 Log[r2.r2/r1.r1]);
{ic\[Psi]a,ic\[Psi]b}]


ICDoubletQuadratic[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,icc,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb,icc}=ICDoubletQuadratic[rf,rs];
Which[NumberOfVectors[rs]==2,
{Flatten[Components[ica]],Flatten[Components[icb]],Flatten[Components[icc]]},
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb],Flatten[icc]}]]


ICPhiDoubletQuadratic[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,icc,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb,icc}=ICPhiDoubletQuadratic[rf,rs];
Which[NumberOfVectors[rs]==2,Flatten[{ica,icb,icc}],
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb],Flatten[icc]}]]


ICPsiDoubletQuadratic[{xf:Except[_List],zf:Except[_List]},rs_CartesianVectors?TwoDimQ]:=
Module[{ica,icb,icc,rf},
rf=MakeCartesianVectors[{{xf},{zf}}];
{ica,icb,icc}=ICPsiDoubletQuadratic[rf,rs];
Which[NumberOfVectors[rs]==2,Flatten[{ica,icb,icc}],
NumberOfVectors[rs]>2,{Flatten[ica],Flatten[icb],Flatten[icc]}]]


ICDoubletQuadratic[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPhiDoubletQuadratic[p___]:=Null/;!TrueQ[TestArguments[p]]


ICPsiDoubletQuadratic[p___]:=Null/;!TrueQ[TestArguments[p]]


ICDoubletQuadratic[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPhiDoubletQuadratic[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICPsiDoubletQuadratic[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICDoubletQuadratic[rf_,rs_]:=Module[{d,ica,icax,icaz,icb,icbx,icbz,icc,iccx,iccz,x,x2,z,rfs,r1,r1Sq,r2,r2Sq,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
d=x-x2;
{icax,icaz}={z/(2\[Pi]) (1/r2Sq-1/r1Sq),-(1/(2\[Pi]))(x2/r2Sq-x/r1Sq)};
ica=MakeCartesianVectors[{icax,icaz}];
{icbx,icbz}={1/(2\[Pi]) ((z(x-x2))/r2Sq-(\[Theta]2-\[Theta]1)),-(1/(2\[Pi]))((x2(x-x2))/r2Sq+1/2 Log[r2Sq/r1Sq])};
icb=MakeCartesianVectors[{icbx,icbz}];
iccx=1/(2\[Pi]) ((z d^2)/r2Sq-2x(\[Theta]2-\[Theta]1)-z Log[r2Sq/r1Sq]);
iccz=-(1/(2\[Pi]))(2d+(x2 d^2)/r2Sq-2z(\[Theta]2-\[Theta]1)+x Log[r2Sq/r1Sq]);
icc=MakeCartesianVectors[{iccx,iccz}];
{Transpose[Rotate[Transpose[ica],\[Theta]p]],Transpose[Rotate[Transpose[icb],\[Theta]p]],Transpose[Rotate[Transpose[icc],\[Theta]p]]}]


ICPhiDoubletQuadratic[rf_,rs_]:=Module[{c,d,ic\[Phi]a,ic\[Phi]b,ic\[Phi]c,rfs,r1,r1Sq,r2,r2Sq,x,x2,z,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
ic\[Phi]a=-(1/(2\[Pi]))(\[Theta]2-\[Theta]1);
ic\[Phi]b=-(1/(2\[Pi]))(x(\[Theta]2-\[Theta]1)+z/2 Log[r2Sq/r1Sq]);
ic\[Phi]c=-(1/(2\[Pi]))(z d+(x^2-z^2)(\[Theta]2-\[Theta]1)+ x z Log[r2Sq/r1Sq]);
{ic\[Phi]a,ic\[Phi]b,ic\[Phi]c}]


ICPsiDoubletQuadratic[rf_,rs_]:=Module[{c,d,ic\[Psi]a,ic\[Psi]b,ic\[Psi]c,rfs,r1,r1Sq,r2,r2Sq,x,x2,z,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
ic\[Psi]a=1/(4\[Pi]) Log[r2Sq/r1Sq];
ic\[Psi]b=1/(2\[Pi]) ((x-x2)-z(\[Theta]2-\[Theta]1)+x/2 Log[r2Sq/r1Sq]);
ic\[Psi]c=1/(2\[Pi]) ((x-x2)(2x-x2)-2x z(\[Theta]2-\[Theta]1)+(x^2-z^2)/2 Log[r2Sq/r1Sq]);
{ic\[Psi]a,ic\[Psi]b,ic\[Psi]c}]


TestArguments[rf_CartesianVectors?TwoDimQ,rs_CartesianVectors?TwoDimQ]:=True


TestArguments[rf_,rs_]:=Message[InfluenceCoefficients::dataType]


TestArguments[x_]/;Length[{x}]==1:=Message[InfluenceCoefficients::argr,"Singularity function",2]


TestArguments[x___]:=Message[InfluenceCoefficients::argrx,"Singularity function",Length[{x}],2]


End[];


Protect[DisplacementVectors,ICDoubletConstant,ICDoubletLinear,ICDoubletPoint,ICDoubletQuadratic,ICSourceConstant,ICSourceLinear,ICSourcePoint,ICVortexConstant,ICVortexLinear,ICVortexPoint,ICPhiDoubletConstant,ICPhiDoubletLinear,ICPhiDoubletQuadratic,ICPhiDoubletPoint,ICPhiSourceConstant,ICPhiSourceLinear,ICPhiSourcePoint,ICPhiVortexConstant,ICPhiVortexLinear,ICPhiVortexPoint,ICPsiDoubletConstant,ICPsiDoubletLinear,ICPsiDoubletQuadratic,ICPsiDoubletPoint,ICPsiSourceConstant,ICPsiSourceLinear,ICPsiSourcePoint,ICPsiVortexConstant,ICPsiVortexLinear,ICPsiVortexPoint,InfluenceCoefficients,TestArguments,UniformFlow,UniformFlowPhi,UniformFlowPsi];


EndPackage[]
