(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      4884,        169]
NotebookOptionsPosition[      3051,        115]
NotebookOutlinePosition[      4266,        147]
CellTagsIndexPosition[      4223,        144]
WindowTitle->Aerodynamics - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "GuideColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 StyleBox[ButtonBox["Mathematica",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:guide/Mathematica"],
  FontSlant->"Italic"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[CellGroupData[{

Cell["Aerodynamics", "GuideTitle",
 CellID->942062912],

Cell[TextData[{
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " 1.2 provides computational tools for steady, incompressible \
two-dimensional potential flow over an airfoil using panel methods.  The \
software consists of a collection of five packages."
}], "GuideAbstract",
 CellID->2001916300],

Cell[TextData[{
 Cell[TextData[ButtonBox["CartesianVectors",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/guide/CartesianVectors"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " data type for collection of vectors"
}], "GuideText",
 CellID->203374175],

Cell[TextData[{
 Cell[TextData[ButtonBox["Graphics",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/guide/Graphics"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " commonly used graphics for aerodynamics"
}], "GuideText",
 CellID->174628346],

Cell[TextData[{
 Cell[TextData[ButtonBox["AirfoilGeometry",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/guide/AirfoilGeometry"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " geometry of airfoils"
}], "GuideText",
 CellID->1463276848],

Cell[TextData[{
 Cell[TextData[ButtonBox["InfluenceCoefficients",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/guide/InfluenceCoefficients"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " influence coefficients for commonly used 2-D singularities"
}], "GuideText",
 CellID->62617219],

Cell[TextData[{
 Cell[TextData[ButtonBox["PanelMethods",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/guide/PanelMethods"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " examples of specific panel methods"
}], "GuideText",
 CellID->31780391]
}, Open  ]],

Cell[CellGroupData[{

Cell["TUTORIALS", "GuideTutorialsSection",
 CellID->415694126],

Cell[TextData[ButtonBox["Overview",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Aerodynamics/tutorial/AerodynamicsOverview"]], "GuideTutorial",
 CellID->32073861]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Aerodynamics - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 9, 57, 50.3004000}", "context" -> 
    "Aerodynamics`", "keywords" -> {}, "index" -> True, "label" -> 
    "Aerodynamics Guide", "language" -> "en", "paclet" -> "Aerodynamics", 
    "status" -> "None", "summary" -> 
    "Aerodynamics 1.2 provides computational tools for steady, incompressible \
two-dimensional potential flow over an airfoil using panel methods. The \
software consists of a collection of five packages.", "synonyms" -> {}, 
    "title" -> "Aerodynamics", "type" -> "Guide", "uri" -> 
    "Aerodynamics/guide/Aerodynamics"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[605, 21, 75, 1, 70, "GuideColorBar"],
Cell[683, 24, 209, 6, 70, "LinkTrail"],
Cell[CellGroupData[{
Cell[917, 34, 54, 1, 70, "GuideTitle",
 CellID->942062912],
Cell[974, 37, 300, 7, 70, "GuideAbstract",
 CellID->2001916300],
Cell[1277, 46, 293, 9, 70, "GuideText",
 CellID->203374175],
Cell[1573, 57, 278, 8, 70, "GuideText",
 CellID->174628346],
Cell[1854, 67, 277, 9, 70, "GuideText",
 CellID->1463276848],
Cell[2134, 78, 325, 9, 70, "GuideText",
 CellID->62617219],
Cell[2462, 89, 283, 9, 70, "GuideText",
 CellID->31780391]
}, Open  ]],
Cell[CellGroupData[{
Cell[2782, 103, 62, 1, 70, "GuideTutorialsSection",
 CellID->415694126],
Cell[2847, 106, 162, 4, 70, "GuideTutorial",
 CellID->32073861]
}, Open  ]],
Cell[3024, 113, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

