(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      4651,        162]
NotebookOptionsPosition[      2765,        105]
NotebookOutlinePosition[      3917,        136]
CellTagsIndexPosition[      3874,        133]
WindowTitle->Graphics - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "GuideColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[CellGroupData[{

Cell["Graphics", "GuideTitle",
 CellID->942062912],

Cell["\<\
This package contains functions to facilitate visual presentation of results \
for geometric and aerodynamic characteristics computed in other packages.\
\>", "GuideAbstract",
 CellID->2001916300],

Cell[TextData[{
 Cell[TextData[ButtonBox["PlotAirfoil",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/PlotAirfoil"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " plots airfoil shape"
}], "GuideText",
 CellID->203374175],

Cell[TextData[{
 Cell[TextData[ButtonBox["PlotConvergence",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/PlotConvergence"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " plots convergence properties of panel methods"
}], "GuideText",
 CellID->293675932],

Cell[TextData[{
 Cell[TextData[ButtonBox["PlotSurfacePressureCoefficient",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/PlotSurfacePressureCoefficient"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " plots pressure coefficient on airfoil"
}], "GuideText",
 CellID->1463276848]
}, Open  ]],

Cell[CellGroupData[{

Cell["TUTORIALS", "GuideTutorialsSection",
 CellID->415694126],

Cell[TextData[ButtonBox["A2 Graphics",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/tutorial/Graphics"]], "GuideTutorial",
 CellID->806871991],

Cell[TextData[ButtonBox["Overview",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Aerodynamics/tutorial/AerodynamicsOverview"]], "GuideTutorial",
 CellID->1885805579]
}, Open  ]],

Cell[CellGroupData[{

Cell["MORE ABOUT", "GuideMoreAboutSection",
 CellID->23220180],

Cell[TextData[ButtonBox["Aerodynamics",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"]], "GuideMoreAbout",
 CellID->1567025153]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Graphics - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 9, 57, 57.5544000}", "context" -> 
    "Aerodynamics`", "keywords" -> {}, "index" -> True, "label" -> 
    "Aerodynamics Guide", "language" -> "en", "paclet" -> "Aerodynamics", 
    "status" -> "None", "summary" -> 
    "This package contains functions to facilitate visual presentation of \
results for geometric and aerodynamic characteristics computed in other \
packages.", "synonyms" -> {}, "title" -> "Graphics", "type" -> "Guide", "uri" -> 
    "Aerodynamics/guide/Graphics"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 75, 1, 70, "GuideColorBar"],
Cell[679, 24, 191, 5, 70, "LinkTrail"],
Cell[CellGroupData[{
Cell[895, 33, 50, 1, 70, "GuideTitle",
 CellID->942062912],
Cell[948, 36, 206, 4, 70, "GuideAbstract",
 CellID->2001916300],
Cell[1157, 42, 262, 8, 70, "GuideText",
 CellID->203374175],
Cell[1422, 52, 299, 9, 70, "GuideText",
 CellID->293675932],
Cell[1724, 63, 322, 9, 70, "GuideText",
 CellID->1463276848]
}, Open  ]],
Cell[CellGroupData[{
Cell[2083, 77, 62, 1, 70, "GuideTutorialsSection",
 CellID->415694126],
Cell[2148, 80, 151, 3, 70, "GuideTutorial",
 CellID->806871991],
Cell[2302, 85, 164, 4, 70, "GuideTutorial",
 CellID->1885805579]
}, Open  ]],
Cell[CellGroupData[{
Cell[2503, 94, 62, 1, 70, "GuideMoreAboutSection",
 CellID->23220180],
Cell[2568, 97, 155, 3, 70, "GuideMoreAbout",
 CellID->1567025153]
}, Open  ]],
Cell[2738, 103, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

