(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     71461,       1957]
NotebookOptionsPosition[     64193,       1709]
NotebookOutlinePosition[     65898,       1756]
CellTagsIndexPosition[     65812,       1751]
WindowTitle->AirfoilFromDataFile - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"1.2 Airfoils From Data Files\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/AirfoilsFromDataFiles"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AirfoilSurfacePoints\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/AirfoilSurfacePoints"], "\<\"FitAirfoil\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/FitAirfoil"], "\<\"NACA4DigitAirfoil\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/NACA4DigitAirfoil"], "\<\"PlotAirfoil\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/ref/PlotAirfoil"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AirfoilGeometry\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/AirfoilGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/AirfoilFromDataFile\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/AirfoilFromDataFile"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
AirfoilFromDataFile.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/AirfoilFromDataFile", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["AirfoilFromDataFile", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"AirfoilFromDataFile", "[", 
       StyleBox["filename", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]imports data from a file and rearranges the data to \
conform to the conventions used in ",
     Cell[BoxData[
      ButtonBox[
       StyleBox["Aerodynamics",
        FontSlant->"Italic"],
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/Aerodynamics"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->346777622],

Cell[TextData[{
 "Collections of vectors are of the data type ",
 Cell[BoxData[
  ButtonBox["CartesianVectors",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/CartesianVectors"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->208986483],

Cell[TextData[{
 "Some files have been downloaded to the folder Airfoil Data from the ",
 ButtonBox["UIUC Airfoil Coordinates Database",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.ae.illinois.edu/m-selig/ads/coord_database.html"], None}],
 " for use in documentation examples, and files may be imported directly from \
this database if you are connected to the Internet."
}], "Notes",
 CellID->24936737],

Cell[TextData[{
 "The UIUC Airfoil Coordinates Database contains data files from various \
sources.  Two numbering conventions are used: counterclockwise and \
fore-to-aft.  The function AirfoilFromDataFile detects the numbering \
convention used in the file, converts it to the clockwise numbering \
convention, and casts the data in the form of a collection of vectors of the \
data type ",
 Cell[BoxData[
  ButtonBox["CartesianVectors",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/CartesianVectors"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->431408632],

Cell["New in 1.1   |   Last modified in 1.2", "Notes",
 CellID->529540534]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->114545432],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection",
 CellID->59937985],

Cell["Load the packages.", "ExampleText",
 CellID->701079788],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->18639833],

Cell["\<\
Here are the names of the data files in the folder Airfoil Data which have \
been downloaded from the UIUC Airfoil Coordinates Database.  Repetitive parts \
of the path names have been stripped away.\
\>", "ExampleText",
 CellID->411631528],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"StringTake", "[", 
     RowBox[{"#", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"StringPosition", "[", 
         RowBox[{"#", ",", "\"\<Airfoil Data\\\\\>\""}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}], "-", 
       RowBox[{"StringLength", "[", "#", "]"}]}]}], "]"}], "&"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"FileNames", "[", 
    RowBox[{"\"\<Aerodynamics\\\\Airfoil Data\\\\*\>\"", ",", "$Path"}], 
    "]"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->161538214],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"clarky.dat\"\>", ",", "\<\"e205.dat\"\>", 
   ",", "\<\"e374.dat\"\>", ",", "\<\"l7769.dat\"\>", 
   ",", "\<\"naca23012.dat\"\>", ",", "\<\"naca4412.dat\"\>", 
   ",", "\<\"naca4412m.dat\"\>", ",", "\<\"naca642415.dat\"\>", 
   ",", "\<\"naca747a315.dat\"\>", ",", "\<\"s1223.dat\"\>", 
   ",", "\<\"sd7003.dat\"\>", ",", "\<\"usa35b.dat\"\>", 
   ",", "\<\"clarky.dat\"\>", ",", "\<\"e205.dat\"\>", 
   ",", "\<\"e374.dat\"\>", ",", "\<\"l7769.dat\"\>", 
   ",", "\<\"naca23012.dat\"\>", ",", "\<\"naca4412.dat\"\>", 
   ",", "\<\"naca642415.dat\"\>", ",", "\<\"naca747a315.dat\"\>", 
   ",", "\<\"s1223.dat\"\>", ",", "\<\"sd7003.dat\"\>", 
   ",", "\<\"usa35b.dat\"\>"}], "}"}]], "Output",
 ImageSize->{564, 67},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->180581880]
}, Open  ]],

Cell["\<\
The Eppler-205 airfoil is used as an example of a data file using the \
counterclockwise numbering convention.\
\>", "ExampleText",
 CellID->158695459],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "[", 
  RowBox[{
   RowBox[{
   "Import", "[", "\"\<Aerodynamics\\\\Airfoil Data\\\\e205.dat\>\"", "]"}], 
   ",", "4"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->123334517],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\<\"E205\"\>", ",", "\<\"(10.48%)\"\>"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1.`", ",", "0.`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.99655`", ",", "0.00039`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.98649`", ",", "0.00174`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.97049`", ",", "0.00427`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.94916`", ",", "0.00778`"}], "}"}], ",", 
    RowBox[{"\[LeftSkeleton]", "51", "\[RightSkeleton]"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.9486`", ",", 
      RowBox[{"-", "0.00252`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.97017`", ",", 
      RowBox[{"-", "0.00125`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.98635`", ",", 
      RowBox[{"-", "0.00036`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.99651`", ",", 
      RowBox[{"-", "0.00003`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1.`", ",", "0.`"}], "}"}]}], "}"}],
  Short[#, 4]& ]], "Output",
 ImageSize->{498, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//Short=",
 CellID->13352816]
}, Open  ]],

Cell["\<\
The function AirfoilFromDataFile converts this data to a clockwise numbering \
convention and casts the data as a collection of vectors of the data type \
CartesianVectors.\
\>", "ExampleText",
 CellID->36460158],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rE205", "=", 
  RowBox[{
  "AirfoilFromDataFile", "[", 
   "\"\<Aerodynamics\\\\Airfoil Data\\\\e205.dat\>\"", "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->317289154],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1.`", ",", "0.99651`", ",", "0.98635`", ",", "0.97017`", ",", "0.9486`", 
     ",", "0.92195`", ",", "0.89034`", ",", "0.854`", ",", "0.81343`", ",", 
     "0.76911`", ",", "0.7216`", ",", "0.67149`", ",", "0.61938`", ",", 
     "0.56591`", ",", "0.51174`", ",", "0.45751`", ",", "0.40388`", ",", 
     "0.35149`", ",", "0.30097`", ",", "0.2529`", ",", "0.20783`", ",", 
     "0.16627`", ",", "0.12864`", ",", "0.09534`", ",", "0.06669`", ",", 
     "0.04291`", ",", "0.02419`", ",", "0.01065`", ",", "0.00233`", ",", 
     "0.00002`", ",", "0.00331`", ",", "0.01097`", ",", "0.02292`", ",", 
     "0.03909`", ",", "0.05937`", ",", "0.0836`", ",", "0.11157`", ",", 
     "0.14302`", ",", "0.17764`", ",", "0.21508`", ",", "0.25496`", ",", 
     "0.29699`", ",", "0.34101`", ",", "0.3868`", ",", "0.4341`", ",", 
     "0.48265`", ",", "0.53217`", ",", "0.58218`", ",", "0.63204`", ",", 
     "0.68108`", ",", "0.72866`", ",", "0.77412`", ",", "0.81684`", ",", 
     "0.85624`", ",", "0.89175`", ",", "0.92285`", ",", "0.94916`", ",", 
     "0.97049`", ",", "0.98649`", ",", "0.99655`", ",", "1.`"}], "}"}], 
   "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", 
     RowBox[{"-", "0.00003`"}], ",", 
     RowBox[{"-", "0.00036`"}], ",", 
     RowBox[{"-", "0.00125`"}], ",", 
     RowBox[{"-", "0.00252`"}], ",", 
     RowBox[{"-", "0.0038`"}], ",", 
     RowBox[{"-", "0.00497`"}], ",", 
     RowBox[{"-", "0.00614`"}], ",", 
     RowBox[{"-", "0.0074`"}], ",", 
     RowBox[{"-", "0.00876`"}], ",", 
     RowBox[{"-", "0.01023`"}], ",", 
     RowBox[{"-", "0.0118`"}], ",", 
     RowBox[{"-", "0.01345`"}], ",", 
     RowBox[{"-", "0.01516`"}], ",", 
     RowBox[{"-", "0.01689`"}], ",", 
     RowBox[{"-", "0.01859`"}], ",", 
     RowBox[{"-", "0.02021`"}], ",", 
     RowBox[{"-", "0.02168`"}], ",", 
     RowBox[{"-", "0.02292`"}], ",", 
     RowBox[{"-", "0.02384`"}], ",", 
     RowBox[{"-", "0.02435`"}], ",", 
     RowBox[{"-", "0.02436`"}], ",", 
     RowBox[{"-", "0.02378`"}], ",", 
     RowBox[{"-", "0.02252`"}], ",", 
     RowBox[{"-", "0.02053`"}], ",", 
     RowBox[{"-", "0.01776`"}], ",", 
     RowBox[{"-", "0.0142`"}], ",", 
     RowBox[{"-", "0.00988`"}], ",", 
     RowBox[{"-", "0.00506`"}], ",", "0.00055`", ",", "0.00766`", ",", 
     "0.01589`", ",", "0.02461`", ",", "0.03344`", ",", "0.04211`", ",", 
     "0.0504`", ",", "0.05811`", ",", "0.06507`", ",", "0.07111`", ",", 
     "0.07606`", ",", "0.0797`", ",", "0.08177`", ",", "0.08214`", ",", 
     "0.08081`", ",", "0.07785`", ",", "0.07342`", ",", "0.06782`", ",", 
     "0.06147`", ",", "0.0547`", ",", "0.04777`", ",", "0.04088`", ",", 
     "0.03419`", ",", "0.02786`", ",", "0.02199`", ",", "0.01668`", ",", 
     "0.01196`", ",", "0.00778`", ",", "0.00427`", ",", "0.00174`", ",", 
     "0.00039`", ",", "0.`"}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[CompressedData["
1:eJwB9QEK/iFib1JlAQAAAD0AAAAAAAAAAADwP/phhPBo4+8/cRsN4C2Q7z8k
7rH0oQvvPwmKH2PuWu4/qoJRSZ2A7T+vQspPqn3sP4cW2c73U+s/nbryWZ4H
6j+U2SCTjJzoPyxlGeJYF+c/zemymNh85T/EfHkB9tHjP+tWz0nvG+I/48KB
kCxg4D8O8+UF2EfdP/CK4H8r2dk/H7+36c9+1j+J78SsF0PTPzojSnuDL9A/
0VeQZiyayj9jKCfaVUjFP2WNeohGd8A/8SkAxjNouD+mYfiImBKxP3+8V61M
+KU/E5uPa0PFmD/kg57Nqs+FP4P6ljldFmM/8WjjiLX49D6vCP63kh1rPyyf
5Xlwd4Y/8YCyKVd4lz8WhzO/mgOkP0sfuqC+Za4/1xLyQc9mtT/k9zb92Y+8
PwNDVrd6TsI/dxA7U+i8xj/yBwPPvYfLPzdxcr9DUdA/bkxPWOIB0z8z+Wab
G9PVP2/whclUwdg/8WPMXUvI2z+IhVrTvOPeP7oxPWGJB+E/N1SM8zeh4j9h
cTjzqznkP7O1vkhoy+U/U+i8xi5R5z+hvmVOl8XoP4gRwqONI+o/g92wbVFm
6z/wp8ZLN4nsP5yiI7n8h+0/yHvVyoRf7j+RCmMLQQ7vP+GX+nlTke8/iIVa
07zj7z8AAAAAAADwP7Ee+1o=
    "], CompressedData["
1:eJwB9QEK/iFib1JlAQAAAD0AAAAAAAAAAAAAAGkdVU0Qdf++D9b/OcyXN797
FK5H4XpUv03bv7LSpGS/xY8xdy0hb79dv2A3bFt0v9i2KLNBJnm/rK3YX3ZP
fr/GihpMw/CBvxYwgVt384S/7Q2+MJkqiL+WsgxxrIuLv1ysqME0DI+/64uE
tpxLkb9hbCHIQQmTv25pNSTusZS/F7zoK0gzlr/xgLIpV3iXvyi4WFGDaZi/
5WGh1jTvmL9SflLt0/GYv5kNMsnIWZi/5A8GnnsPl78S91j60AWVvwE1tWyt
L5K/hlrTvOMUjb9AahMn9zuEv7a+SGjLuXS/L26jAbwFQj8AOsyXF2B/P0xx
Vdl3RZA/+kSeJF0zmT+sqME0DB+hP3NLqyFxj6U/INJvXwfOqT9xICQLmMCt
P2Ni83FtqLA/wCZr1EM0sj9/pIgMq3izP0i/fR04Z7Q/Vz7L8+DutD9JhbGF
IAe1Px2UMNP2r7Q/klz+Q/rtsz9dUN8yp8uyP7HEA8qmXLE/DMhe7/54rz/E
sS5uowGsPxO4dTdPdag/PPceLjnupD+oUrMHWoGhP4Fbd/NUh5w/TS1b64uE
lj/4Nv3ZjxSRP5Gb4QZ8fog/dY4B2evdfz8FqKlla31xP6ciFcYWglw/5SfV
Ph2POT8AAAAAAAAAAPf66Iw=
    "]], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{580, 237},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->112540284]
}, Open  ]],

Cell[TextData[{
 "Look at the list of ",
 Cell[BoxData[
  StyleBox["z", "TI"]], "InlineFormula"],
 "-components to verify that the lower surface is being traversed first, from \
trailing edge forward, indicative of the clockwise numbering convention for \
panels.  Note that the head of ",
 Cell[BoxData[
  StyleBox["r", "TI"]], "InlineFormula"],
 " identifies the collection of vectors as the data type CartesianVectors, \
and that the airfoil is specified using 61 data points."
}], "ExampleText",
 CellID->604996005],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Head", "[", "rE205", "]"}], ",", 
   RowBox[{"NumberOfVectors", "[", "rE205", "]"}]}], "}"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->693433935],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"CartesianVectors", ",", "61"}], "}"}]], "Output",
 ImageSize->{155, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->108252223]
}, Open  ]],

Cell["Plot the points specified in the data file.", "ExampleText",
 CellID->235318411],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gData", "=", 
  RowBox[{"PlotAirfoil", "[", 
   RowBox[{"rE205", ",", 
    RowBox[{"Joined", "\[Rule]", "False"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"PointSize", "[", "Medium", "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->109742180],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3b3O49QWBuAcTg8UiBJBS0MLXwMSxdCBRkKiQhqKTIVo6SgoKMldcANH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    "], {{0, 180}, {504, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{504, 180},
  PlotRange->{{0, 504}, {0, 180}}]], "Output",
 ImageSize->{508, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->414931036]
}, Open  ]],

Cell[TextData[{
 "Data in the file can be used to specify panel endpoints for a discretized \
airfoil, or a curve can be fit to the data using ",
 Cell[BoxData[
  ButtonBox["FitAirfoil",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/FitAirfoil"]], "InlineFormula"],
 ", and a user-specified discretization can be based on this fit using ",
 Cell[BoxData[
  ButtonBox["AirfoilSurfacePoints",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/AirfoilSurfacePoints"]], 
  "InlineFormula"],
 ".  "
}], "ExampleText",
 CellID->457083155],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->62857481],

Cell["\<\
The Clark-Y airfoil is used as an example of a data file using the \
fore-to-aft numbering convention.\
\>", "ExampleText",
 CellID->650134084],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "[", 
  RowBox[{
   RowBox[{
   "Import", "[", "\"\<Aerodynamics\\\\Airfoil Data\\\\clarky.dat\>\"", "]"}],
    ",", "4"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->230872325],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\<\"CLARK\"\>", ",", "\<\"Y\"\>", ",", "\<\"AIRFOIL\"\>"}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"61.`", ",", "61.`"}], "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.`", ",", "0.`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.0005`", ",", "0.002339`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.001`", ",", "0.0037271`"}], "}"}], ",", 
    RowBox[{"\[LeftSkeleton]", "114", "\[RightSkeleton]"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.94`", ",", 
      RowBox[{"-", "0.0028028`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.96`", ",", 
      RowBox[{"-", "0.0020683`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.97`", ",", 
      RowBox[{"-", "0.0017011`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.98`", ",", 
      RowBox[{"-", "0.0013339`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.99`", ",", 
      RowBox[{"-", "0.0009666`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1.`", ",", 
      RowBox[{"-", "0.0005993`"}]}], "}"}]}], "}"}],
  Short[#, 4]& ]], "Output",
 ImageSize->{534, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]//Short=",
 CellID->638127094]
}, Open  ]],

Cell[TextData[{
 "The function AirfoilFromDataFile converts this data to a clockwise \
numbering convention and casts the data in the form used in ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 ".  Plot the points in the data file."
}], "ExampleText",
 CellID->339076757],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rClarkY", "=", 
   RowBox[{
   "AirfoilFromDataFile", "[", 
    "\"\<Aerodynamics\\\\Airfoil Data\\\\clarky.dat\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"gData", "=", 
  RowBox[{"PlotAirfoil", "[", 
   RowBox[{"rClarkY", ",", 
    RowBox[{"Joined", "\[Rule]", "False"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"PointSize", "[", "Medium", "]"}]}], "}"}]}]}], 
   "]"}]}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->219697220],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3T+LM+UaB+A9HMTKQgvRSo+IKAg2VtsoCCKiCMfGStAinZzWzuIFLQ34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    "], {{0, 180}, {504, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{504, 180},
  PlotRange->{{0, 504}, {0, 180}}]], "Output",
 ImageSize->{508, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->644987863]
}, Open  ]],

Cell["\<\
Note that this file specifies more points on the airfoil than the previous \
example..\
\>", "ExampleText",
 CellID->119066703],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NumberOfVectors", "[", "rClarkY", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->32397896],

Cell[BoxData["121"], "Output",
 ImageSize->{25, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->11530598]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Scope",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1293636265],

Cell["\<\
Data can be downloaded directly from the UIUC Airfoil Coordinates Database.  \
From the site, choose the airfoil you wish to use, for example, the \
Eppler-1214.  Note the address that displays at the bottom of the screen when \
you place the cursor over the link to the data file. \
\>", "ExampleText",
 CellID->99156681],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"url", "=", "\"\<http://www.ae.uiuc.edu/m-selig/ads/coord/\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rE1214", "=", 
   RowBox[{"AirfoilFromDataFile", "[", 
    RowBox[{"url", "<>", "\"\<e1214.dat\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"gE1214", "=", 
  RowBox[{"PlotAirfoil", "[", 
   RowBox[{"rE1214", ",", 
    RowBox[{"Joined", "\[Rule]", "False"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"PointSize", "[", "Medium", "]"}]}], "}"}]}]}], 
   "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->906552818],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3b2OM0UWBmCvNocvIEbsXcAkIBFABloJiRQCE6FNyQgICPFdcAMrczFO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    "], {{0, 180}, {504, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{504, 180},
  PlotRange->{{0, 504}, {0, 180}}]], "Output",
 ImageSize->{508, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->93957981]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(2)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1305812373],

Cell["\<\
Individuals may contribute to the UIUC Airfoil Coordinates Database, and \
strict adherence to a data format is not enforced.  This can lead to \
surprises, so it is imperative that data for a given airfoil be checked.  In \
the examples below, some of the variations in detail that I have encountered \
are shown.\
\>", "ExampleText",
 CellID->129806726],

Cell["\<\
Members of the NACA family of four-digit airfoil can be specified in terms of \
thickness and camber properties, and this is the best approach for specifying \
a member of this family for use in panel methods.  However, some of these \
airfoils are also specified in the UIUC Airfoil Coordinates Database, and \
serve to illustrate some of the differences in detail encountered in data \
files.\
\>", "ExampleText",
 CellID->307170278],

Cell[TextData[{
 "Import the data file for the NACA-4412 airfoil from the folder Airfoil \
Data.  There are two details in this file that deviate from what is \
considered standard.  Note that the ",
 Cell[BoxData["z"], "InlineFormula"],
 "-components of the trailing-edge points are wrapped in parentheses.  Also \
note that a long trailing-edge panel has been added with an endpoint at ",
 Cell[BoxData[
  RowBox[{"x", "=", "10000"}]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->113636149],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "[", 
  RowBox[{
   RowBox[{
   "Import", "[", "\"\<Aerodynamics\\\\Airfoil Data\\\\naca4412.dat\>\"", 
    "]"}], ",", "4"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->150414795],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\<\"NACA\"\>", ",", "4412"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1.`", ",", "\<\"......\"\>"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1.`", ",", "\<\"(0.0013)\"\>"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.95`", ",", "0.0147`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.9`", ",", "0.0271`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.8`", ",", "0.0489`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.7`", ",", "0.0669`"}], "}"}], ",", 
    RowBox[{"\[LeftSkeleton]", "24", "\[RightSkeleton]"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.6`", ",", 
      RowBox[{"-", "0.01`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.7`", ",", 
      RowBox[{"-", "0.0065`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.8`", ",", 
      RowBox[{"-", "0.0039`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.9`", ",", 
      RowBox[{"-", "0.0022`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.95`", ",", 
      RowBox[{"-", "0.0016`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1.`", ",", "\<\"(-0.0013)\"\>"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"10000", ",", "0.`"}], "}"}]}], "}"}],
  Short[#, 4]& ]], "Output",
 ImageSize->{536, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]//Short=",
 CellID->28939896]
}, Open  ]],

Cell["\<\
Both of these details are modified in the function AirfoilFromDataFile to \
cast this data in standard form.  Plot the airfoil, joining points in the \
data file to show that the long trailing-edge panel has been omitted..\
\>", "ExampleText",
 CellID->220357045],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rNACA4412", "=", 
  RowBox[{
  "AirfoilFromDataFile", "[", 
   "\"\<Aerodynamics\\\\Airfoil Data\\\\naca4412.dat\>\"", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->330733392],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1.`", ",", "0.95`", ",", "0.9`", ",", "0.8`", ",", "0.7`", ",", "0.6`", 
     ",", "0.5`", ",", "0.4`", ",", "0.3`", ",", "0.25`", ",", "0.2`", ",", 
     "0.15`", ",", "0.1`", ",", "0.075`", ",", "0.05`", ",", "0.025`", ",", 
     "0.0125`", ",", "0.`", ",", "0.0125`", ",", "0.025`", ",", "0.05`", ",", 
     "0.075`", ",", "0.1`", ",", "0.15`", ",", "0.2`", ",", "0.25`", ",", 
     "0.3`", ",", "0.4`", ",", "0.5`", ",", "0.6`", ",", "0.7`", ",", "0.8`", 
     ",", "0.9`", ",", "0.95`", ",", "1.`"}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.0013`"}], ",", 
     RowBox[{"-", "0.0016`"}], ",", 
     RowBox[{"-", "0.0022`"}], ",", 
     RowBox[{"-", "0.0039`"}], ",", 
     RowBox[{"-", "0.0065`"}], ",", 
     RowBox[{"-", "0.01`"}], ",", 
     RowBox[{"-", "0.014`"}], ",", 
     RowBox[{"-", "0.018`"}], ",", 
     RowBox[{"-", "0.0226`"}], ",", 
     RowBox[{"-", "0.025`"}], ",", 
     RowBox[{"-", "0.0274`"}], ",", 
     RowBox[{"-", "0.0288`"}], ",", 
     RowBox[{"-", "0.0286`"}], ",", 
     RowBox[{"-", "0.0274`"}], ",", 
     RowBox[{"-", "0.0249`"}], ",", 
     RowBox[{"-", "0.0195`"}], ",", 
     RowBox[{"-", "0.0143`"}], ",", "0.`", ",", "0.0244`", ",", "0.0339`", 
     ",", "0.0473`", ",", "0.0576`", ",", "0.0659`", ",", "0.0789`", ",", 
     "0.088`", ",", "0.0941`", ",", "0.0976`", ",", "0.098`", ",", "0.0919`", 
     ",", "0.0814`", ",", "0.0669`", ",", "0.0489`", ",", "0.0271`", ",", 
     "0.0147`", ",", "0.0013`"}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{1., 0.95, 0.9, 0.8, 0.7, 
    0.6, 0.5, 0.4, 0.3, 0.25, 0.2, 0.15, 0.1, 0.075, 0.05, 0.025, 0.0125, 0., 
    0.0125, 0.025, 0.05, 0.075, 0.1, 0.15, 0.2, 0.25, 0.3, 0.4, 0.5, 0.6, 0.7,
     0.8, 0.9, 0.95, 
    1.}, {-0.0013, -0.0016, -0.0022, -0.0039, -0.0065, -0.01, -0.014, -0.018, \
-0.0226, -0.025, -0.0274, -0.0288, -0.0286, -0.0274, -0.0249, -0.0195, \
-0.0143, 0., 0.0244, 0.0339, 0.0473, 0.0576, 0.0659, 0.0789, 0.088, 0.0941, 
    0.0976, 0.098, 0.0919, 0.0814, 0.0669, 0.0489, 0.0271, 0.0147, 0.0013}], 
   "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{518, 118},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->44447894]
}, Open  ]],

Cell["\<\
Joining data points is useful for determining if there are problems with the \
data file.\
\>", "ExampleText",
 CellID->555424484],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gData", "=", 
  RowBox[{"PlotAirfoil", "[", "rNACA4412", "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->382272419],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQBmIQDQEf7Kd8Y4uf4RO6Pw0M3tnrOsu8fmQWtf/sGRB4
Y6+ft5hxD2vS/lkzQeCl/b3Crr4nn/Kh6p/ZW245UbZvftV+YzB4bF8tss79
YVXLfoj5D+wrX6oZcqzpgeq/aW993793et4kqPrL9r6f+4JLVKZD1V+wh6ib
CVV/0v6Z/ZL7+/jmQNUftp90ut5jf+1cqPxOe57JK5sCPedC5TfD1UPkV9qH
1a7bllQPM2+mvXa72M1z3ydD+Z1Q/b37GdAATJ79g5hHwJ8ZMHfZV5mttguP
XmgPM59/jvGiLeYr7GH2Q9y31h7mPuuCcx2X7m2wh7n/UNvy8FNGW+xh/tvl
ycOk3b7NHub/3Tt62T6I7bCHhQ/E/h32sPDzAikX22kPC1/PuQ1qh9q228PC
P+37k8SF17bYw+LnsZnUgWiFjfaw+NOo69mZzbnSHha/oNiWOjDbHhb/qqVM
szik++zR0oc9AGz1+ak=
    "]]},
  Frame->True,
  FrameLabel->{
    FormBox["\"x\"", TraditionalForm], 
    FormBox["\"z\"", TraditionalForm]},
  FrameTicks->{{{-1.2, 
      FormBox[
       RowBox[{"-", "1.2`"}], TraditionalForm]}, {-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.7999999999999999, 
      FormBox[
       RowBox[{"-", "0.7999999999999999`"}], 
       TraditionalForm]}, {-0.5999999999999999, 
      FormBox[
       RowBox[{"-", "0.5999999999999999`"}], 
       TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {1.0000000000000002`, 
      FormBox["1.0000000000000002`", TraditionalForm]}, {1.2000000000000004`, 
      FormBox["1.2000000000000004`", TraditionalForm]}, {1.4000000000000001`, 
      FormBox["1.4000000000000001`", TraditionalForm]}, {1.6, 
      FormBox["1.6`", TraditionalForm]}}, {{-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.9, 
      FormBox[
       RowBox[{"-", "0.9`"}], TraditionalForm]}, {-0.8, 
      FormBox[
       RowBox[{"-", "0.8`"}], TraditionalForm]}, {-0.7, 
      FormBox[
       RowBox[{"-", "0.7`"}], TraditionalForm]}, {-0.6, 
      FormBox[
       RowBox[{"-", "0.6`"}], TraditionalForm]}, {-0.5, 
      FormBox[
       RowBox[{"-", "0.5`"}], TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.29999999999999993`, 
      FormBox[
       RowBox[{"-", "0.29999999999999993`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], 
       TraditionalForm]}, {-0.09999999999999998, 
      FormBox[
       RowBox[{"-", "0.09999999999999998`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.10000000000000009`, 
      FormBox["0.10000000000000009`", TraditionalForm]}, {
     0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.30000000000000004`, 
      FormBox["0.30000000000000004`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.5, 
      FormBox["0.5`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.7000000000000002, 
      FormBox["0.7000000000000002`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {0.9000000000000001, 
      FormBox["0.9000000000000001`", TraditionalForm]}, {1., 
      FormBox["1.`", TraditionalForm]}}, None, {{-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.9, 
      FormBox[
       RowBox[{"-", "0.9`"}], TraditionalForm]}, {-0.8, 
      FormBox[
       RowBox[{"-", "0.8`"}], TraditionalForm]}, {-0.7, 
      FormBox[
       RowBox[{"-", "0.7`"}], TraditionalForm]}, {-0.6, 
      FormBox[
       RowBox[{"-", "0.6`"}], TraditionalForm]}, {-0.5, 
      FormBox[
       RowBox[{"-", "0.5`"}], TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.29999999999999993`, 
      FormBox[
       RowBox[{"-", "0.29999999999999993`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], 
       TraditionalForm]}, {-0.09999999999999998, 
      FormBox[
       RowBox[{"-", "0.09999999999999998`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.10000000000000009`, 
      FormBox["0.10000000000000009`", TraditionalForm]}, {
     0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.30000000000000004`, 
      FormBox["0.30000000000000004`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.5, 
      FormBox["0.5`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.7000000000000002, 
      FormBox["0.7000000000000002`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {0.9000000000000001, 
      FormBox["0.9000000000000001`", TraditionalForm]}, {1., 
      FormBox["1.`", TraditionalForm]}}},
  ImageSize->{504., 180.},
  PlotRange->{{-0.05, 1.05}, {-0.1, 0.201}},
  PlotRangeClipping->True,
  RotateLabel->False]], "Output",
 ImageSize->{508, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->197870475]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->15098627],

Cell["\<\
Next, consider the data file for the NACA-4424 airfoil imported from the UIUC \
Airfoil Database.  \
\>", "ExampleText",
 CellID->571482826],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "[", 
  RowBox[{
   RowBox[{"Import", "[", 
    RowBox[{"url", "<>", "\"\<naca4424.dat\>\""}], "]"}], ",", "4"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->537730225],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\<\"NACA\"\>", ",", "4424"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1.`", ",", "\<\".......\"\>"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.95196`", ",", "0.0224`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.9032`", ",", "0.04099`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.80464`", ",", "0.07447`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.70487`", ",", "0.10312`"}], "}"}], ",", 
    RowBox[{"\[LeftSkeleton]", "25", "\[RightSkeleton]"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.69513`", ",", 
      RowBox[{"-", "0.04312`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.79536`", ",", 
      RowBox[{"-", "0.03003`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.8968`", ",", 
      RowBox[{"-", "0.01655`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.94804`", ",", 
      RowBox[{"-", "0.00964`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1.`", ",", "0.`"}], "}"}]}], "}"}],
  Short[#, 4]& ]], "Output",
 ImageSize->{491, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]//Short=",
 CellID->8621102]
}, Open  ]],

Cell["\<\
At first glance this may seem plausible, but look at the plot of the airfoil. \
 \
\>", "ExampleText",
 CellID->38787840],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rNACA4424", "=", 
   RowBox[{"AirfoilFromDataFile", "[", 
    RowBox[{"url", "<>", "\"\<naca4424.dat\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"gData", "=", 
  RowBox[{"PlotAirfoil", "[", "rNACA4424", "]"}]}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->20760879],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQDQEf7GEsrxmZv8PD3tmfEr33VGlf8/6uDQ9fTt30
xj736L9N1Z8m7M+unXhhWvFLe4aSGfr6B+btP/WXz7XR7pn9z7TZ0peFl+3P
W8y4h1XosX3CWcYmy6o1+2vXbUuqv3nffm9+zduZqhv3z5oJAjft65d08Kyu
2Lw/4/ROkfCpl+2v69/gvS22dX/+7gsxyydesHe3dVls3bF1f5HxnYbz/Kft
zy9YWN/UvXX/zah4lS1Pj9jXsmYeW/Ryy/65GeGKT9X32ld3uJULWG/evyd8
rc+PpdvsJ6p7XvfZt3H/GpmoFOv76+1Pnoi8cZlv/X77IJe20D0L7T0bZkVt
u7Z8/8b9b+bZ6Eyx/3KY4+HFYwv3M6CBhembXxVvLbU/L2K1fqP3EvtM2VBf
gdJ++2l2JY61p9fYt4vdPPc9eLG974+ldfdCttiHyIJcvN4+c+Ue2YdbdthP
P3Vb0I97m33BxkVslw322PdyszttajhoDwnXA/YH/4dtSlY+YS8msWnX1eJD
9kqdcW4b75yz/wcK1omH7f/NWhPIf/GSfevGVgV21SP2sPCrjZHWOvbzsP3B
FUv8HIQf2Ouqmclfbztk/+NQyqqEkMf2rlo9uiyWB+yZz+9t9+57Zn/TaUKz
UNou+xNbFybN2f/SvrcKFGCb7QVebl/P/PyN/RTht1pL/iyxbzZJvlhS9s7+
+K4dvWwfptkDAED/C4k=
    "]]},
  Frame->True,
  FrameLabel->{
    FormBox["\"x\"", TraditionalForm], 
    FormBox["\"z\"", TraditionalForm]},
  FrameTicks->{{{-1.2, 
      FormBox[
       RowBox[{"-", "1.2`"}], TraditionalForm]}, {-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.7999999999999999, 
      FormBox[
       RowBox[{"-", "0.7999999999999999`"}], 
       TraditionalForm]}, {-0.5999999999999999, 
      FormBox[
       RowBox[{"-", "0.5999999999999999`"}], 
       TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {1.0000000000000002`, 
      FormBox["1.0000000000000002`", TraditionalForm]}, {1.2000000000000004`, 
      FormBox["1.2000000000000004`", TraditionalForm]}, {1.4000000000000001`, 
      FormBox["1.4000000000000001`", TraditionalForm]}, {1.6, 
      FormBox["1.6`", TraditionalForm]}}, {{-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.9, 
      FormBox[
       RowBox[{"-", "0.9`"}], TraditionalForm]}, {-0.8, 
      FormBox[
       RowBox[{"-", "0.8`"}], TraditionalForm]}, {-0.7, 
      FormBox[
       RowBox[{"-", "0.7`"}], TraditionalForm]}, {-0.6, 
      FormBox[
       RowBox[{"-", "0.6`"}], TraditionalForm]}, {-0.5, 
      FormBox[
       RowBox[{"-", "0.5`"}], TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.29999999999999993`, 
      FormBox[
       RowBox[{"-", "0.29999999999999993`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], 
       TraditionalForm]}, {-0.09999999999999998, 
      FormBox[
       RowBox[{"-", "0.09999999999999998`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.10000000000000009`, 
      FormBox["0.10000000000000009`", TraditionalForm]}, {
     0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.30000000000000004`, 
      FormBox["0.30000000000000004`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.5, 
      FormBox["0.5`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.7000000000000002, 
      FormBox["0.7000000000000002`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {0.9000000000000001, 
      FormBox["0.9000000000000001`", TraditionalForm]}, {1., 
      FormBox["1.`", TraditionalForm]}}, None, {{-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.9, 
      FormBox[
       RowBox[{"-", "0.9`"}], TraditionalForm]}, {-0.8, 
      FormBox[
       RowBox[{"-", "0.8`"}], TraditionalForm]}, {-0.7, 
      FormBox[
       RowBox[{"-", "0.7`"}], TraditionalForm]}, {-0.6, 
      FormBox[
       RowBox[{"-", "0.6`"}], TraditionalForm]}, {-0.5, 
      FormBox[
       RowBox[{"-", "0.5`"}], TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.29999999999999993`, 
      FormBox[
       RowBox[{"-", "0.29999999999999993`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], 
       TraditionalForm]}, {-0.09999999999999998, 
      FormBox[
       RowBox[{"-", "0.09999999999999998`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.10000000000000009`, 
      FormBox["0.10000000000000009`", TraditionalForm]}, {
     0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.30000000000000004`, 
      FormBox["0.30000000000000004`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.5, 
      FormBox["0.5`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.7000000000000002, 
      FormBox["0.7000000000000002`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {0.9000000000000001, 
      FormBox["0.9000000000000001`", TraditionalForm]}, {1., 
      FormBox["1.`", TraditionalForm]}}},
  ImageSize->{504., 180.},
  PlotRange->{{-0.05, 1.05}, {-0.1, 0.201}},
  PlotRangeClipping->True,
  RotateLabel->False]], "Output",
 ImageSize->{508, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->318348817]
}, Open  ]],

Cell["\<\
Although NACA four-digit airfoil defined by thickness and camber properties \
is not closed at the trailing edge, this is something different!  Add a point \
on upper surface trailing edge point corresponding to the trailing-edge point \
on the lower surface.\
\>", "ExampleText",
 CellID->627377214],

Cell[CellGroupData[{

Cell["\<\
rNACA4424=Append[rNACA4424,{1.,0.}];
PlotAirfoil[rNACA4424]\
\>", "Input",
 CellLabel->"In[3]:=",
 CellID->390201010],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQBmIQDQEf7GEsrxmZv8PD3tmfEr33VGlf8/6uDQ9fTt30
xj736L9N1Z8m7M+unXhhWvFLe4aSGfr6B+btP/WXz7XR7pn9z7TZ0peFl+3P
W8y4h1XosX3CWcYmy6o1+2vXbUuqv3nffm9+zduZqhv3z5oJAjft65d08Kyu
2Lw/4/ROkfCpl+2v69/gvS22dX/+7gsxyydesHe3dVls3bF1f5HxnYbz/Kft
zy9YWN/UvXX/zah4lS1Pj9jXsmYeW/Ryy/65GeGKT9X32ld3uJULWG/evyd8
rc+PpdvsJ6p7XvfZt3H/GpmoFOv76+1Pnoi8cZlv/X77IJe20D0L7T0bZkVt
u7Z8/8b9b+bZ6Eyx/3KY4+HFYwv3M6CBhembXxVvLbU/L2K1fqP3EvtM2VBf
gdJ++2l2JY61p9fYt4vdPPc9eLG974+ldfdCttiHyIJcvN4+c+Ue2YdbdthP
P3Vb0I97m33BxkVslw322PdyszttajhoDwnXA/YH/4dtSlY+YS8msWnX1eJD
9kqdcW4b75yz/wcK1omH7f/NWhPIf/GSfevGVgV21SP2sPCrjZHWOvbzsP3B
FUv8HIQf2Ouqmclfbztk/+NQyqqEkMf2rlo9uiyWB+yZz+9t9+57Zn/TaUKz
UNou+xNbFybN2f/SvrcKFGCb7QVebl/P/PyN/RTht1pL/iyxbzZJvlhS9s7+
+K4dvWwfptmjpw8AB20MuQ==
    "]]},
  Frame->True,
  FrameLabel->{
    FormBox["\"x\"", TraditionalForm], 
    FormBox["\"z\"", TraditionalForm]},
  FrameTicks->{{{-1.2, 
      FormBox[
       RowBox[{"-", "1.2`"}], TraditionalForm]}, {-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.7999999999999999, 
      FormBox[
       RowBox[{"-", "0.7999999999999999`"}], 
       TraditionalForm]}, {-0.5999999999999999, 
      FormBox[
       RowBox[{"-", "0.5999999999999999`"}], 
       TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {1.0000000000000002`, 
      FormBox["1.0000000000000002`", TraditionalForm]}, {1.2000000000000004`, 
      FormBox["1.2000000000000004`", TraditionalForm]}, {1.4000000000000001`, 
      FormBox["1.4000000000000001`", TraditionalForm]}, {1.6, 
      FormBox["1.6`", TraditionalForm]}}, {{-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.9, 
      FormBox[
       RowBox[{"-", "0.9`"}], TraditionalForm]}, {-0.8, 
      FormBox[
       RowBox[{"-", "0.8`"}], TraditionalForm]}, {-0.7, 
      FormBox[
       RowBox[{"-", "0.7`"}], TraditionalForm]}, {-0.6, 
      FormBox[
       RowBox[{"-", "0.6`"}], TraditionalForm]}, {-0.5, 
      FormBox[
       RowBox[{"-", "0.5`"}], TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.29999999999999993`, 
      FormBox[
       RowBox[{"-", "0.29999999999999993`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], 
       TraditionalForm]}, {-0.09999999999999998, 
      FormBox[
       RowBox[{"-", "0.09999999999999998`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.10000000000000009`, 
      FormBox["0.10000000000000009`", TraditionalForm]}, {
     0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.30000000000000004`, 
      FormBox["0.30000000000000004`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.5, 
      FormBox["0.5`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.7000000000000002, 
      FormBox["0.7000000000000002`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {0.9000000000000001, 
      FormBox["0.9000000000000001`", TraditionalForm]}, {1., 
      FormBox["1.`", TraditionalForm]}}, None, {{-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.9, 
      FormBox[
       RowBox[{"-", "0.9`"}], TraditionalForm]}, {-0.8, 
      FormBox[
       RowBox[{"-", "0.8`"}], TraditionalForm]}, {-0.7, 
      FormBox[
       RowBox[{"-", "0.7`"}], TraditionalForm]}, {-0.6, 
      FormBox[
       RowBox[{"-", "0.6`"}], TraditionalForm]}, {-0.5, 
      FormBox[
       RowBox[{"-", "0.5`"}], TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.29999999999999993`, 
      FormBox[
       RowBox[{"-", "0.29999999999999993`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], 
       TraditionalForm]}, {-0.09999999999999998, 
      FormBox[
       RowBox[{"-", "0.09999999999999998`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.10000000000000009`, 
      FormBox["0.10000000000000009`", TraditionalForm]}, {
     0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.30000000000000004`, 
      FormBox["0.30000000000000004`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.5, 
      FormBox["0.5`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.7000000000000002, 
      FormBox["0.7000000000000002`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {0.9000000000000001, 
      FormBox["0.9000000000000001`", TraditionalForm]}, {1., 
      FormBox["1.`", TraditionalForm]}}},
  ImageSize->{504., 180.},
  PlotRange->{{-0.05, 1.05}, {-0.1, 0.201}},
  PlotRangeClipping->True,
  RotateLabel->False]], "Output",
 ImageSize->{508, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->19944675]
}, Open  ]],

Cell["\<\
Always examine the data in the file and plot the airfoil to avoid surprises.  \
If you encounter UIUC data files that present problems not covered in this \
section, please contact me at rlf@ufl.edu.\
\>", "ExampleText",
 CellID->39125373]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[{
 StyleBox[ButtonBox["AirfoilSurfacePoints",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/AirfoilSurfacePoints"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["FitAirfoil",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/FitAirfoil"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["NACA4DigitAirfoil",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/NACA4DigitAirfoil"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["PlotAirfoil",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/PlotAirfoil"],
  FontFamily->"Verdana"],
 " "
}], "SeeAlso",
 CellID->745892494]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["1.2 Airfoils From Data Files",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Aerodynamics/tutorial/AirfoilsFromDataFiles"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["AirfoilGeometry",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/AirfoilGeometry"]], "MoreAbout",
 CellID->275696692]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["RELATED LINKS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "RelatedLinksSection",
 CellID->1584193535],

Cell[TextData[ButtonBox["UIUC Airfoil Data Site",
 BaseStyle->"Hyperlink",
 ButtonData->{
   URL["http://www.ae.uiuc.edu/m-selig/ads.html"], None}]], "RelatedLinks",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"AirfoilFromDataFile - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 9, 58, 10.4868000}", "context" -> 
    "Aerodynamics`AirfoilGeometry`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "AirfoilFromDataFile[filename] imports data from a file and rearranges \
the data to conform to the conventions used in Aerodynamics.", 
    "synonyms" -> {}, "title" -> "AirfoilFromDataFile", "type" -> "Symbol", 
    "uri" -> "Aerodynamics/ref/AirfoilFromDataFile"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7048, 201, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->114545432]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 65669, 1744}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[612, 21, 76, 1, 70, "SymbolColorBar"],
Cell[691, 24, 191, 5, 70, "LinkTrail"],
Cell[885, 31, 3426, 78, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4336, 113, 62, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[4401, 116, 657, 19, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5095, 140, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->346777622],
Cell[5678, 159, 250, 8, 70, "Notes",
 CellID->208986483],
Cell[5931, 169, 422, 9, 70, "Notes",
 CellID->24936737],
Cell[6356, 180, 578, 13, 70, "Notes",
 CellID->431408632],
Cell[6937, 195, 74, 1, 70, "Notes",
 CellID->529540534]
}, Closed]],
Cell[CellGroupData[{
Cell[7048, 201, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->114545432],
Cell[CellGroupData[{
Cell[7534, 218, 147, 5, 70, "ExampleSection",
 CellID->59937985],
Cell[7684, 225, 61, 1, 70, "ExampleText",
 CellID->701079788],
Cell[7748, 228, 99, 3, 70, "Input",
 CellID->18639833],
Cell[7850, 233, 250, 5, 70, "ExampleText",
 CellID->411631528],
Cell[CellGroupData[{
Cell[8125, 242, 607, 18, 70, "Input",
 CellID->161538214],
Cell[8735, 262, 868, 18, 88, "Output",
 CellID->180581880]
}, Open  ]],
Cell[9618, 283, 161, 4, 70, "ExampleText",
 CellID->158695459],
Cell[CellGroupData[{
Cell[9804, 291, 213, 7, 70, "Input",
 CellID->123334517],
Cell[10020, 300, 1188, 36, 71, "Output",
 CellID->13352816]
}, Open  ]],
Cell[11223, 339, 222, 5, 70, "ExampleText",
 CellID->36460158],
Cell[CellGroupData[{
Cell[11470, 348, 196, 6, 70, "Input",
 CellID->317289154],
Cell[11669, 356, 4579, 92, 258, "Output",
 CellID->112540284]
}, Open  ]],
Cell[16263, 451, 519, 12, 70, "ExampleText",
 CellID->604996005],
Cell[CellGroupData[{
Cell[16807, 467, 198, 6, 70, "Input",
 CellID->693433935],
Cell[17008, 475, 220, 7, 36, "Output",
 CellID->108252223]
}, Open  ]],
Cell[17243, 485, 86, 1, 70, "ExampleText",
 CellID->235318411],
Cell[CellGroupData[{
Cell[17354, 490, 357, 11, 28, "Input",
 CellID->109742180],
Cell[17714, 503, 4001, 73, 201, "Output",
 CellID->414931036]
}, Open  ]],
Cell[21730, 579, 560, 15, 70, "ExampleText",
 CellID->457083155],
Cell[CellGroupData[{
Cell[22315, 598, 124, 3, 70, "ExampleDelimiter",
 CellID->62857481],
Cell[22442, 603, 153, 4, 70, "ExampleText",
 CellID->650134084],
Cell[CellGroupData[{
Cell[22620, 611, 215, 7, 70, "Input",
 CellID->230872325],
Cell[22838, 620, 1283, 40, 71, "Output",
 CellID->638127094]
}, Open  ]],
Cell[24136, 663, 278, 7, 70, "ExampleText",
 CellID->339076757],
Cell[CellGroupData[{
Cell[24439, 674, 543, 17, 47, "Input",
 CellID->219697220],
Cell[24985, 693, 4119, 75, 201, "Output",
 CellID->644987863]
}, Open  ]],
Cell[29119, 771, 137, 4, 70, "ExampleText",
 CellID->119066703],
Cell[CellGroupData[{
Cell[29281, 779, 116, 3, 70, "Input",
 CellID->32397896],
Cell[29400, 784, 159, 5, 36, "Output",
 CellID->11530598]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29620, 796, 221, 7, 70, "ExampleSection",
 CellID->1293636265],
Cell[29844, 805, 332, 6, 70, "ExampleText",
 CellID->99156681],
Cell[CellGroupData[{
Cell[30201, 815, 649, 19, 70, "Input",
 CellID->906552818],
Cell[30853, 836, 4000, 73, 70, "Output",
 CellID->93957981]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[34902, 915, 231, 7, 70, "ExampleSection",
 CellID->1305812373],
Cell[35136, 924, 365, 7, 70, "ExampleText",
 CellID->129806726],
Cell[35504, 933, 445, 8, 70, "ExampleText",
 CellID->307170278],
Cell[35952, 943, 499, 11, 70, "ExampleText",
 CellID->113636149],
Cell[CellGroupData[{
Cell[36476, 958, 218, 7, 70, "Input",
 CellID->150414795],
Cell[36697, 967, 1399, 43, 71, "Output",
 CellID->28939896]
}, Open  ]],
Cell[38111, 1013, 273, 5, 70, "ExampleText",
 CellID->220357045],
Cell[CellGroupData[{
Cell[38409, 1022, 204, 6, 70, "Input",
 CellID->330733392],
Cell[38616, 1030, 2326, 50, 139, "Output",
 CellID->44447894]
}, Open  ]],
Cell[40957, 1083, 140, 4, 70, "ExampleText",
 CellID->555424484],
Cell[CellGroupData[{
Cell[41122, 1091, 142, 4, 70, "Input",
 CellID->382272419],
Cell[41267, 1097, 5462, 125, 201, "Output",
 CellID->197870475]
}, Open  ]],
Cell[CellGroupData[{
Cell[46766, 1227, 124, 3, 70, "ExampleDelimiter",
 CellID->15098627],
Cell[46893, 1232, 150, 4, 70, "ExampleText",
 CellID->571482826],
Cell[CellGroupData[{
Cell[47068, 1240, 208, 7, 70, "Input",
 CellID->537730225],
Cell[47279, 1249, 1185, 36, 71, "Output",
 CellID->8621102]
}, Open  ]],
Cell[48479, 1288, 131, 4, 70, "ExampleText",
 CellID->38787840],
Cell[CellGroupData[{
Cell[48635, 1296, 316, 9, 70, "Input",
 CellID->20760879],
Cell[48954, 1307, 5706, 129, 201, "Output",
 CellID->318348817]
}, Open  ]],
Cell[54675, 1439, 310, 6, 70, "ExampleText",
 CellID->627377214],
Cell[CellGroupData[{
Cell[55010, 1449, 127, 5, 70, "Input",
 CellID->390201010],
Cell[55140, 1456, 5709, 129, 201, "Output",
 CellID->19944675]
}, Open  ]],
Cell[60864, 1588, 249, 5, 70, "ExampleText",
 CellID->39125373]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[61174, 1600, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[61594, 1614, 651, 22, 70, "SeeAlso",
 CellID->745892494]
}, Open  ]],
Cell[CellGroupData[{
Cell[62282, 1641, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[62704, 1655, 180, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[62921, 1664, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[63343, 1678, 155, 3, 70, "MoreAbout",
 CellID->275696692]
}, Open  ]],
Cell[CellGroupData[{
Cell[63535, 1686, 427, 12, 70, "RelatedLinksSection",
 CellID->1584193535],
Cell[63965, 1700, 186, 4, 70, "RelatedLinks",
 CellID->1038487239]
}, Open  ]],
Cell[64166, 1707, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

