(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     26456,        818]
NotebookOptionsPosition[     21832,        663]
NotebookOutlinePosition[     23484,        709]
CellTagsIndexPosition[     23399,        704]
WindowTitle->Components - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"A1  Data Type CartesianVectors\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"CartesianVectors\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/CartesianVectors"], "\<\"MakeCartesianVectors\
\"\>":>Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/MakeCartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"CartesianVectors\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/Components\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/Components"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
Components.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/Components", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Components", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Components", "[", 
       StyleBox["v", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]selects the lists of components from a collection of \
vectors of the data type ",
     Cell[BoxData[
      ButtonBox["CartesianVectors",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/CartesianVectors"]], 
      "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->116507275],

Cell["New in 1.0   |   Last modified in 1.1", "Notes",
 CellID->529540534]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->426766302],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->495216652],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->371969155],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->10413192],

Cell["\<\
Specify a list of components for a collection of three-dimensional vectors.  \
There are five vectors in this collection.\
\>", "ExampleText",
 CellID->22505329],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"uList", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Array", "[", 
     RowBox[{"ux", ",", "5"}], "]"}], ",", 
    RowBox[{"Array", "[", 
     RowBox[{"uy", ",", "5"}], "]"}], ",", 
    RowBox[{"Array", "[", 
     RowBox[{"uz", ",", "5"}], "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->43223280],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ux", "[", "1", "]"}], ",", 
     RowBox[{"ux", "[", "2", "]"}], ",", 
     RowBox[{"ux", "[", "3", "]"}], ",", 
     RowBox[{"ux", "[", "4", "]"}], ",", 
     RowBox[{"ux", "[", "5", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uy", "[", "1", "]"}], ",", 
     RowBox[{"uy", "[", "2", "]"}], ",", 
     RowBox[{"uy", "[", "3", "]"}], ",", 
     RowBox[{"uy", "[", "4", "]"}], ",", 
     RowBox[{"uy", "[", "5", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uz", "[", "1", "]"}], ",", 
     RowBox[{"uz", "[", "2", "]"}], ",", 
     RowBox[{"uz", "[", "3", "]"}], ",", 
     RowBox[{"uz", "[", "4", "]"}], ",", 
     RowBox[{"uz", "[", "5", "]"}]}], "}"}]}], "}"}]], "Output",
 ImageSize->{496, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->295488980]
}, Open  ]],

Cell["Construct the data type CartesianVectors.", "ExampleText",
 CellID->315076144],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"u", "=", 
  RowBox[{"MakeCartesianVectors", "[", "uList", "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->843452585],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ux", "[", "1", "]"}], ",", 
     RowBox[{"ux", "[", "2", "]"}], ",", 
     RowBox[{"ux", "[", "3", "]"}], ",", 
     RowBox[{"ux", "[", "4", "]"}], ",", 
     RowBox[{"ux", "[", "5", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uy", "[", "1", "]"}], ",", 
     RowBox[{"uy", "[", "2", "]"}], ",", 
     RowBox[{"uy", "[", "3", "]"}], ",", 
     RowBox[{"uy", "[", "4", "]"}], ",", 
     RowBox[{"uy", "[", "5", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uz", "[", "1", "]"}], ",", 
     RowBox[{"uz", "[", "2", "]"}], ",", 
     RowBox[{"uz", "[", "3", "]"}], ",", 
     RowBox[{"uz", "[", "4", "]"}], ",", 
     RowBox[{"uz", "[", "5", "]"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{
     $CellContext`ux[1], 
     $CellContext`ux[2], 
     $CellContext`ux[3], 
     $CellContext`ux[4], 
     $CellContext`ux[5]}, {
     $CellContext`uy[1], 
     $CellContext`uy[2], 
     $CellContext`uy[3], 
     $CellContext`uy[4], 
     $CellContext`uy[5]}, {
     $CellContext`uz[1], 
     $CellContext`uz[2], 
     $CellContext`uz[3], 
     $CellContext`uz[4], 
     $CellContext`uz[5]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{487, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->596101656]
}, Open  ]],

Cell[TextData[{
 "Note the head of ",
 Cell[BoxData[
  StyleBox["u", "TI"]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->67032196],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Head", "[", "u", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->451022405],

Cell[BoxData["CartesianVectors"], "Output",
 ImageSize->{116, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->205716098]
}, Open  ]],

Cell["The selector Components returns the original list.", "ExampleText",
 CellID->436391113],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Components", "[", "u", "]"}], "===", "uList"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->176079663],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->40979646]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Scope",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->5861271],

Cell["\<\
Sometimes, it is convenient to arrange the components of the collection of \
vectors as matrices.\
\>", "ExampleText",
 CellID->56022862],

Cell[BoxData[
 RowBox[{
  RowBox[{"vList", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Array", "[", 
      RowBox[{"vx", ",", 
       RowBox[{"{", 
        RowBox[{"4", ",", "5"}], "}"}]}], "]"}], ",", 
     RowBox[{"Array", "[", 
      RowBox[{"vy", ",", 
       RowBox[{"{", 
        RowBox[{"4", ",", "5"}], "}"}]}], "]"}], ",", 
     RowBox[{"Array", "[", 
      RowBox[{"vz", ",", 
       RowBox[{"{", 
        RowBox[{"4", ",", "5"}], "}"}]}], "]"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->13477226],

Cell["\<\
Construct a collection of vectors of the data type CartesianVectors and \
display it in matrix form.\
\>", "ExampleText",
 CellID->774807007],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"v", "=", 
    RowBox[{"MakeCartesianVectors", "[", "vList", "]"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->294358663],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnT1y4zoWhT01K5lteA+TzAq6XuDqbBwqe6FCO3Po0KFrknboUKEW0EGH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    "], {{0, 177}, {333, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{333, 177},
  PlotRange->{{0, 333}, {0, 177}}]], "Output",
 ImageSize->{337, 177},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->95971085]
}, Open  ]],

Cell[TextData[{
 "Note the head of ",
 Cell[BoxData[
  StyleBox["v", "TI"]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->764594328],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Head", "[", "v", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->230123782],

Cell[BoxData["CartesianVectors"], "Output",
 ImageSize->{116, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->286774391]
}, Open  ]],

Cell["The selector Components returns the original list.", "ExampleText",
 CellID->7277960],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Components", "[", "v", "]"}], "===", "vList"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->341417852],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->444789624]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[{
 StyleBox[ButtonBox["CartesianVectors",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/CartesianVectors"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["MakeCartesianVectors",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/MakeCartesianVectors"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->88624347]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[{
 ButtonBox["A1",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox["  ",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox["Data",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox[" ",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox["Type",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox[" ",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox["CartesianVectors",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"]
}], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["CartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/CartesianVectors"]], "MoreAbout",
 CellID->17577746]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Components - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 9, 58, 32.7480000}", "context" -> 
    "Aerodynamics`CartesianVectors`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "Components[v] selects the lists of components from a collection of \
vectors of the data type CartesianVectors.", "synonyms" -> {}, "title" -> 
    "Components", "type" -> "Symbol", "uri" -> "Aerodynamics/ref/Components"},
   "LinkTrails" -> "", "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5457, 160, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->426766302]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 23256, 697}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 76, 1, 70, "SymbolColorBar"],
Cell[682, 24, 191, 5, 70, "LinkTrail"],
Cell[876, 31, 3169, 74, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4070, 109, 53, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[4126, 112, 600, 18, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4763, 135, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->116507275],
Cell[5346, 154, 74, 1, 70, "Notes",
 CellID->529540534]
}, Closed]],
Cell[CellGroupData[{
Cell[5457, 160, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->426766302],
Cell[CellGroupData[{
Cell[5943, 177, 148, 5, 70, "ExampleSection",
 CellID->495216652],
Cell[6094, 184, 132, 6, 70, "ExampleText",
 CellID->371969155],
Cell[6229, 192, 99, 3, 70, "Input",
 CellID->10413192],
Cell[6331, 197, 171, 4, 70, "ExampleText",
 CellID->22505329],
Cell[CellGroupData[{
Cell[6527, 205, 335, 11, 70, "Input",
 CellID->43223280],
Cell[6865, 218, 931, 28, 54, "Output",
 CellID->295488980]
}, Open  ]],
Cell[7811, 249, 84, 1, 70, "ExampleText",
 CellID->315076144],
Cell[CellGroupData[{
Cell[7920, 254, 143, 4, 70, "Input",
 CellID->843452585],
Cell[8066, 260, 1438, 46, 54, "Output",
 CellID->596101656]
}, Open  ]],
Cell[9519, 309, 137, 6, 70, "ExampleText",
 CellID->67032196],
Cell[CellGroupData[{
Cell[9681, 319, 100, 3, 70, "Input",
 CellID->451022405],
Cell[9784, 324, 174, 5, 36, "Output",
 CellID->205716098]
}, Open  ]],
Cell[9973, 332, 93, 1, 70, "ExampleText",
 CellID->436391113],
Cell[CellGroupData[{
Cell[10091, 337, 135, 4, 70, "Input",
 CellID->176079663],
Cell[10229, 343, 160, 5, 36, "Output",
 CellID->40979646]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10438, 354, 218, 7, 70, "ExampleSection",
 CellID->5861271],
Cell[10659, 363, 147, 4, 70, "ExampleText",
 CellID->56022862],
Cell[10809, 369, 532, 18, 70, "Input",
 CellID->13477226],
Cell[11344, 389, 151, 4, 70, "ExampleText",
 CellID->774807007],
Cell[CellGroupData[{
Cell[11520, 397, 205, 7, 70, "Input",
 CellID->294358663],
Cell[11728, 406, 6485, 114, 70, "Output",
 CellID->95971085]
}, Open  ]],
Cell[18228, 523, 138, 6, 70, "ExampleText",
 CellID->764594328],
Cell[CellGroupData[{
Cell[18391, 533, 100, 3, 70, "Input",
 CellID->230123782],
Cell[18494, 538, 174, 5, 36, "Output",
 CellID->286774391]
}, Open  ]],
Cell[18683, 546, 91, 1, 70, "ExampleText",
 CellID->7277960],
Cell[CellGroupData[{
Cell[18799, 551, 135, 4, 70, "Input",
 CellID->341417852],
Cell[18937, 557, 161, 5, 36, "Output",
 CellID->444789624]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19159, 569, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[19579, 583, 356, 11, 70, "SeeAlso",
 CellID->88624347]
}, Open  ]],
Cell[CellGroupData[{
Cell[19972, 599, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[20394, 613, 781, 23, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[21212, 641, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[21634, 655, 156, 3, 70, "MoreAbout",
 CellID->17577746]
}, Open  ]],
Cell[21805, 661, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

