(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     14852,        490]
NotebookOptionsPosition[     11481,        381]
NotebookOutlinePosition[     13118,        427]
CellTagsIndexPosition[     13033,        422]
WindowTitle->CosineSpacing - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"1.1 Introduction to Airfoil Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/IntroductionToAirfoilGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Layout\"\>":>Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/Layout"], "\<\"NDiscretizeUnitSegment\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/NDiscretizeUnitSegment"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AirfoilGeometry\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/AirfoilGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/CosineSpacing\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/CosineSpacing"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
CosineSpacing.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/CosineSpacing", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["CosineSpacing", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["CosineSpacing"], "InlineFormula"],
     "\[LineSeparator]is a value for the option ",
     Cell[BoxData[
      ButtonBox["Layout",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/Layout"]], "InlineFormula"],
     " in the function ",
     Cell[BoxData[
      ButtonBox["NDiscretizeUnitSegment",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/NDiscretizeUnitSegment"]], 
      "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->88979539],

Cell[TextData[{
 "The other two values for the option ",
 Cell[BoxData[
  ButtonBox["Layout",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/Layout"]], "InlineFormula"],
 " are ",
 Cell[BoxData[
  ButtonBox["ConstantSpacing",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/ConstantSpacing"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["HalfCosineSpacing",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/HalfCosineSpacing"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069],

Cell["New in 1.0", "Notes",
 CellID->529540534]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->494162855],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->121029181],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->885726909],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->237225796],

Cell[TextData[{
 "Use NDiscretizeUnitSegment to subdivide the unit segment into ",
 Cell[BoxData[
  StyleBox["n", "TI"]], "InlineFormula"],
 " pieces."
}], "ExampleText",
 CellID->346983563],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"xList", "=", 
  RowBox[{"NDiscretizeUnitSegment", "[", 
   RowBox[{"n", ",", 
    RowBox[{"Layout", "\[Rule]", "CosineSpacing"}]}], "]"}]}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->86796878],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.`", ",", "0.024471741852423234`", ",", "0.09549150281252627`", ",", 
   "0.2061073738537635`", ",", "0.3454915028125263`", ",", 
   "0.49999999999999994`", ",", "0.6545084971874737`", ",", 
   "0.7938926261462365`", ",", "0.9045084971874737`", ",", 
   "0.9755282581475768`", ",", "1.`"}], "}"}]], "Output",
 ImageSize->{333, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->163303347]
}, Open  ]],

Cell["\<\
The value CosineSpacing for the option Layout concentrates points near both \
ends of the unit segment as shown below.\
\>", "ExampleText",
 CellID->62222020],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
     RowBox[{"Point", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"xList", ",", 
         RowBox[{"Table", "[", 
          RowBox[{"0", ",", 
           RowBox[{"{", 
            RowBox[{"n", "+", "1"}], "}"}]}], "]"}]}], "}"}], "]"}], "]"}]}], 
    "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"6", " ", "72"}]}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.1"}], ",", "0.1"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->40554313],

Cell[BoxData[
 GraphicsBox[
  {PointSize[Medium], 
   PointBox[{{0., 0}, {0.024471741852423234`, 0}, {0.09549150281252627, 0}, {
     0.2061073738537635, 0}, {0.3454915028125263, 0}, {
     0.49999999999999994`, 0}, {0.6545084971874737, 0}, {
     0.7938926261462365, 0}, {0.9045084971874737, 0}, {
     0.9755282581475768, 0}, {1., 0}}]},
  ImageSize->432,
  PlotRange->{-0.1, 0.1}]], "Output",
 ImageSize->{436, 83},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->186015085]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[{
 StyleBox[ButtonBox["Layout",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/Layout"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["NDiscretizeUnitSegment",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/NDiscretizeUnitSegment"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->447834129]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["1.1 Introduction to Airfoil Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Aerodynamics/tutorial/IntroductionToAirfoilGeometry"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["AirfoilGeometry",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/AirfoilGeometry"]], "MoreAbout",
 CellID->1665078683]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"CosineSpacing - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 9, 58, 39.3156000}", "context" -> 
    "Aerodynamics`AirfoilGeometry`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "CosineSpacing is a value for the option Layout in the function \
NDiscretizeUnitSegment.", "synonyms" -> {}, "title" -> "CosineSpacing", 
    "type" -> "Symbol", "uri" -> "Aerodynamics/ref/CosineSpacing"}, 
  "LinkTrails" -> "", "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6063, 181, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->494162855]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 12890, 415}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 76, 1, 70, "SymbolColorBar"],
Cell[685, 24, 191, 5, 70, "LinkTrail"],
Cell[879, 31, 3180, 73, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4084, 108, 56, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[4143, 111, 675, 20, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4855, 136, 579, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->88979539],
Cell[5437, 155, 539, 18, 70, "Notes",
 CellID->1067943069],
Cell[5979, 175, 47, 1, 70, "Notes",
 CellID->529540534]
}, Closed]],
Cell[CellGroupData[{
Cell[6063, 181, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->494162855],
Cell[CellGroupData[{
Cell[6549, 198, 148, 5, 70, "ExampleSection",
 CellID->121029181],
Cell[6700, 205, 132, 6, 70, "ExampleText",
 CellID->885726909],
Cell[6835, 213, 100, 3, 70, "Input",
 CellID->237225796],
Cell[6938, 218, 190, 6, 70, "ExampleText",
 CellID->346983563],
Cell[CellGroupData[{
Cell[7153, 228, 287, 8, 70, "Input",
 CellID->86796878],
Cell[7443, 238, 483, 12, 54, "Output",
 CellID->163303347]
}, Open  ]],
Cell[7941, 253, 168, 4, 70, "ExampleText",
 CellID->62222020],
Cell[CellGroupData[{
Cell[8134, 261, 684, 22, 70, "Input",
 CellID->40554313],
Cell[8821, 285, 526, 14, 104, "Output",
 CellID->186015085]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9408, 306, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[9828, 320, 341, 11, 70, "SeeAlso",
 CellID->447834129]
}, Open  ]],
Cell[CellGroupData[{
Cell[10206, 336, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[10628, 350, 196, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[10861, 359, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[11283, 373, 156, 3, 70, "MoreAbout",
 CellID->1665078683]
}, Open  ]],
Cell[11454, 379, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

