(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     25894,        869]
NotebookOptionsPosition[     21194,        713]
NotebookOutlinePosition[     22954,        761]
CellTagsIndexPosition[     22869,        756]
WindowTitle->Cross (\:F4A0) - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"A1 Data Type CartesianVectors\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Dot\"\>":>Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/Dot"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"CartesianVectors\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/Cross\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/Cross"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
Cross.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/Cross", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Cross (\[Cross])", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Cross", "[", 
       RowBox[{
        StyleBox["u", "TI"], ",", 
        StyleBox["v", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]gives the element-by-element vector cross product of \
two collections of three-dimensional vectors of the  data type ",
     Cell[BoxData[
      ButtonBox["CartesianVectors",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/CartesianVectors"]], 
      "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Cross", "[", 
       StyleBox["u", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives the element-by-element perpendicular vectors for \
a collection of two-dimensional vectors."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->81014330],

Cell["New in 1.0", "Notes",
 CellID->529540534]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->1543914],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection",
 CellID->31596765],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->280757486],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->107795920],

Cell["\<\
Specify two collections of three-dimensional vectors of the data type \
CartesianVectors, where components are simple lists.\
\>", "ExampleText",
 CellID->25689371],

Cell[BoxData[{
 RowBox[{
  RowBox[{"uS3D", "=", 
   RowBox[{"MakeCartesianVectors", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Array", "[", 
       RowBox[{"ux", ",", "5"}], "]"}], ",", 
      RowBox[{"Array", "[", 
       RowBox[{"uy", ",", "5"}], "]"}], ",", 
      RowBox[{"Array", "[", 
       RowBox[{"uz", ",", "5"}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vS3D", "=", 
   RowBox[{"MakeCartesianVectors", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Array", "[", 
       RowBox[{"vx", ",", "5"}], "]"}], ",", 
      RowBox[{"Array", "[", 
       RowBox[{"vy", ",", "5"}], "]"}], ",", 
      RowBox[{"Array", "[", 
       RowBox[{"vz", ",", "5"}], "]"}]}], "}"}], "]"}]}], ";"}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->110273710],

Cell["\<\
Note that the structure of these two collections of vectors are the same.\
\>", "ExampleText",
 CellID->195533284],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "/@", 
  RowBox[{"{", 
   RowBox[{"uS3D", ",", "vS3D"}], "}"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->390891365],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}]}], "}"}]], "Output",
 ImageSize->{107, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->597468578]
}, Open  ]],

Cell["\<\
Element-by-element cross product of these two collections of vectors.\
\>", "ExampleText",
 CellID->643090720],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wS3D", "=", 
  RowBox[{"uS3D", "\[Cross]", "vS3D"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->73938320],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"uz", "[", "1", "]"}]}], " ", 
       RowBox[{"vy", "[", "1", "]"}]}], "+", 
      RowBox[{
       RowBox[{"uy", "[", "1", "]"}], " ", 
       RowBox[{"vz", "[", "1", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"uz", "[", "2", "]"}]}], " ", 
       RowBox[{"vy", "[", "2", "]"}]}], "+", 
      RowBox[{
       RowBox[{"uy", "[", "2", "]"}], " ", 
       RowBox[{"vz", "[", "2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"uz", "[", "3", "]"}]}], " ", 
       RowBox[{"vy", "[", "3", "]"}]}], "+", 
      RowBox[{
       RowBox[{"uy", "[", "3", "]"}], " ", 
       RowBox[{"vz", "[", "3", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"uz", "[", "4", "]"}]}], " ", 
       RowBox[{"vy", "[", "4", "]"}]}], "+", 
      RowBox[{
       RowBox[{"uy", "[", "4", "]"}], " ", 
       RowBox[{"vz", "[", "4", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"uz", "[", "5", "]"}]}], " ", 
       RowBox[{"vy", "[", "5", "]"}]}], "+", 
      RowBox[{
       RowBox[{"uy", "[", "5", "]"}], " ", 
       RowBox[{"vz", "[", "5", "]"}]}]}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"uz", "[", "1", "]"}], " ", 
       RowBox[{"vx", "[", "1", "]"}]}], "-", 
      RowBox[{
       RowBox[{"ux", "[", "1", "]"}], " ", 
       RowBox[{"vz", "[", "1", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uz", "[", "2", "]"}], " ", 
       RowBox[{"vx", "[", "2", "]"}]}], "-", 
      RowBox[{
       RowBox[{"ux", "[", "2", "]"}], " ", 
       RowBox[{"vz", "[", "2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uz", "[", "3", "]"}], " ", 
       RowBox[{"vx", "[", "3", "]"}]}], "-", 
      RowBox[{
       RowBox[{"ux", "[", "3", "]"}], " ", 
       RowBox[{"vz", "[", "3", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uz", "[", "4", "]"}], " ", 
       RowBox[{"vx", "[", "4", "]"}]}], "-", 
      RowBox[{
       RowBox[{"ux", "[", "4", "]"}], " ", 
       RowBox[{"vz", "[", "4", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uz", "[", "5", "]"}], " ", 
       RowBox[{"vx", "[", "5", "]"}]}], "-", 
      RowBox[{
       RowBox[{"ux", "[", "5", "]"}], " ", 
       RowBox[{"vz", "[", "5", "]"}]}]}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"uy", "[", "1", "]"}]}], " ", 
       RowBox[{"vx", "[", "1", "]"}]}], "+", 
      RowBox[{
       RowBox[{"ux", "[", "1", "]"}], " ", 
       RowBox[{"vy", "[", "1", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"uy", "[", "2", "]"}]}], " ", 
       RowBox[{"vx", "[", "2", "]"}]}], "+", 
      RowBox[{
       RowBox[{"ux", "[", "2", "]"}], " ", 
       RowBox[{"vy", "[", "2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"uy", "[", "3", "]"}]}], " ", 
       RowBox[{"vx", "[", "3", "]"}]}], "+", 
      RowBox[{
       RowBox[{"ux", "[", "3", "]"}], " ", 
       RowBox[{"vy", "[", "3", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"uy", "[", "4", "]"}]}], " ", 
       RowBox[{"vx", "[", "4", "]"}]}], "+", 
      RowBox[{
       RowBox[{"ux", "[", "4", "]"}], " ", 
       RowBox[{"vy", "[", "4", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"uy", "[", "5", "]"}]}], " ", 
       RowBox[{"vx", "[", "5", "]"}]}], "+", 
      RowBox[{
       RowBox[{"ux", "[", "5", "]"}], " ", 
       RowBox[{"vy", "[", "5", "]"}]}]}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{-$CellContext`uz[
       1] $CellContext`vy[1] + $CellContext`uy[1] $CellContext`vz[
       1], -$CellContext`uz[2] $CellContext`vy[2] + $CellContext`uy[
       2] $CellContext`vz[2], -$CellContext`uz[3] $CellContext`vy[
       3] + $CellContext`uy[3] $CellContext`vz[3], -$CellContext`uz[
       4] $CellContext`vy[4] + $CellContext`uy[4] $CellContext`vz[
       4], -$CellContext`uz[5] $CellContext`vy[5] + $CellContext`uy[
       5] $CellContext`vz[5]}, {$CellContext`uz[1] $CellContext`vx[
       1] - $CellContext`ux[1] $CellContext`vz[
      1], $CellContext`uz[2] $CellContext`vx[2] - $CellContext`ux[
      2] $CellContext`vz[
      2], $CellContext`uz[3] $CellContext`vx[3] - $CellContext`ux[
      3] $CellContext`vz[
      3], $CellContext`uz[4] $CellContext`vx[4] - $CellContext`ux[
      4] $CellContext`vz[
      4], $CellContext`uz[5] $CellContext`vx[5] - $CellContext`ux[
      5] $CellContext`vz[
      5]}, {-$CellContext`uy[1] $CellContext`vx[1] + $CellContext`ux[
       1] $CellContext`vy[1], -$CellContext`uy[2] $CellContext`vx[
       2] + $CellContext`ux[2] $CellContext`vy[2], -$CellContext`uy[
       3] $CellContext`vx[3] + $CellContext`ux[3] $CellContext`vy[
       3], -$CellContext`uy[4] $CellContext`vx[4] + $CellContext`ux[
       4] $CellContext`vy[4], -$CellContext`uy[5] $CellContext`vx[
       5] + $CellContext`ux[5] $CellContext`vy[5]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{557, 101},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->827836907]
}, Open  ]],

Cell["Note the structure of the result.", "ExampleText",
 CellID->114880245],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Head", "[", "wS3D", "]"}], ",", 
   RowBox[{"Dimensions", "[", "wS3D", "]"}]}], "}"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->430957953],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"CartesianVectors", ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}]}], "}"}]], "Output",
 ImageSize->{180, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->663567231]
}, Open  ]],

Cell["\<\
The cross product is perpendicular to the original vectors element-by-element \
in the collections, and there were five vectors each collection.\
\>", "ExampleText",
 CellID->378189741],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "/@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"wS3D", ".", "uS3D"}], ",", 
    RowBox[{"wS3D", ".", "vS3D"}]}], "}"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->110286018],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{215, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->24350170]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->914516997],

Cell["Specify a collection of two-dimensional vectors.", "ExampleText",
 CellID->301422485],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"uS2D", "=", 
  RowBox[{"MakeCartesianVectors", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Array", "[", 
      RowBox[{"ux", ",", "5"}], "]"}], ",", 
     RowBox[{"Array", "[", 
      RowBox[{"uy", ",", "5"}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->145352101],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ux", "[", "1", "]"}], ",", 
     RowBox[{"ux", "[", "2", "]"}], ",", 
     RowBox[{"ux", "[", "3", "]"}], ",", 
     RowBox[{"ux", "[", "4", "]"}], ",", 
     RowBox[{"ux", "[", "5", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uy", "[", "1", "]"}], ",", 
     RowBox[{"uy", "[", "2", "]"}], ",", 
     RowBox[{"uy", "[", "3", "]"}], ",", 
     RowBox[{"uy", "[", "4", "]"}], ",", 
     RowBox[{"uy", "[", "5", "]"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{
     $CellContext`ux[1], 
     $CellContext`ux[2], 
     $CellContext`ux[3], 
     $CellContext`ux[4], 
     $CellContext`ux[5]}, {
     $CellContext`uy[1], 
     $CellContext`uy[2], 
     $CellContext`uy[3], 
     $CellContext`uy[4], 
     $CellContext`uy[5]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{479, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->300885461]
}, Open  ]],

Cell["\<\
Cross gives a collection of vectors perpendicular to the above vectors.\
\>", "ExampleText",
 CellID->655555058],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wS2D", "=", 
  RowBox[{"Cross", "[", "uS2D", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->392390744],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"uy", "[", "1", "]"}]}], ",", 
     RowBox[{"-", 
      RowBox[{"uy", "[", "2", "]"}]}], ",", 
     RowBox[{"-", 
      RowBox[{"uy", "[", "3", "]"}]}], ",", 
     RowBox[{"-", 
      RowBox[{"uy", "[", "4", "]"}]}], ",", 
     RowBox[{"-", 
      RowBox[{"uy", "[", "5", "]"}]}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ux", "[", "1", "]"}], ",", 
     RowBox[{"ux", "[", "2", "]"}], ",", 
     RowBox[{"ux", "[", "3", "]"}], ",", 
     RowBox[{"ux", "[", "4", "]"}], ",", 
     RowBox[{"ux", "[", "5", "]"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{-$CellContext`uy[
      1], -$CellContext`uy[2], -$CellContext`uy[3], -$CellContext`uy[
      4], -$CellContext`uy[5]}, {
     $CellContext`ux[1], 
     $CellContext`ux[2], 
     $CellContext`ux[3], 
     $CellContext`ux[4], 
     $CellContext`ux[5]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{519, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->650611855]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wS2D", ".", "uS2D"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->35255916],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 ImageSize->{97, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->43796369]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[StyleBox[ButtonBox["Dot",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/ref/Dot"],
 FontFamily->"Verdana"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[{
 ButtonBox["A1",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox[" ",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox["Data",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox[" ",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox["Type",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox[" ",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox["CartesianVectors",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"]
}], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["CartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/CartesianVectors"]], "MoreAbout",
 CellID->741679522]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Cross (\[Cross]) - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 9, 58, 43.4652000}", "context" -> 
    "Aerodynamics`", "keywords" -> {}, "index" -> True, "label" -> 
    "Aerodynamics Paclet Symbol", "language" -> "en", "paclet" -> 
    "Aerodynamics", "status" -> "None", "summary" -> 
    "Cross[u, v] gives the element-by-element vector cross product of two \
collections of three-dimensional vectors of the data type \
CartesianVectors.Cross[u] gives the element-by-element perpendicular vectors \
for a collection of two-dimensional vectors.", "synonyms" -> {}, "title" -> 
    "Cross (x)", "type" -> "Symbol", "uri" -> "Aerodynamics/ref/Cross"}, 
  "LinkTrails" -> "", "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5624, 166, 459, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->1543914]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 22728, 749}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[607, 21, 76, 1, 70, "SymbolColorBar"],
Cell[686, 24, 191, 5, 70, "LinkTrail"],
Cell[880, 31, 2983, 70, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3888, 105, 59, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[3950, 108, 971, 28, 70, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4958, 141, 579, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->81014330],
Cell[5540, 160, 47, 1, 70, "Notes",
 CellID->529540534]
}, Closed]],
Cell[CellGroupData[{
Cell[5624, 166, 459, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->1543914],
Cell[CellGroupData[{
Cell[6108, 183, 147, 5, 70, "ExampleSection",
 CellID->31596765],
Cell[6258, 190, 132, 6, 70, "ExampleText",
 CellID->280757486],
Cell[6393, 198, 100, 3, 70, "Input",
 CellID->107795920],
Cell[6496, 203, 174, 4, 70, "ExampleText",
 CellID->25689371],
Cell[6673, 209, 797, 25, 70, "Input",
 CellID->110273710],
Cell[7473, 236, 124, 3, 70, "ExampleText",
 CellID->195533284],
Cell[CellGroupData[{
Cell[7622, 243, 155, 5, 70, "Input",
 CellID->390891365],
Cell[7780, 250, 302, 11, 36, "Output",
 CellID->597468578]
}, Open  ]],
Cell[8097, 264, 120, 3, 70, "ExampleText",
 CellID->643090720],
Cell[CellGroupData[{
Cell[8242, 271, 130, 4, 70, "Input",
 CellID->73938320],
Cell[8375, 277, 5419, 154, 122, "Output",
 CellID->827836907]
}, Open  ]],
Cell[13809, 434, 76, 1, 70, "ExampleText",
 CellID->114880245],
Cell[CellGroupData[{
Cell[13910, 439, 191, 6, 70, "Input",
 CellID->430957953],
Cell[14104, 447, 268, 9, 36, "Output",
 CellID->663567231]
}, Open  ]],
Cell[14387, 459, 195, 4, 70, "ExampleText",
 CellID->378189741],
Cell[CellGroupData[{
Cell[14607, 467, 209, 7, 70, "Input",
 CellID->110286018],
Cell[14819, 476, 364, 12, 36, "Output",
 CellID->24350170]
}, Open  ]],
Cell[CellGroupData[{
Cell[15220, 493, 125, 3, 70, "ExampleDelimiter",
 CellID->914516997],
Cell[15348, 498, 91, 1, 70, "ExampleText",
 CellID->301422485],
Cell[CellGroupData[{
Cell[15464, 503, 317, 10, 70, "Input",
 CellID->145352101],
Cell[15784, 515, 1048, 34, 36, "Output",
 CellID->300885461]
}, Open  ]],
Cell[16847, 552, 122, 3, 70, "ExampleText",
 CellID->655555058],
Cell[CellGroupData[{
Cell[16994, 559, 130, 4, 70, "Input",
 CellID->392390744],
Cell[17127, 565, 1147, 36, 36, "Output",
 CellID->650611855]
}, Open  ]],
Cell[CellGroupData[{
Cell[18311, 606, 97, 3, 70, "Input",
 CellID->35255916],
Cell[18411, 611, 232, 7, 36, "Output",
 CellID->43796369]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18716, 626, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[19136, 640, 161, 4, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[19334, 649, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[19756, 663, 780, 23, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[20573, 691, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[20995, 705, 157, 3, 70, "MoreAbout",
 CellID->741679522]
}, Open  ]],
Cell[21167, 711, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

