(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     34703,       1145]
NotebookOptionsPosition[     29430,        968]
NotebookOutlinePosition[     31167,       1016]
CellTagsIndexPosition[     31081,       1011]
WindowTitle->Dot (.) - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"A1 Data Type CartesianVectors\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Cross\"\>":>Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/Cross"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"CartesianVectors\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/Dot\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/Dot"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
Dot.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/Dot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Dot (.)", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{
        StyleBox["u", "TI"], ".", 
        StyleBox["v", "TI"]}], " ", "or", " ", 
       RowBox[{"Dot", "[", 
        RowBox[{
         StyleBox["u", "TI"], ",", 
         StyleBox["v", "TI"]}], "]"}]}]], "InlineFormula"],
     " \[LineSeparator]gives element-by-element scalar product of two \
collections of vectors of the data type ",
     Cell[BoxData[
      ButtonBox["CartesianVectors",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/CartesianVectors"]], 
      "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{
        StyleBox["u", "TI"], ".", 
        StyleBox["a", "TI"]}], " ", "or", " ", 
       RowBox[{"Dot", "[", 
        RowBox[{
         StyleBox["u", "TI"], ",", 
         StyleBox["a", "TI"]}], "]"}]}]], "InlineFormula"],
     "\[LineSeparator]gives scalar product of a collection of vectors ",
     Cell[BoxData[
      StyleBox["u", "TI"]], "InlineFormula"],
     " of the data type CartesianVectors and a list ",
     Cell[BoxData[
      StyleBox["a", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->418296202],

Cell["New in 1.0   |   Last modified in 1.2", "Notes",
 CellID->529540534]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->299512149],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->412311818],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->280757486],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->107795920],

Cell["\<\
Specify two collections of three-dimensional vectors of the data type \
CartesianVectors, where components are simple lists.\
\>", "ExampleText",
 CellID->25689371],

Cell[BoxData[{
 RowBox[{
  RowBox[{"uS3D", "=", 
   RowBox[{"MakeCartesianVectors", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Array", "[", 
       RowBox[{"ux", ",", "5"}], "]"}], ",", 
      RowBox[{"Array", "[", 
       RowBox[{"uy", ",", "5"}], "]"}], ",", 
      RowBox[{"Array", "[", 
       RowBox[{"uz", ",", "5"}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vS3D", "=", 
   RowBox[{"MakeCartesianVectors", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Array", "[", 
       RowBox[{"vx", ",", "5"}], "]"}], ",", 
      RowBox[{"Array", "[", 
       RowBox[{"vy", ",", "5"}], "]"}], ",", 
      RowBox[{"Array", "[", 
       RowBox[{"vz", ",", "5"}], "]"}]}], "}"}], "]"}]}], ";"}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->110273710],

Cell["\<\
Note that the structure of these two collections of vectors are the same.\
\>", "ExampleText",
 CellID->195533284],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "/@", 
  RowBox[{"{", 
   RowBox[{"uS3D", ",", "vS3D"}], "}"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->390891365],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}]}], "}"}]], "Output",
 ImageSize->{107, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->294269220]
}, Open  ]],

Cell["\<\
Element-by-element scalar product of these two collections of vectors.\
\>", "ExampleText",
 CellID->643090720],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"uS3D", ".", "vS3D"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->73938320],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ux", "[", "1", "]"}], " ", 
     RowBox[{"vx", "[", "1", "]"}]}], "+", 
    RowBox[{
     RowBox[{"uy", "[", "1", "]"}], " ", 
     RowBox[{"vy", "[", "1", "]"}]}], "+", 
    RowBox[{
     RowBox[{"uz", "[", "1", "]"}], " ", 
     RowBox[{"vz", "[", "1", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"ux", "[", "2", "]"}], " ", 
     RowBox[{"vx", "[", "2", "]"}]}], "+", 
    RowBox[{
     RowBox[{"uy", "[", "2", "]"}], " ", 
     RowBox[{"vy", "[", "2", "]"}]}], "+", 
    RowBox[{
     RowBox[{"uz", "[", "2", "]"}], " ", 
     RowBox[{"vz", "[", "2", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"ux", "[", "3", "]"}], " ", 
     RowBox[{"vx", "[", "3", "]"}]}], "+", 
    RowBox[{
     RowBox[{"uy", "[", "3", "]"}], " ", 
     RowBox[{"vy", "[", "3", "]"}]}], "+", 
    RowBox[{
     RowBox[{"uz", "[", "3", "]"}], " ", 
     RowBox[{"vz", "[", "3", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"ux", "[", "4", "]"}], " ", 
     RowBox[{"vx", "[", "4", "]"}]}], "+", 
    RowBox[{
     RowBox[{"uy", "[", "4", "]"}], " ", 
     RowBox[{"vy", "[", "4", "]"}]}], "+", 
    RowBox[{
     RowBox[{"uz", "[", "4", "]"}], " ", 
     RowBox[{"vz", "[", "4", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"ux", "[", "5", "]"}], " ", 
     RowBox[{"vx", "[", "5", "]"}]}], "+", 
    RowBox[{
     RowBox[{"uy", "[", "5", "]"}], " ", 
     RowBox[{"vy", "[", "5", "]"}]}], "+", 
    RowBox[{
     RowBox[{"uz", "[", "5", "]"}], " ", 
     RowBox[{"vz", "[", "5", "]"}]}]}]}], "}"}]], "Output",
 ImageSize->{520, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->125756848]
}, Open  ]],

Cell["\<\
Note that the result is a simple list of the five scalar products.\
\>", "ExampleText",
 CellID->114880245],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Head", "[", "%", "]"}], ",", 
   RowBox[{"Dimensions", "[", "%", "]"}]}], "}"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->430957953],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"List", ",", 
   RowBox[{"{", "5", "}"}]}], "}"}]], "Output",
 ImageSize->{78, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->152031004]
}, Open  ]],

Cell[TextData[{
 "The scalar product is also defined between a collection of vectors and a \
list of appropriate dimensions.  The result is a single vector in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " notation."
}], "ExampleText",
 CellID->305848282],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"aS", "=", 
   RowBox[{"Array", "[", 
    RowBox[{"a", ",", "5"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"uS3D", ".", "aS"}]}], "Input",
 CellLabel->"In[6]:=",
 CellID->41533466],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "1", "]"}], " ", 
     RowBox[{"ux", "[", "1", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "2", "]"}], " ", 
     RowBox[{"ux", "[", "2", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "3", "]"}], " ", 
     RowBox[{"ux", "[", "3", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "4", "]"}], " ", 
     RowBox[{"ux", "[", "4", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "5", "]"}], " ", 
     RowBox[{"ux", "[", "5", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "1", "]"}], " ", 
     RowBox[{"uy", "[", "1", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "2", "]"}], " ", 
     RowBox[{"uy", "[", "2", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "3", "]"}], " ", 
     RowBox[{"uy", "[", "3", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "4", "]"}], " ", 
     RowBox[{"uy", "[", "4", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "5", "]"}], " ", 
     RowBox[{"uy", "[", "5", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "1", "]"}], " ", 
     RowBox[{"uz", "[", "1", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "2", "]"}], " ", 
     RowBox[{"uz", "[", "2", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "3", "]"}], " ", 
     RowBox[{"uz", "[", "3", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "4", "]"}], " ", 
     RowBox[{"uz", "[", "4", "]"}]}], "+", 
    RowBox[{
     RowBox[{"a", "[", "5", "]"}], " ", 
     RowBox[{"uz", "[", "5", "]"}]}]}]}], "}"}]], "Output",
 ImageSize->{401, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->182000998]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Head", "[", "%", "]"}], ",", 
   RowBox[{"Dimensions", "[", "%", "]"}]}], "}"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->401404001],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"List", ",", 
   RowBox[{"{", "3", "}"}]}], "}"}]], "Output",
 ImageSize->{78, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->341471668]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Scope",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1293636265],

Cell["\<\
In representing models for panel methods, the components of collections of \
vectors are represented as nested lists of matrix form.  For example, the \
velocity influence coefficients for a two-dimensional panel method using four \
vortex panels can be represented in the following form.\
\>", "ExampleText",
 CellID->474027081],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ic", "=", 
   RowBox[{"MakeCartesianVectors", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Array", "[", 
       RowBox[{"icx", ",", 
        RowBox[{"{", 
         RowBox[{"4", ",", "4"}], "}"}]}], "]"}], ",", 
      RowBox[{"Array", "[", 
       RowBox[{"icz", ",", 
        RowBox[{"{", 
         RowBox[{"4", ",", "4"}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ic", "//", "MatrixForm"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->205230638],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnT1y40YQhVn2SXwMM/MVfIKtDVibWaGyDRWKmcINN9wMChUq1AEYbKhQ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    "], {{0, 57}, {577, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{577, 57},
  PlotRange->{{0, 577}, {0, 57}}]], "Output",
 ImageSize->{581, 57},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->582563256]
}, Open  ]],

Cell["\<\
The first index specifies a collocation point at which the influence \
coefficient is being computed and the second index specifies a vortex panel.\
\>", "ExampleText",
 CellID->49018754],

Cell["\<\
Represent unit vectors normal to panels by a collection of vectors.\
\>", "ExampleText",
 CellID->325303811],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"un", "=", 
  RowBox[{"MakeCartesianVectors", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Array", "[", 
      RowBox[{"unx", ",", "4"}], "]"}], ",", 
     RowBox[{"Array", "[", 
      RowBox[{"unz", ",", "4"}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->35009813],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"unx", "[", "1", "]"}], ",", 
     RowBox[{"unx", "[", "2", "]"}], ",", 
     RowBox[{"unx", "[", "3", "]"}], ",", 
     RowBox[{"unx", "[", "4", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"unz", "[", "1", "]"}], ",", 
     RowBox[{"unz", "[", "2", "]"}], ",", 
     RowBox[{"unz", "[", "3", "]"}], ",", 
     RowBox[{"unz", "[", "4", "]"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{
     $CellContext`unx[1], 
     $CellContext`unx[2], 
     $CellContext`unx[3], 
     $CellContext`unx[4]}, {
     $CellContext`unz[1], 
     $CellContext`unz[2], 
     $CellContext`unz[3], 
     $CellContext`unz[4]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{443, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->311207505]
}, Open  ]],

Cell["\<\
Components of velocity influence coefficient normal to panels can be \
represented by a simple scalar product.\
\>", "ExampleText",
 CellID->97024124],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ic", ".", "un"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->841632680],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"1", ",", "1"}], "]"}], " ", 
       RowBox[{"unx", "[", "1", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"1", ",", "1"}], "]"}], " ", 
       RowBox[{"unz", "[", "1", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"1", ",", "2"}], "]"}], " ", 
       RowBox[{"unx", "[", "1", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"1", ",", "2"}], "]"}], " ", 
       RowBox[{"unz", "[", "1", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"1", ",", "3"}], "]"}], " ", 
       RowBox[{"unx", "[", "1", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"1", ",", "3"}], "]"}], " ", 
       RowBox[{"unz", "[", "1", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"1", ",", "4"}], "]"}], " ", 
       RowBox[{"unx", "[", "1", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"1", ",", "4"}], "]"}], " ", 
       RowBox[{"unz", "[", "1", "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"2", ",", "1"}], "]"}], " ", 
       RowBox[{"unx", "[", "2", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"2", ",", "1"}], "]"}], " ", 
       RowBox[{"unz", "[", "2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"2", ",", "2"}], "]"}], " ", 
       RowBox[{"unx", "[", "2", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"2", ",", "2"}], "]"}], " ", 
       RowBox[{"unz", "[", "2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"2", ",", "3"}], "]"}], " ", 
       RowBox[{"unx", "[", "2", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"2", ",", "3"}], "]"}], " ", 
       RowBox[{"unz", "[", "2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"2", ",", "4"}], "]"}], " ", 
       RowBox[{"unx", "[", "2", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"2", ",", "4"}], "]"}], " ", 
       RowBox[{"unz", "[", "2", "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"3", ",", "1"}], "]"}], " ", 
       RowBox[{"unx", "[", "3", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"3", ",", "1"}], "]"}], " ", 
       RowBox[{"unz", "[", "3", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"3", ",", "2"}], "]"}], " ", 
       RowBox[{"unx", "[", "3", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"3", ",", "2"}], "]"}], " ", 
       RowBox[{"unz", "[", "3", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"3", ",", "3"}], "]"}], " ", 
       RowBox[{"unx", "[", "3", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"3", ",", "3"}], "]"}], " ", 
       RowBox[{"unz", "[", "3", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"3", ",", "4"}], "]"}], " ", 
       RowBox[{"unx", "[", "3", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"3", ",", "4"}], "]"}], " ", 
       RowBox[{"unz", "[", "3", "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"4", ",", "1"}], "]"}], " ", 
       RowBox[{"unx", "[", "4", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"4", ",", "1"}], "]"}], " ", 
       RowBox[{"unz", "[", "4", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"4", ",", "2"}], "]"}], " ", 
       RowBox[{"unx", "[", "4", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"4", ",", "2"}], "]"}], " ", 
       RowBox[{"unz", "[", "4", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"4", ",", "3"}], "]"}], " ", 
       RowBox[{"unx", "[", "4", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"4", ",", "3"}], "]"}], " ", 
       RowBox[{"unz", "[", "4", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"icx", "[", 
        RowBox[{"4", ",", "4"}], "]"}], " ", 
       RowBox[{"unx", "[", "4", "]"}]}], "+", 
      RowBox[{
       RowBox[{"icz", "[", 
        RowBox[{"4", ",", "4"}], "]"}], " ", 
       RowBox[{"unz", "[", "4", "]"}]}]}]}], "}"}]}], "}"}]], "Output",
 ImageSize->{490, 135},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->114411712]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Head", "[", "%", "]"}], ",", 
   RowBox[{"Dimensions", "[", "%", "]"}]}], "}"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->341747214],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"List", ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "4"}], "}"}]}], "}"}]], "Output",
 ImageSize->{96, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->138113928]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[StyleBox[ButtonBox["Cross",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/ref/Cross"],
 FontFamily->"Verdana"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[{
 ButtonBox["A1",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox[" ",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox["Data",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox[" ",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox["Type",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox[" ",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"],
 ButtonBox["CartesianVectors",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"]
}], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["CartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/CartesianVectors"]], "MoreAbout",
 CellID->116326325]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["RELATED LINKS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "RelatedLinksSection",
 CellID->1584193535],

Cell[TextData[{
 ButtonBox["NKS|Online",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolframscience.com/nksonline/index/search.cgi?SearchIndex=\
Dot"], None}],
 " (",
 StyleBox[ButtonBox["A New Kind of Science",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolframscience.com/nksonline/"], None}],
  FontSlant->"Italic"],
 ")"
}], "RelatedLinks"]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Dot (.) - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 9, 58, 51.1092000}", "context" -> 
    "Aerodynamics`", "keywords" -> {}, "index" -> True, "label" -> 
    "Aerodynamics Paclet Symbol", "language" -> "en", "paclet" -> 
    "Aerodynamics", "status" -> "None", "summary" -> 
    "u.v or Dot[u, v] gives element-by-element scalar product of two \
collections of vectors of the data type CartesianVectors.u.a or Dot[u, a] \
gives scalar product of a collection of vectors u of the data type \
CartesianVectors and a list a.", "synonyms" -> {}, "title" -> "Dot (.)", 
    "type" -> "Symbol", "uri" -> "Aerodynamics/ref/Dot"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6039, 181, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->299512149]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 30938, 1004}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 76, 1, 70, "SymbolColorBar"],
Cell[679, 24, 191, 5, 70, "LinkTrail"],
Cell[873, 31, 2979, 70, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3877, 105, 50, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[3930, 108, 1378, 43, 70, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5345, 156, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->418296202],
Cell[5928, 175, 74, 1, 70, "Notes",
 CellID->529540534]
}, Closed]],
Cell[CellGroupData[{
Cell[6039, 181, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->299512149],
Cell[CellGroupData[{
Cell[6525, 198, 148, 5, 70, "ExampleSection",
 CellID->412311818],
Cell[6676, 205, 132, 6, 70, "ExampleText",
 CellID->280757486],
Cell[6811, 213, 100, 3, 70, "Input",
 CellID->107795920],
Cell[6914, 218, 174, 4, 70, "ExampleText",
 CellID->25689371],
Cell[7091, 224, 797, 25, 70, "Input",
 CellID->110273710],
Cell[7891, 251, 124, 3, 70, "ExampleText",
 CellID->195533284],
Cell[CellGroupData[{
Cell[8040, 258, 155, 5, 70, "Input",
 CellID->390891365],
Cell[8198, 265, 302, 11, 36, "Output",
 CellID->294269220]
}, Open  ]],
Cell[8515, 279, 121, 3, 70, "ExampleText",
 CellID->643090720],
Cell[CellGroupData[{
Cell[8661, 286, 97, 3, 70, "Input",
 CellID->73938320],
Cell[8761, 291, 1739, 57, 71, "Output",
 CellID->125756848]
}, Open  ]],
Cell[10515, 351, 117, 3, 70, "ExampleText",
 CellID->114880245],
Cell[CellGroupData[{
Cell[10657, 358, 185, 6, 70, "Input",
 CellID->430957953],
Cell[10845, 366, 230, 8, 36, "Output",
 CellID->152031004]
}, Open  ]],
Cell[11090, 377, 263, 7, 70, "ExampleText",
 CellID->305848282],
Cell[CellGroupData[{
Cell[11378, 388, 224, 7, 70, "Input",
 CellID->41533466],
Cell[11605, 397, 1696, 55, 71, "Output",
 CellID->182000998]
}, Open  ]],
Cell[CellGroupData[{
Cell[13338, 457, 185, 6, 70, "Input",
 CellID->401404001],
Cell[13526, 465, 230, 8, 36, "Output",
 CellID->341471668]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13805, 479, 221, 7, 70, "ExampleSection",
 CellID->1293636265],
Cell[14029, 488, 339, 6, 70, "ExampleText",
 CellID->474027081],
Cell[CellGroupData[{
Cell[14393, 498, 526, 17, 70, "Input",
 CellID->205230638],
Cell[14922, 517, 3786, 70, 70, "Output",
 CellID->582563256]
}, Open  ]],
Cell[18723, 590, 197, 4, 70, "ExampleText",
 CellID->49018754],
Cell[18923, 596, 118, 3, 70, "ExampleText",
 CellID->325303811],
Cell[CellGroupData[{
Cell[19066, 603, 316, 10, 70, "Input",
 CellID->35009813],
Cell[19385, 615, 928, 30, 36, "Output",
 CellID->311207505]
}, Open  ]],
Cell[20328, 648, 160, 4, 70, "ExampleText",
 CellID->97024124],
Cell[CellGroupData[{
Cell[20513, 656, 94, 3, 70, "Input",
 CellID->841632680],
Cell[20610, 661, 4949, 159, 156, "Output",
 CellID->114411712]
}, Open  ]],
Cell[CellGroupData[{
Cell[25596, 825, 185, 6, 70, "Input",
 CellID->341747214],
Cell[25784, 833, 255, 9, 36, "Output",
 CellID->138113928]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[26100, 849, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[26520, 863, 165, 4, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[26722, 872, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[27144, 886, 780, 23, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[27961, 914, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[28383, 928, 157, 3, 70, "MoreAbout",
 CellID->116326325]
}, Open  ]],
Cell[CellGroupData[{
Cell[28577, 936, 427, 12, 70, "RelatedLinksSection",
 CellID->1584193535],
Cell[29007, 950, 381, 13, 70, "RelatedLinks"]
}, Open  ]],
Cell[29403, 966, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

