(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     21906,        749]
NotebookOptionsPosition[     17543,        603]
NotebookOutlinePosition[     19222,        650]
CellTagsIndexPosition[     19137,        645]
WindowTitle->ExtendXzToXyz - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"A1 CartesianVectors\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ExtendXyToXyz\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/ref/ExtendXyToXyz"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"CartesianVectors\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/ExtendXzToXyz\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/ExtendXzToXyz"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
ExtendXzToXyz.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/ExtendXzToXyz", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["ExtendXzToXyz", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"ExtendXzToXyz", "[", 
       StyleBox["v", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]extends a collection of two-dimensional vectors to \
three-dimensions by padding the ",
     Cell[BoxData[
      StyleBox["y", "TI"]], "InlineFormula"],
     " component with zeros."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->48517027],

Cell["\<\
This function is used primarily for preparing collections of two-dimensional \
vectors for taking a three-dimensional cross product.\
\>", "Notes",
 CellID->1067943069],

Cell["New in 1.0", "Notes",
 CellID->529540534]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->598026499],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->40442798],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->693742856],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->118809426],

Cell["\<\
Specify two collections of 2-D vectors of the data type CartesianVectors.\
\>", "MathCaption",
 CellID->12893997],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"u2D", "=", 
  RowBox[{"MakeCartesianVectors", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Array", "[", 
      RowBox[{"ux", ",", "5"}], "]"}], ",", 
     RowBox[{"Array", "[", 
      RowBox[{"uz", ",", "5"}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->101936636],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ux", "[", "1", "]"}], ",", 
     RowBox[{"ux", "[", "2", "]"}], ",", 
     RowBox[{"ux", "[", "3", "]"}], ",", 
     RowBox[{"ux", "[", "4", "]"}], ",", 
     RowBox[{"ux", "[", "5", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uz", "[", "1", "]"}], ",", 
     RowBox[{"uz", "[", "2", "]"}], ",", 
     RowBox[{"uz", "[", "3", "]"}], ",", 
     RowBox[{"uz", "[", "4", "]"}], ",", 
     RowBox[{"uz", "[", "5", "]"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{
     $CellContext`ux[1], 
     $CellContext`ux[2], 
     $CellContext`ux[3], 
     $CellContext`ux[4], 
     $CellContext`ux[5]}, {
     $CellContext`uz[1], 
     $CellContext`uz[2], 
     $CellContext`uz[3], 
     $CellContext`uz[4], 
     $CellContext`uz[5]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{479, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->534852224]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v2D", "=", 
  RowBox[{"MakeCartesianVectors", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Array", "[", 
      RowBox[{"vx", ",", "5"}], "]"}], ",", 
     RowBox[{"Array", "[", 
      RowBox[{"vz", ",", "5"}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->359172056],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vx", "[", "1", "]"}], ",", 
     RowBox[{"vx", "[", "2", "]"}], ",", 
     RowBox[{"vx", "[", "3", "]"}], ",", 
     RowBox[{"vx", "[", "4", "]"}], ",", 
     RowBox[{"vx", "[", "5", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vz", "[", "1", "]"}], ",", 
     RowBox[{"vz", "[", "2", "]"}], ",", 
     RowBox[{"vz", "[", "3", "]"}], ",", 
     RowBox[{"vz", "[", "4", "]"}], ",", 
     RowBox[{"vz", "[", "5", "]"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{
     $CellContext`vx[1], 
     $CellContext`vx[2], 
     $CellContext`vx[3], 
     $CellContext`vx[4], 
     $CellContext`vx[5]}, {
     $CellContext`vz[1], 
     $CellContext`vz[2], 
     $CellContext`vz[3], 
     $CellContext`vz[4], 
     $CellContext`vz[5]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{479, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->539329249]
}, Open  ]],

Cell["Note that there are five vectors in each collection.", "ExampleText",
 CellID->210940296],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NumberOfVectors", "/@", 
  RowBox[{"{", 
   RowBox[{"u2D", ",", "v2D"}], "}"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->143340338],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"5", ",", "5"}], "}"}]], "Output",
 ImageSize->{43, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->291171359]
}, Open  ]],

Cell["Extend the collections to 3-D vectors.", "ExampleText",
 CellID->234436199],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"u3D", "=", 
  RowBox[{"ExtendXzToXyz", "[", "u2D", "]"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->525617782],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ux", "[", "1", "]"}], ",", 
     RowBox[{"ux", "[", "2", "]"}], ",", 
     RowBox[{"ux", "[", "3", "]"}], ",", 
     RowBox[{"ux", "[", "4", "]"}], ",", 
     RowBox[{"ux", "[", "5", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], 
   "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uz", "[", "1", "]"}], ",", 
     RowBox[{"uz", "[", "2", "]"}], ",", 
     RowBox[{"uz", "[", "3", "]"}], ",", 
     RowBox[{"uz", "[", "4", "]"}], ",", 
     RowBox[{"uz", "[", "5", "]"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{
     $CellContext`ux[1], 
     $CellContext`ux[2], 
     $CellContext`ux[3], 
     $CellContext`ux[4], 
     $CellContext`ux[5]}, {0, 0, 0, 0, 0}, {
     $CellContext`uz[1], 
     $CellContext`uz[2], 
     $CellContext`uz[3], 
     $CellContext`uz[4], 
     $CellContext`uz[5]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{581, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->712668506]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v3D", "=", 
  RowBox[{"ExtendXzToXyz", "[", "v2D", "]"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->176467336],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vx", "[", "1", "]"}], ",", 
     RowBox[{"vx", "[", "2", "]"}], ",", 
     RowBox[{"vx", "[", "3", "]"}], ",", 
     RowBox[{"vx", "[", "4", "]"}], ",", 
     RowBox[{"vx", "[", "5", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], 
   "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vz", "[", "1", "]"}], ",", 
     RowBox[{"vz", "[", "2", "]"}], ",", 
     RowBox[{"vz", "[", "3", "]"}], ",", 
     RowBox[{"vz", "[", "4", "]"}], ",", 
     RowBox[{"vz", "[", "5", "]"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{
     $CellContext`vx[1], 
     $CellContext`vx[2], 
     $CellContext`vx[3], 
     $CellContext`vx[4], 
     $CellContext`vx[5]}, {0, 0, 0, 0, 0}, {
     $CellContext`vz[1], 
     $CellContext`vz[2], 
     $CellContext`vz[3], 
     $CellContext`vz[4], 
     $CellContext`vz[5]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{581, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->270953542]
}, Open  ]],

Cell["Take cross products element by element.", "ExampleText",
 CellID->10665861],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"w3D", "=", 
  RowBox[{"u3D", "\[Cross]", "v3D"}]}]], "Input",
 CellLabel->"In[7]:=",
 CellID->2739995],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], 
   "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"uz", "[", "1", "]"}], " ", 
       RowBox[{"vx", "[", "1", "]"}]}], "-", 
      RowBox[{
       RowBox[{"ux", "[", "1", "]"}], " ", 
       RowBox[{"vz", "[", "1", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uz", "[", "2", "]"}], " ", 
       RowBox[{"vx", "[", "2", "]"}]}], "-", 
      RowBox[{
       RowBox[{"ux", "[", "2", "]"}], " ", 
       RowBox[{"vz", "[", "2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uz", "[", "3", "]"}], " ", 
       RowBox[{"vx", "[", "3", "]"}]}], "-", 
      RowBox[{
       RowBox[{"ux", "[", "3", "]"}], " ", 
       RowBox[{"vz", "[", "3", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uz", "[", "4", "]"}], " ", 
       RowBox[{"vx", "[", "4", "]"}]}], "-", 
      RowBox[{
       RowBox[{"ux", "[", "4", "]"}], " ", 
       RowBox[{"vz", "[", "4", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uz", "[", "5", "]"}], " ", 
       RowBox[{"vx", "[", "5", "]"}]}], "-", 
      RowBox[{
       RowBox[{"ux", "[", "5", "]"}], " ", 
       RowBox[{"vz", "[", "5", "]"}]}]}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{0, 0, 0, 0, 
    0}, {$CellContext`uz[1] $CellContext`vx[1] - $CellContext`ux[
      1] $CellContext`vz[
      1], $CellContext`uz[2] $CellContext`vx[2] - $CellContext`ux[
      2] $CellContext`vz[
      2], $CellContext`uz[3] $CellContext`vx[3] - $CellContext`ux[
      3] $CellContext`vz[
      3], $CellContext`uz[4] $CellContext`vx[4] - $CellContext`ux[
      4] $CellContext`vz[
      4], $CellContext`uz[5] $CellContext`vx[5] - $CellContext`ux[
      5] $CellContext`vz[5]}, {0, 0, 0, 0, 0}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{525, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->424533377]
}, Open  ]],

Cell["\<\
Note that computed cross products are perpendicular to each of the specified \
vectors element by element. \
\>", "ExampleText",
 CellID->7273185],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"w3D", ".", "u3D"}], ",", 
   RowBox[{"w3D", ".", "v3D"}]}], "}"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->309844456],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{215, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->326950381]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[StyleBox[ButtonBox["ExtendXyToXyz",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/ref/ExtendXyToXyz"],
 FontFamily->"Verdana"]], "SeeAlso",
 CellID->88624347]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["A1 CartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["CartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/CartesianVectors"]], "MoreAbout",
 CellID->431833267]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"ExtendXzToXyz - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 9, 59, 1.9824000}", "context" -> 
    "Aerodynamics`CartesianVectors`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "ExtendXzToXyz[v] extends a collection of two-dimensional vectors to \
three-dimensions by padding the y component with zeros.", "synonyms" -> {}, 
    "title" -> "ExtendXzToXyz", "type" -> "Symbol", "uri" -> 
    "Aerodynamics/ref/ExtendXzToXyz"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5410, 160, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->598026499]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 18994, 638}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 76, 1, 70, "SymbolColorBar"],
Cell[685, 24, 191, 5, 70, "LinkTrail"],
Cell[879, 31, 3040, 71, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3944, 106, 56, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[4003, 109, 523, 15, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4563, 129, 579, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->48517027],
Cell[5145, 148, 178, 4, 70, "Notes",
 CellID->1067943069],
Cell[5326, 154, 47, 1, 70, "Notes",
 CellID->529540534]
}, Closed]],
Cell[CellGroupData[{
Cell[5410, 160, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->598026499],
Cell[CellGroupData[{
Cell[5896, 177, 147, 5, 70, "ExampleSection",
 CellID->40442798],
Cell[6046, 184, 132, 6, 70, "ExampleText",
 CellID->693742856],
Cell[6181, 192, 100, 3, 70, "Input",
 CellID->118809426],
Cell[6284, 197, 123, 3, 70, "MathCaption",
 CellID->12893997],
Cell[CellGroupData[{
Cell[6432, 204, 316, 10, 70, "Input",
 CellID->101936636],
Cell[6751, 216, 1048, 34, 36, "Output",
 CellID->534852224]
}, Open  ]],
Cell[CellGroupData[{
Cell[7836, 255, 316, 10, 70, "Input",
 CellID->359172056],
Cell[8155, 267, 1048, 34, 36, "Output",
 CellID->539329249]
}, Open  ]],
Cell[9218, 304, 95, 1, 70, "ExampleText",
 CellID->210940296],
Cell[CellGroupData[{
Cell[9338, 309, 158, 5, 70, "Input",
 CellID->143340338],
Cell[9499, 316, 203, 7, 36, "Output",
 CellID->291171359]
}, Open  ]],
Cell[9717, 326, 81, 1, 70, "ExampleText",
 CellID->234436199],
Cell[CellGroupData[{
Cell[9823, 331, 136, 4, 70, "Input",
 CellID->525617782],
Cell[9962, 337, 1167, 37, 36, "Output",
 CellID->712668506]
}, Open  ]],
Cell[CellGroupData[{
Cell[11166, 379, 136, 4, 70, "Input",
 CellID->176467336],
Cell[11305, 385, 1167, 37, 36, "Output",
 CellID->270953542]
}, Open  ]],
Cell[12487, 425, 81, 1, 70, "ExampleText",
 CellID->10665861],
Cell[CellGroupData[{
Cell[12593, 430, 126, 4, 70, "Input",
 CellID->2739995],
Cell[12722, 436, 2145, 62, 71, "Output",
 CellID->424533377]
}, Open  ]],
Cell[14882, 501, 156, 4, 70, "ExampleText",
 CellID->7273185],
Cell[CellGroupData[{
Cell[15063, 509, 171, 6, 70, "Input",
 CellID->309844456],
Cell[15237, 517, 365, 12, 36, "Output",
 CellID->326950381]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15663, 536, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[16083, 550, 180, 4, 70, "SeeAlso",
 CellID->88624347]
}, Open  ]],
Cell[CellGroupData[{
Cell[16300, 559, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[16722, 573, 163, 3, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[16922, 581, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[17344, 595, 157, 3, 70, "MoreAbout",
 CellID->431833267]
}, Open  ]],
Cell[17516, 601, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

