(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     14783,        485]
NotebookOptionsPosition[     11396,        376]
NotebookOutlinePosition[     13050,        422]
CellTagsIndexPosition[     12965,        417]
WindowTitle->HalfCosineSpacing - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"1.1 Introduction to Airfoil Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/IntroductionToAirfoilGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Layout\"\>":>Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/Layout"], "\<\"NDiscretizeUnitSegment\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/NDiscretizeUnitSegment"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AirfoilGeometry\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/AirfoilGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/HalfCosineSpacing\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/HalfCosineSpacing"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
HalfCosineSpacing.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/HalfCosineSpacing", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["HalfCosineSpacing", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["HalfCosineSpacing"], "InlineFormula"],
     "\[LineSeparator]is a value for the option ",
     Cell[BoxData[
      ButtonBox["Layout",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/Layout"]], "InlineFormula"],
     " for the function ",
     Cell[BoxData[
      ButtonBox["NDiscretizeUnitSegment",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/NDiscretizeUnitSegment"]], 
      "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->497923275],

Cell[TextData[{
 "The other two values for the option Layout are ",
 Cell[BoxData[
  ButtonBox["ConstantSpacing",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/ConstantSpacing"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["CosineSpacing",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/CosineSpacing"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069],

Cell["New in 1.0", "Notes",
 CellID->529540534]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->829642048],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->350488226],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->885726909],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->237225796],

Cell[TextData[{
 "Use NDiscretizeUnitSegment to subdivide the unit segment into ",
 Cell[BoxData[
  StyleBox["n", "TI"]], "InlineFormula"],
 " pieces."
}], "ExampleText",
 CellID->346983563],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"xList", "=", 
  RowBox[{"NDiscretizeUnitSegment", "[", 
   RowBox[{"n", ",", 
    RowBox[{"Layout", "\[Rule]", "HalfCosineSpacing"}]}], "]"}]}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->338040793],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.`", ",", "0.01231165940486223`", ",", "0.04894348370484647`", ",", 
   "0.1089934758116321`", ",", "0.19098300562505255`", ",", 
   "0.2928932188134524`", ",", "0.412214747707527`", ",", 
   "0.5460095002604533`", ",", "0.6909830056250525`", ",", 
   "0.843565534959769`", ",", "0.9999999999999999`"}], "}"}]], "Output",
 ImageSize->{361, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->2402960]
}, Open  ]],

Cell["\<\
The value HalfCosineSpacing for the option Layout concentrates points near \
the beginning of the unit segment.\
\>", "ExampleText",
 CellID->62222020],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
     RowBox[{"Point", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"xList", ",", 
         RowBox[{"Table", "[", 
          RowBox[{"0", ",", 
           RowBox[{"{", 
            RowBox[{"n", "+", "1"}], "}"}]}], "]"}]}], "}"}], "]"}], "]"}]}], 
    "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"6", " ", "72"}]}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.1"}], ",", "0.1"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->40554313],

Cell[BoxData[
 GraphicsBox[
  {PointSize[Medium], 
   PointBox[{{0., 0}, {0.01231165940486223, 0}, {0.04894348370484647, 0}, {
     0.1089934758116321, 0}, {0.19098300562505255`, 0}, {
     0.2928932188134524, 0}, {0.412214747707527, 0}, {
     0.5460095002604533, 0}, {0.6909830056250525, 0}, {
     0.843565534959769, 0}, {0.9999999999999999, 0}}]},
  ImageSize->432,
  PlotRange->{-0.1, 0.1}]], "Output",
 ImageSize->{436, 83},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->33291839]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[{
 StyleBox[ButtonBox["Layout",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/Layout"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["NDiscretizeUnitSegment",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/NDiscretizeUnitSegment"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->447834129]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["1.1 Introduction to Airfoil Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Aerodynamics/tutorial/IntroductionToAirfoilGeometry"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["AirfoilGeometry",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/AirfoilGeometry"]], "MoreAbout",
 CellID->1665078683]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"HalfCosineSpacing - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 9, 59, 16.5528000}", "context" -> 
    "Aerodynamics`AirfoilGeometry`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "HalfCosineSpacing is a value for the option Layout for the function \
NDiscretizeUnitSegment.", "synonyms" -> {}, "title" -> "HalfCosineSpacing", 
    "type" -> "Symbol", "uri" -> "Aerodynamics/ref/HalfCosineSpacing"}, 
  "LinkTrails" -> "", "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5958, 176, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->829642048]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 12822, 410}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[610, 21, 76, 1, 70, "SymbolColorBar"],
Cell[689, 24, 191, 5, 70, "LinkTrail"],
Cell[883, 31, 3196, 73, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4104, 108, 60, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[4167, 111, 680, 20, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4884, 136, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->497923275],
Cell[5467, 155, 404, 13, 70, "Notes",
 CellID->1067943069],
Cell[5874, 170, 47, 1, 70, "Notes",
 CellID->529540534]
}, Closed]],
Cell[CellGroupData[{
Cell[5958, 176, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->829642048],
Cell[CellGroupData[{
Cell[6444, 193, 148, 5, 70, "ExampleSection",
 CellID->350488226],
Cell[6595, 200, 132, 6, 70, "ExampleText",
 CellID->885726909],
Cell[6730, 208, 100, 3, 70, "Input",
 CellID->237225796],
Cell[6833, 213, 190, 6, 70, "ExampleText",
 CellID->346983563],
Cell[CellGroupData[{
Cell[7048, 223, 292, 8, 70, "Input",
 CellID->338040793],
Cell[7343, 233, 494, 12, 54, "Output",
 CellID->2402960]
}, Open  ]],
Cell[7852, 248, 161, 4, 70, "ExampleText",
 CellID->62222020],
Cell[CellGroupData[{
Cell[8038, 256, 684, 22, 70, "Input",
 CellID->40554313],
Cell[8725, 280, 537, 14, 104, "Output",
 CellID->33291839]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9323, 301, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[9743, 315, 341, 11, 70, "SeeAlso",
 CellID->447834129]
}, Open  ]],
Cell[CellGroupData[{
Cell[10121, 331, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[10543, 345, 196, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[10776, 354, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[11198, 368, 156, 3, 70, "MoreAbout",
 CellID->1665078683]
}, Open  ]],
Cell[11369, 374, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

