(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     17622,        560]
NotebookOptionsPosition[     14281,        453]
NotebookOutlinePosition[     15911,        499]
CellTagsIndexPosition[     15826,        494]
WindowTitle->Layout - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"1.1 Introduction To Airfoil Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/IntroductionToAirfoilGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"NDiscretizeUnitSegment\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/NDiscretizeUnitSegment"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AirfoilGeometry\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/AirfoilGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/Layout\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/Layout"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
Layout.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/Layout", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Layout", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["Layout"], "InlineFormula"],
     "\[LineSeparator]is an option of ",
     Cell[BoxData[
      ButtonBox["NDiscretizeUnitSegment",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/NDiscretizeUnitSegment"]], 
      "InlineFormula"],
     " providing some flexibility for discretizing an airfoil."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->228939941],

Cell[TextData[{
 "Values accepted for the option Layout are ",
 Cell[BoxData[
  ButtonBox["ConstantSpacing",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/ConstantSpacing"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["CosineSpacing",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/CosineSpacing"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["HalfCosineSpacing",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/HalfCosineSpacing"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069],

Cell["New in 1.1", "Notes",
 CellID->529540534]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->26253387],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->33717520],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->885726909],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->237225796],

Cell[TextData[{
 "Use NDiscretizeUnitSegment to subdivide the unit segment into ",
 Cell[BoxData[
  StyleBox["n", "TI"]], "InlineFormula"],
 " pieces for each value o Layout."
}], "ExampleText",
 CellID->105341754],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xCon", " ", "=", " ", 
   RowBox[{"NDiscretizeUnitSegment", "[", 
    RowBox[{"n", ",", " ", 
     RowBox[{"Layout", " ", "\[Rule]", " ", "ConstantSpacing"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xCos", " ", "=", " ", 
   RowBox[{"NDiscretizeUnitSegment", "[", 
    RowBox[{"n", ",", " ", 
     RowBox[{"Layout", " ", "\[Rule]", " ", "CosineSpacing"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xHCos", " ", "=", " ", 
   RowBox[{"NDiscretizeUnitSegment", "[", 
    RowBox[{"n", ",", " ", 
     RowBox[{"Layout", " ", "\[Rule]", " ", "HalfCosineSpacing"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->347042507],

Cell["\<\
Illustrate the layout options by graphing the three lists of points generated \
above. \
\>", "ExampleText",
 CellID->68003369],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"AspectRatio", "\[Rule]", ".1"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"7", " ", "72"}], "}"}]}], ",", 
      RowBox[{"Ticks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "None"}], "}"}]}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gxCon", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"xCon", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"Length", "[", "xCon", "]"}], "}"}]}], "]"}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"PointSize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gxCos", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"xCos", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"Length", "[", "xCos", "]"}], "}"}]}], "]"}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"PointSize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gxHCos", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"xHCos", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"Length", "[", "xHCos", "]"}], "}"}]}], "]"}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Green", ",", 
        RowBox[{"PointSize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsColumn", "[", 
  RowBox[{"{", 
   RowBox[{"gxCon", ",", "gxCos", ",", "gxHCos"}], "}"}], "]"}]}], "Input",
 CellLabel->"In[3]:=",
 CellID->99122243],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[
      {RGBColor[1, 0, 0], PointSize[Large], 
       PointBox[{{0., 0.}, {0.1, 0.}, {0.2, 0.}, {0.30000000000000004`, 0.}, {
        0.4, 0.}, {0.5, 0.}, {0.6000000000000001, 0.}, {0.7000000000000001, 
        0.}, {0.8, 0.}, {0.9, 0.}, {1., 0.}}]},
      AspectRatio->0.1,
      Axes->True,
      ImageSize->{504},
      PlotRange->Automatic,
      PlotRangeClipping->True,
      Ticks->{Automatic, None}], {264.6, -27.090000000000003`}, 
     ImageScaled[{0.5, 0.5}], {504, 50.400000000000006`}], InsetBox[
     GraphicsBox[
      {RGBColor[0, 0, 1], PointSize[Large], 
       PointBox[{{0., 0.}, {0.024471741852423234`, 0.}, {0.09549150281252627, 
        0.}, {0.2061073738537635, 0.}, {0.3454915028125263, 0.}, {
        0.49999999999999994`, 0.}, {0.6545084971874737, 0.}, {
        0.7938926261462365, 0.}, {0.9045084971874737, 0.}, {
        0.9755282581475768, 0.}, {1., 0.}}]},
      AspectRatio->0.1,
      Axes->True,
      ImageSize->{504},
      PlotRange->Automatic,
      PlotRangeClipping->True,
      Ticks->{Automatic, None}], {264.6, -81.27000000000001}, 
     ImageScaled[{0.5, 0.5}], {504, 50.400000000000006`}], InsetBox[
     GraphicsBox[
      {RGBColor[0, 1, 0], PointSize[Large], 
       PointBox[{{0., 0.}, {0.01231165940486223, 0.}, {0.04894348370484647, 
        0.}, {0.1089934758116321, 0.}, {0.19098300562505255`, 0.}, {
        0.2928932188134524, 0.}, {0.412214747707527, 0.}, {0.5460095002604533,
         0.}, {0.6909830056250525, 0.}, {0.843565534959769, 0.}, {
        0.9999999999999999, 0.}}]},
      AspectRatio->0.1,
      Axes->True,
      ImageSize->{504},
      PlotRange->Automatic,
      PlotRangeClipping->True,
      Ticks->{Automatic, None}], {264.6, -135.45000000000002`}, 
     ImageScaled[{0.5, 0.5}], {504, 50.400000000000006`}]}, {}},
  ContentSelectable->True,
  ImageSize->{541.2, 174.54000000000002`},
  PlotRangePadding->{6, 5}]], "Output",
 ImageSize->{545, 175},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->324942390]
}, Open  ]],

Cell["\<\
Constant spacing is shown in red, cosine spacing in blue and half-cosine in \
green.\
\>", "ExampleText",
 CellID->335828069]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[StyleBox[ButtonBox["NDiscretizeUnitSegment",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/ref/NDiscretizeUnitSegment"],
 FontFamily->"Verdana"]], "SeeAlso",
 CellID->700084885]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["1.1 Introduction To Airfoil Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Aerodynamics/tutorial/IntroductionToAirfoilGeometry"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["AirfoilGeometry",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/AirfoilGeometry"]], "MoreAbout",
 CellID->1665078683]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Layout - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 10, 1, 18.6384000}", "context" -> 
    "Aerodynamics`AirfoilGeometry`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "Layout is an option of NDiscretizeUnitSegment providing some flexibility \
for discretizing an airfoil.", "synonyms" -> {}, "title" -> "Layout", "type" -> 
    "Symbol", "uri" -> "Aerodynamics/ref/Layout"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5819, 175, 460, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->26253387]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15684, 487}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[599, 21, 76, 1, 70, "SymbolColorBar"],
Cell[678, 24, 191, 5, 70, "LinkTrail"],
Cell[872, 31, 3064, 72, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3961, 107, 49, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[4013, 110, 543, 15, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4593, 130, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->228939941],
Cell[5176, 149, 556, 18, 70, "Notes",
 CellID->1067943069],
Cell[5735, 169, 47, 1, 70, "Notes",
 CellID->529540534]
}, Closed]],
Cell[CellGroupData[{
Cell[5819, 175, 460, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->26253387],
Cell[CellGroupData[{
Cell[6304, 192, 147, 5, 70, "ExampleSection",
 CellID->33717520],
Cell[6454, 199, 132, 6, 70, "ExampleText",
 CellID->885726909],
Cell[6589, 207, 100, 3, 70, "Input",
 CellID->237225796],
Cell[6692, 212, 214, 6, 70, "ExampleText",
 CellID->105341754],
Cell[6909, 220, 789, 22, 70, "Input",
 CellID->347042507],
Cell[7701, 244, 137, 4, 70, "ExampleText",
 CellID->68003369],
Cell[CellGroupData[{
Cell[7863, 252, 2193, 69, 70, "Input",
 CellID->99122243],
Cell[10059, 323, 2092, 49, 196, "Output",
 CellID->324942390]
}, Open  ]],
Cell[12166, 375, 135, 4, 70, "ExampleText",
 CellID->335828069]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12350, 385, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[12770, 399, 199, 4, 70, "SeeAlso",
 CellID->700084885]
}, Open  ]],
Cell[CellGroupData[{
Cell[13006, 408, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[13428, 422, 196, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[13661, 431, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[14083, 445, 156, 3, 70, "MoreAbout",
 CellID->1665078683]
}, Open  ]],
Cell[14254, 451, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

