(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     16734,        574]
NotebookOptionsPosition[     12820,        445]
NotebookOutlinePosition[     14449,        491]
CellTagsIndexPosition[     14364,        486]
WindowTitle->MirrorXAxis - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"A1  Data Type CartesianVectors\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"MakeCartesianVectors\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/MakeCartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"CartesianVectors\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/MirrorXAxis\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/MirrorXAxis"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
MirrorXAxis.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/MirrorXAxis", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["MirrorXAxis", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MirrorXAxis", "[", 
       StyleBox["r", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]reflects a collection of two-dimensional vectors \
through the ",
     Cell[BoxData[
      StyleBox["x", "TI"]], "InlineFormula"],
     "-axis."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->661564054],

Cell[TextData[{
 "Collections of vectors are of the data type ",
 Cell[BoxData[
  ButtonBox["CartesianVectors",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/CartesianVectors"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069],

Cell["\<\
MirrorXAxis maintains the clockwise numbering convention for ordering panels.\
\>", "Notes",
 CellID->61718882],

Cell["New in 1.0   |   Last modified in 1.1", "Notes",
 CellID->529540534]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->721796909],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->902104680],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->693742856],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->118809426],

Cell["\<\
Specify a collection of vectors describing a triangle.  Use the clockwise \
numbering convention for ordering panels.\
\>", "ExampleText",
 CellID->134609565],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"r", "=", 
  RowBox[{"MakeCartesianVectors", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1.", ",", "0.", ",", "0.25", ",", "1."}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5", ",", "0.5", ",", "0.65", ",", "0.5"}], "}"}]}], "}"}], 
   "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->95442210],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.`", ",", "0.`", ",", "0.25`", ",", "1.`"}], "}"}], 
   "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{"0.5`", ",", "0.5`", ",", "0.65`", ",", "0.5`"}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{1., 0., 0.25, 1.}, {0.5, 
    0.5, 0.65, 0.5}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{268, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->95768132]
}, Open  ]],

Cell["Plot the triangle.", "ExampleText",
 CellID->158847682],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gr", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{"r", ",", 
    RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.1"}], ",", "1.1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.75"}], "}"}]}], "}"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->133934283],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], 
   LineBox[{{1., 0.5}, {0., 0.5}, {0.25, 0.65}, {1., 0.5}}]},
  Axes->True,
  Frame->True,
  PlotRange->{{-0.1, 1.1}, {0, 0.75}},
  PlotRangeClipping->True]], "Output",
 ImageSize->{184, 118},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->108531836]
}, Open  ]],

Cell[TextData[{
 "Reflect the collection of vectors through the ",
 Cell[BoxData[
  StyleBox["x", "TI"]], "InlineFormula"],
 "-axis."
}], "ExampleText",
 CellID->191826588],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rImage", "=", 
  RowBox[{"MirrorXAxis", "[", "r", "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->164812042],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.`", ",", "0.25`", ",", "0.`", ",", "1.`"}], "}"}], 
   "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.5`"}], ",", 
     RowBox[{"-", "0.65`"}], ",", 
     RowBox[{"-", "0.5`"}], ",", 
     RowBox[{"-", "0.5`"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{1., 0.25, 0., 
    1.}, {-0.5, -0.65, -0.5, -0.5}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{300, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->366355785]
}, Open  ]],

Cell["\<\
Note that the ordering in the collection of vectors describing the image \
maintains the clockwise numbering convention.\
\>", "ExampleText",
 CellID->6392095],

Cell["Plot the original figure and its image.", "ExampleText",
 CellID->47530447],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"grImage", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{"rImage", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"gr", ",", "grImage", ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.1"}], ",", "1.1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.75"}], ",", "0.75"}], "}"}]}], "}"}]}]}], 
  "]"}]}], "Input",
 CellLabel->"In[5]:=",
 CellID->224624262],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.67, 0.6, 0.6], 
    LineBox[{{1., 0.5}, {0., 0.5}, {0.25, 0.65}, {1., 0.5}}]}, 
   {Hue[0.67, 0.6, 0.6], 
    LineBox[{{1., -0.5}, {0.25, -0.65}, {0., -0.5}, {1., -0.5}}]}},
  Axes->True,
  Frame->True,
  PlotRange->{{-0.1, 1.1}, {-0.75, 0.75}},
  PlotRangeClipping->True]], "Output",
 ImageSize->{184, 211},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->791240347]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[StyleBox[ButtonBox["MakeCartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/ref/MakeCartesianVectors"],
 FontFamily->"Verdana"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["A1  Data Type CartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"]], "Tutorials",
 CellID->109763630]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["CartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/CartesianVectors"]], "MoreAbout",
 CellID->349675741]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MirrorXAxis - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 10, 1, 26.6880000}", "context" -> 
    "Aerodynamics`CartesianVectors`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "MirrorXAxis[r] reflects a collection of two-dimensional vectors through \
the x-axis.", "synonyms" -> {}, "title" -> "MirrorXAxis", "type" -> "Symbol", 
    "uri" -> "Aerodynamics/ref/MirrorXAxis"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5616, 170, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->721796909]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 14221, 479}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 76, 1, 70, "SymbolColorBar"],
Cell[683, 24, 191, 5, 70, "LinkTrail"],
Cell[877, 31, 3065, 72, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3967, 107, 54, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[4024, 110, 483, 15, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4544, 130, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->661564054],
Cell[5127, 149, 251, 8, 70, "Notes",
 CellID->1067943069],
Cell[5381, 159, 121, 3, 70, "Notes",
 CellID->61718882],
Cell[5505, 164, 74, 1, 70, "Notes",
 CellID->529540534]
}, Closed]],
Cell[CellGroupData[{
Cell[5616, 170, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->721796909],
Cell[CellGroupData[{
Cell[6102, 187, 148, 5, 70, "ExampleSection",
 CellID->902104680],
Cell[6253, 194, 132, 6, 70, "ExampleText",
 CellID->693742856],
Cell[6388, 202, 100, 3, 70, "Input",
 CellID->118809426],
Cell[6491, 207, 168, 4, 70, "ExampleText",
 CellID->134609565],
Cell[CellGroupData[{
Cell[6684, 215, 352, 11, 70, "Input",
 CellID->95442210],
Cell[7039, 228, 518, 16, 36, "Output",
 CellID->95768132]
}, Open  ]],
Cell[7572, 247, 61, 1, 70, "ExampleText",
 CellID->158847682],
Cell[CellGroupData[{
Cell[7658, 252, 546, 16, 70, "Input",
 CellID->133934283],
Cell[8207, 270, 353, 12, 139, "Output",
 CellID->108531836]
}, Open  ]],
Cell[8575, 285, 172, 6, 70, "ExampleText",
 CellID->191826588],
Cell[CellGroupData[{
Cell[8772, 295, 135, 4, 70, "Input",
 CellID->164812042],
Cell[8910, 301, 607, 20, 36, "Output",
 CellID->366355785]
}, Open  ]],
Cell[9532, 324, 169, 4, 70, "ExampleText",
 CellID->6392095],
Cell[9704, 330, 81, 1, 70, "ExampleText",
 CellID->47530447],
Cell[CellGroupData[{
Cell[9810, 335, 585, 20, 70, "Input",
 CellID->224624262],
Cell[10398, 357, 455, 14, 232, "Output",
 CellID->791240347]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10914, 378, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[11334, 392, 195, 4, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[11566, 401, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[11988, 415, 174, 3, 70, "Tutorials",
 CellID->109763630]
}, Open  ]],
Cell[CellGroupData[{
Cell[12199, 423, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[12621, 437, 157, 3, 70, "MoreAbout",
 CellID->349675741]
}, Open  ]],
Cell[12793, 443, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

