(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     32912,       1022]
NotebookOptionsPosition[     27732,        851]
NotebookOutlinePosition[     29525,        899]
CellTagsIndexPosition[     29440,        894]
WindowTitle->NDiscretizeUnitSegment - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"1.1 Introduction To Airfoil Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/IntroductionToAirfoilGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AirfoilSurfacePoints\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/AirfoilSurfacePoints"], "\<\"PanelPoints\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/ref/PanelPoints"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AirfoilGeometry\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/AirfoilGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Aerodynamics/ref/NDiscretizeUnitSegment\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/NDiscretizeUnitSegment"]}, Visible -> 
            False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
NDiscretizeUnitSegment.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/NDiscretizeUnitSegment", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["NDiscretizeUnitSegment", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"NDiscretizeUnitSegment", "[", 
       StyleBox["n", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns a list of ",
     Cell[BoxData[
      RowBox[{
       StyleBox["n", "TI"], "+", "1"}]], "InlineFormula"],
     " numbers in the range from zero to one, dividing the unit segment into ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"],
     " sub-segments. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"NDiscretizeUnitSegment", "[", 
       RowBox[{
        StyleBox["n", "TI"], ",", 
        StyleBox["m", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns the list of numbers to precision ",
     Cell[BoxData[
      StyleBox["m", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->25843688],

Cell["The following options can be given: ", "Notes"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["Layout",
     BaseStyle->"Link",
     ButtonData->"paclet:Aerodynamics/ref/Layout"], 
    ButtonBox["ConstantSpacing",
     BaseStyle->"Link",
     ButtonData->"paclet:Aerodynamics/ref/ConstantSpacing"], Cell[TextData[{
     Cell[BoxData[
      ButtonBox["Layout",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/Layout"]], "InlineFormula"],
     " is an option of ",
     Cell[BoxData["NDiscretizeUnitSegment"], "InlineFormula"],
     " providing some flexibility for discretizing an airfoil."
    }], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["PanelOffset",
     BaseStyle->"Link",
     ButtonData->"paclet:Aerodynamics/ref/PanelOffset"], "0.", Cell[TextData[{
     Cell[BoxData[
      ButtonBox["PanelOffset",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/PanelOffset"]], "InlineFormula"],
     " is an option for the functions ",
     Cell[BoxData["NDiscretizeUnitSegment"], "InlineFormula"],
     " and ",
     Cell[BoxData[
      ButtonBox["PanelPoints",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/PanelPoints"]], "InlineFormula"],
     " allowing flexibility in locating points."
    }], "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}}],

Cell["New in 1.0", "Notes",
 CellID->529540534]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->630817520],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->34950866],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->396165825],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->230514364],

Cell["\<\
Divide the unit segment into 10 sub-segments using using the default value of \
Layout.\
\>", "ExampleText",
 CellID->297313774],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NDiscretizeUnitSegment", "[", "10", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->30360763],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.`", ",", "0.1`", ",", "0.2`", ",", "0.30000000000000004`", ",", "0.4`", 
   ",", "0.5`", ",", "0.6000000000000001`", ",", "0.7000000000000001`", ",", 
   "0.8`", ",", "0.9`", ",", "1.`"}], "}"}]], "Output",
 ImageSize->{345, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->268311093]
}, Open  ]],

Cell["Specify 25 digit precision.", "ExampleText",
 CellID->293570029],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NDiscretizeUnitSegment", "[", 
  RowBox[{"5", ",", "25"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->431048280],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0.2`25.", ",", 
   "0.3999999999999999999999999999999999999999999999999999999999`25.", ",", 
   "0.5999999999999999999999999999999999999999999999999999999999`25.", ",", 
   "0.7999999999999999999999999999999999999999999999999999999999`25.", ",", 
   "0.9999999999999999999999999999999999999999999999999999999998`25."}], 
  "}"}]], "Output",
 ImageSize->{408, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->548007534]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(2)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->2061341341],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Layout",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1757724783],

Cell[TextData[{
 "Subdivide the unit segment into ",
 Cell[BoxData[
  StyleBox["n", "TI"]], "InlineFormula"],
 " pieces for each value of Layout."
}], "ExampleText",
 CellID->105341754],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xCon", " ", "=", " ", 
   RowBox[{"NDiscretizeUnitSegment", "[", 
    RowBox[{"n", ",", " ", 
     RowBox[{"Layout", " ", "\[Rule]", " ", "ConstantSpacing"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xCos", " ", "=", " ", 
   RowBox[{"NDiscretizeUnitSegment", "[", 
    RowBox[{"n", ",", " ", 
     RowBox[{"Layout", " ", "\[Rule]", " ", "CosineSpacing"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xHCos", " ", "=", " ", 
   RowBox[{"NDiscretizeUnitSegment", "[", 
    RowBox[{"n", ",", " ", 
     RowBox[{"Layout", " ", "\[Rule]", " ", "HalfCosineSpacing"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->347042507],

Cell["\<\
Illustrate the layout options by graphing the three lists of points generated \
above. \
\>", "ExampleText",
 CellID->68003369],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"AspectRatio", "\[Rule]", ".1"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"7", " ", "72"}], "}"}]}], ",", 
      RowBox[{"Ticks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "None"}], "}"}]}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gxCon", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"xCon", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"Length", "[", "xCon", "]"}], "}"}]}], "]"}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"PointSize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gxCos", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"xCos", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"Length", "[", "xCos", "]"}], "}"}]}], "]"}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"PointSize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gxHCos", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"xHCos", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"Length", "[", "xHCos", "]"}], "}"}]}], "]"}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Green", ",", 
        RowBox[{"PointSize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsColumn", "[", 
  RowBox[{"{", 
   RowBox[{"gxCon", ",", "gxCos", ",", "gxHCos"}], "}"}], "]"}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->99122243],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[
      {RGBColor[1, 0, 0], PointSize[Large], 
       PointBox[{{0., 0.}, {0.1, 0.}, {0.2, 0.}, {0.30000000000000004`, 0.}, {
        0.4, 0.}, {0.5, 0.}, {0.6000000000000001, 0.}, {0.7000000000000001, 
        0.}, {0.8, 0.}, {0.9, 0.}, {1., 0.}}]},
      AspectRatio->0.1,
      Axes->True,
      ImageSize->{504},
      PlotRange->Automatic,
      PlotRangeClipping->True,
      Ticks->{Automatic, None}], {264.6, -27.090000000000003`}, 
     ImageScaled[{0.5, 0.5}], {504, 50.400000000000006`}], InsetBox[
     GraphicsBox[
      {RGBColor[0, 0, 1], PointSize[Large], 
       PointBox[{{0., 0.}, {0.024471741852423234`, 0.}, {0.09549150281252627, 
        0.}, {0.2061073738537635, 0.}, {0.3454915028125263, 0.}, {
        0.49999999999999994`, 0.}, {0.6545084971874737, 0.}, {
        0.7938926261462365, 0.}, {0.9045084971874737, 0.}, {
        0.9755282581475768, 0.}, {1., 0.}}]},
      AspectRatio->0.1,
      Axes->True,
      ImageSize->{504},
      PlotRange->Automatic,
      PlotRangeClipping->True,
      Ticks->{Automatic, None}], {264.6, -81.27000000000001}, 
     ImageScaled[{0.5, 0.5}], {504, 50.400000000000006`}], InsetBox[
     GraphicsBox[
      {RGBColor[0, 1, 0], PointSize[Large], 
       PointBox[{{0., 0.}, {0.01231165940486223, 0.}, {0.04894348370484647, 
        0.}, {0.1089934758116321, 0.}, {0.19098300562505255`, 0.}, {
        0.2928932188134524, 0.}, {0.412214747707527, 0.}, {0.5460095002604533,
         0.}, {0.6909830056250525, 0.}, {0.843565534959769, 0.}, {
        0.9999999999999999, 0.}}]},
      AspectRatio->0.1,
      Axes->True,
      ImageSize->{504},
      PlotRange->Automatic,
      PlotRangeClipping->True,
      Ticks->{Automatic, None}], {264.6, -135.45000000000002`}, 
     ImageScaled[{0.5, 0.5}], {504, 50.400000000000006`}]}, {}},
  ContentSelectable->True,
  ImageSize->{541.2, 174.54000000000002`},
  PlotRangePadding->{6, 5}]], "Output",
 ImageSize->{545, 175},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->183092658]
}, Open  ]],

Cell[TextData[{
 "Note that ",
 Cell[BoxData[
  RowBox[{
   StyleBox["n", "TI"], "+", "1"}]], "InlineFormula"],
 " panel endpoints are generated."
}], "ExampleText",
 CellID->789732082],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "/@", 
  RowBox[{"{", 
   RowBox[{"xCon", ",", "xCos", ",", "xHCos"}], "}"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->105948418],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"11", ",", "11", ",", "11"}], "}"}]], "Output",
 ImageSize->{82, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->34918545]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "PanelOffset",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1295379749],

Cell["\<\
Points interior to the sub-segments are specified by the option PanelOffset.  \
Here, the default value for Layout is used and points are located in the \
middle of each segment.\
\>", "ExampleText",
 CellID->914405104],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xMid", "=", 
  RowBox[{"NDiscretizeUnitSegment", "[", 
   RowBox[{"n", ",", 
    RowBox[{"PanelOffset", "\[Rule]", "0.5"}]}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->46504520],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.05`", ",", "0.15000000000000002`", ",", "0.25`", ",", 
   "0.35000000000000003`", ",", "0.45`", ",", "0.55`", ",", 
   "0.6500000000000001`", ",", "0.75`", ",", "0.8500000000000001`", ",", 
   "0.95`"}], "}"}]], "Output",
 ImageSize->{397, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->47327331]
}, Open  ]],

Cell[TextData[{
 "For interior points, NDiscretizeUnitSegment returns ",
 Cell[BoxData[
  StyleBox["n", "TI"]], "InlineFormula"],
 " points."
}], "ExampleText",
 CellID->243860688],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "xMid", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->431832227],

Cell[BoxData["10"], "Output",
 ImageSize->{18, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->508597510]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Applications",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->258228157],

Cell["\<\
Compute two collections of vectors, one locating panel end points for a \
discretized NACA 4415 airfoil, and the other locating collocation points at \
mid-panel.  Plot the two collections of points, joining the panel endpoints \
to show the discretized airfoil.  The resulting graph illustrates a \
discretized with collocation points at mid-panel.\
\>", "ExampleText",
 CellID->21363168],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rP", "=", 
   RowBox[{"AirfoilSurfacePoints", "[", 
    RowBox[{"NACA4DigitAirfoil", "[", 
     RowBox[{"4415", ",", 
      RowBox[{"NDiscretizeUnitSegment", "[", 
       RowBox[{"5", ",", 
        RowBox[{"Layout", "\[Rule]", "HalfCosineSpacing"}]}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rC", "=", 
   RowBox[{"PanelPoints", "[", "rP", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"grP", "=", 
   RowBox[{"PlotAirfoil", "[", "rP", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"grC", "=", 
   RowBox[{"PlotAirfoil", "[", 
    RowBox[{"rC", ",", 
     RowBox[{"Joined", "\[Rule]", "False"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"grP", ",", "grC"}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->333885958],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.67, 0.6, 0.6], 
    LineBox[{{0.9997918421408566, -0.0015611839435751304`}, {
     0.6879573940418148, -0.016198441614263596`}, {
     0.41201947304449976`, -0.03195715360845929}, {
     0.19836607364310915`, -0.04156765018480128}, {
     0.05655570289022391, -0.03417765488167223}, {0., 0.}, {
     0.04133126451946903, 0.052557316065027525`}, {0.18359993760699594`, 
     0.09972359821603287}, {0.4124100223705542, 0.11192399803922404`}, {
     0.6940086172082903, 0.07738263948924372}, {1.0002081578591433`, 
     0.0015611839435751551`}}]}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0.8438746180913357, -0.008879812778919364}, {
     0.5499884335431573, -0.024077797611361446`}, {
     0.30519277334380446`, -0.036762401896630284`}, {
     0.12746088826666652`, -0.03787265253323675}, {
     0.028277851445111954`, -0.017088827440836115`}, {0.020665632259734515`, 
     0.026278658032513762`}, {0.11246560106323249`, 0.0761404571405302}, {
     0.29800497998877507`, 0.10582379812762846`}, {0.5532093197894222, 
     0.09465331876423388}, {0.8471083875337169, 0.03947191171640944}}]}},
  Frame->True,
  FrameLabel->{
    FormBox["\"x\"", TraditionalForm], 
    FormBox["\"z\"", TraditionalForm]},
  FrameTicks->{{{-1.2, 
      FormBox[
       RowBox[{"-", "1.2`"}], TraditionalForm]}, {-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.7999999999999999, 
      FormBox[
       RowBox[{"-", "0.7999999999999999`"}], 
       TraditionalForm]}, {-0.5999999999999999, 
      FormBox[
       RowBox[{"-", "0.5999999999999999`"}], 
       TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {1.0000000000000002`, 
      FormBox["1.0000000000000002`", TraditionalForm]}, {1.2000000000000004`, 
      FormBox["1.2000000000000004`", TraditionalForm]}, {1.4000000000000001`, 
      FormBox["1.4000000000000001`", TraditionalForm]}, {1.6, 
      FormBox["1.6`", TraditionalForm]}}, {{-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.9, 
      FormBox[
       RowBox[{"-", "0.9`"}], TraditionalForm]}, {-0.8, 
      FormBox[
       RowBox[{"-", "0.8`"}], TraditionalForm]}, {-0.7, 
      FormBox[
       RowBox[{"-", "0.7`"}], TraditionalForm]}, {-0.6, 
      FormBox[
       RowBox[{"-", "0.6`"}], TraditionalForm]}, {-0.5, 
      FormBox[
       RowBox[{"-", "0.5`"}], TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.29999999999999993`, 
      FormBox[
       RowBox[{"-", "0.29999999999999993`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], 
       TraditionalForm]}, {-0.09999999999999998, 
      FormBox[
       RowBox[{"-", "0.09999999999999998`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.10000000000000009`, 
      FormBox["0.10000000000000009`", TraditionalForm]}, {
     0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.30000000000000004`, 
      FormBox["0.30000000000000004`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.5, 
      FormBox["0.5`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.7000000000000002, 
      FormBox["0.7000000000000002`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {0.9000000000000001, 
      FormBox["0.9000000000000001`", TraditionalForm]}, {1., 
      FormBox["1.`", TraditionalForm]}}, None, {{-1., 
      FormBox[
       RowBox[{"-", "1.`"}], TraditionalForm]}, {-0.9, 
      FormBox[
       RowBox[{"-", "0.9`"}], TraditionalForm]}, {-0.8, 
      FormBox[
       RowBox[{"-", "0.8`"}], TraditionalForm]}, {-0.7, 
      FormBox[
       RowBox[{"-", "0.7`"}], TraditionalForm]}, {-0.6, 
      FormBox[
       RowBox[{"-", "0.6`"}], TraditionalForm]}, {-0.5, 
      FormBox[
       RowBox[{"-", "0.5`"}], TraditionalForm]}, {-0.3999999999999999, 
      FormBox[
       RowBox[{"-", "0.3999999999999999`"}], 
       TraditionalForm]}, {-0.29999999999999993`, 
      FormBox[
       RowBox[{"-", "0.29999999999999993`"}], 
       TraditionalForm]}, {-0.19999999999999996`, 
      FormBox[
       RowBox[{"-", "0.19999999999999996`"}], 
       TraditionalForm]}, {-0.09999999999999998, 
      FormBox[
       RowBox[{"-", "0.09999999999999998`"}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {0.10000000000000009`, 
      FormBox["0.10000000000000009`", TraditionalForm]}, {
     0.20000000000000018`, 
      FormBox["0.20000000000000018`", TraditionalForm]}, {
     0.30000000000000004`, 
      FormBox["0.30000000000000004`", TraditionalForm]}, {
     0.40000000000000013`, 
      FormBox["0.40000000000000013`", TraditionalForm]}, {0.5, 
      FormBox["0.5`", TraditionalForm]}, {0.6000000000000001, 
      FormBox["0.6000000000000001`", TraditionalForm]}, {0.7000000000000002, 
      FormBox["0.7000000000000002`", TraditionalForm]}, {0.8, 
      FormBox["0.8`", TraditionalForm]}, {0.9000000000000001, 
      FormBox["0.9000000000000001`", TraditionalForm]}, {1., 
      FormBox["1.`", TraditionalForm]}}},
  ImageSize->{504., 180.},
  PlotRange->{{-0.05, 1.05}, {-0.1, 0.201}},
  PlotRangeClipping->True,
  RotateLabel->False,
  Ticks->{Automatic, None}]], "Output",
 ImageSize->{508, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->287350269]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[{
 StyleBox[ButtonBox["AirfoilSurfacePoints",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/AirfoilSurfacePoints"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["PanelPoints",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/PanelPoints"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["1.1 Introduction To Airfoil Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Aerodynamics/tutorial/IntroductionToAirfoilGeometry"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["AirfoilGeometry",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/AirfoilGeometry"]], "MoreAbout",
 CellID->249563248]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"NDiscretizeUnitSegment - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 10, 1, 39.2928000}", "context" -> 
    "Aerodynamics`AirfoilGeometry`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "NDiscretizeUnitSegment[n] returns a list of n + 1 numbers in the range \
from zero to one, dividing the unit segment into n sub-segments. \
NDiscretizeUnitSegment[n, m] returns the list of numbers to precision m.", 
    "synonyms" -> {}, "title" -> "NDiscretizeUnitSegment", "type" -> "Symbol",
     "uri" -> "Aerodynamics/ref/NDiscretizeUnitSegment"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7473, 214, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->630817520]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 29297, 887}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[615, 21, 76, 1, 70, "SymbolColorBar"],
Cell[694, 24, 191, 5, 70, "LinkTrail"],
Cell[888, 31, 3245, 75, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4158, 110, 65, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[4226, 113, 984, 29, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5247, 147, 579, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->25843688],
Cell[5829, 166, 53, 0, 70, "Notes"],
Cell[5885, 168, 1501, 38, 70, "3ColumnTableMod"],
Cell[7389, 208, 47, 1, 70, "Notes",
 CellID->529540534]
}, Closed]],
Cell[CellGroupData[{
Cell[7473, 214, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->630817520],
Cell[CellGroupData[{
Cell[7959, 231, 147, 5, 70, "ExampleSection",
 CellID->34950866],
Cell[8109, 238, 132, 6, 70, "ExampleText",
 CellID->396165825],
Cell[8244, 246, 100, 3, 70, "Input",
 CellID->230514364],
Cell[8347, 251, 138, 4, 70, "ExampleText",
 CellID->297313774],
Cell[CellGroupData[{
Cell[8510, 259, 118, 3, 70, "Input",
 CellID->30360763],
Cell[8631, 264, 382, 10, 36, "Output",
 CellID->268311093]
}, Open  ]],
Cell[9028, 277, 70, 1, 70, "ExampleText",
 CellID->293570029],
Cell[CellGroupData[{
Cell[9123, 282, 142, 4, 70, "Input",
 CellID->431048280],
Cell[9268, 288, 524, 13, 71, "Output",
 CellID->548007534]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9841, 307, 223, 7, 70, "ExampleSection",
 CellID->2061341341],
Cell[CellGroupData[{
Cell[10089, 318, 228, 7, 70, "ExampleSubsection",
 CellID->1757724783],
Cell[10320, 327, 185, 6, 70, "ExampleText",
 CellID->105341754],
Cell[10508, 335, 789, 22, 70, "Input",
 CellID->347042507],
Cell[11300, 359, 137, 4, 70, "ExampleText",
 CellID->68003369],
Cell[CellGroupData[{
Cell[11462, 367, 2193, 69, 70, "Input",
 CellID->99122243],
Cell[13658, 438, 2092, 49, 196, "Output",
 CellID->183092658]
}, Open  ]],
Cell[15765, 490, 185, 7, 70, "ExampleText",
 CellID->789732082],
Cell[CellGroupData[{
Cell[15975, 501, 165, 5, 70, "Input",
 CellID->105948418],
Cell[16143, 508, 215, 7, 36, "Output",
 CellID->34918545]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[16407, 521, 233, 7, 70, "ExampleSubsection",
 CellID->1295379749],
Cell[16643, 530, 229, 5, 70, "ExampleText",
 CellID->914405104],
Cell[CellGroupData[{
Cell[16897, 539, 210, 6, 70, "Input",
 CellID->46504520],
Cell[17110, 547, 396, 11, 36, "Output",
 CellID->47327331]
}, Open  ]],
Cell[17521, 561, 180, 6, 70, "ExampleText",
 CellID->243860688],
Cell[CellGroupData[{
Cell[17726, 571, 105, 3, 70, "Input",
 CellID->431832227],
Cell[17834, 576, 159, 5, 36, "Output",
 CellID->508597510]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[18054, 588, 227, 7, 70, "ExampleSection",
 CellID->258228157],
Cell[18284, 597, 399, 7, 70, "ExampleText",
 CellID->21363168],
Cell[CellGroupData[{
Cell[18708, 608, 861, 25, 70, "Input",
 CellID->333885958],
Cell[19572, 635, 6021, 134, 201, "Output",
 CellID->287350269]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25654, 776, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[26074, 790, 347, 11, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[26458, 806, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[26880, 820, 196, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[27113, 829, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[27535, 843, 155, 3, 70, "MoreAbout",
 CellID->249563248]
}, Open  ]],
Cell[27705, 849, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

