(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     16576,        565]
NotebookOptionsPosition[     12446,        427]
NotebookOutlinePosition[     14117,        474]
CellTagsIndexPosition[     14032,        469]
WindowTitle->PanelOffset - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"1.1 Introduction To Airfoil Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/IntroductionToAirfoilGeometry"], \
"\<\"1.5 Panel Geometry\"\>":>Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/PanelGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"NDiscretizeUnitSegment\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/NDiscretizeUnitSegment"], \
"\<\"PanelPoints\"\>":>Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/PanelPoints"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AirfoilGeometry\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/AirfoilGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/PanelOffset\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/PanelOffset"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
PanelOffset.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/PanelOffset", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PanelOffset", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["PanelOffset"], "InlineFormula"],
     "\[LineSeparator]is an option for the functions ",
     Cell[BoxData[
      ButtonBox["NDiscretizeUnitSegment",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/NDiscretizeUnitSegment"]], 
      "InlineFormula"],
     " and ",
     Cell[BoxData[
      ButtonBox["PanelPoints",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/PanelPoints"]], "InlineFormula"],
     " allowing flexibility in locating points."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->163525005],

Cell["New in 1.0", "Notes",
 CellID->918694056]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->14262548],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->522622362],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->819145224],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2090244],

Cell["Display the default options for NDiscretizeUnitSegment.", "ExampleText",
 CellID->611747941],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "NDiscretizeUnitSegment", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->334972181],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Layout", "\[Rule]", "ConstantSpacing"}], ",", 
   RowBox[{"PanelOffset", "\[Rule]", "0.`"}]}], "}"}]], "Output",
 ImageSize->{301, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->447038259]
}, Open  ]],

Cell["\<\
With these options, equally spaced points are computed on the unit segment.\
\>", "ExampleText",
 CellID->141096074],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xEnd", "=", 
  RowBox[{"NDiscretizeUnitSegment", "[", "10", "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->80434706],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.`", ",", "0.1`", ",", "0.2`", ",", "0.30000000000000004`", ",", "0.4`", 
   ",", "0.5`", ",", "0.6000000000000001`", ",", "0.7000000000000001`", ",", 
   "0.8`", ",", "0.9`", ",", "1.`"}], "}"}]], "Output",
 ImageSize->{345, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->457515815]
}, Open  ]],

Cell["\<\
Note that the length of the list is one greater than the discretization \
number used as the input argument.\
\>", "ExampleText",
 CellID->53226141],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "xEnd", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->2359351],

Cell[BoxData["11"], "Output",
 ImageSize->{18, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->177092830]
}, Open  ]],

Cell["\<\
If the value of PanelOffset is greater than 0 and less than 1, a list of \
interior points is returned\
\>", "ExampleText",
 CellID->407722081],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xQuarter", "=", 
  RowBox[{"NDiscretizeUnitSegment", "[", 
   RowBox[{"10", ",", 
    RowBox[{"PanelOffset", "\[Rule]", "0.25"}]}], "]"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->136857109],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.025`", ",", "0.125`", ",", "0.22500000000000003`", ",", 
   "0.32500000000000007`", ",", "0.42500000000000004`", ",", "0.525`", ",", 
   "0.6250000000000001`", ",", "0.7250000000000001`", ",", 
   "0.8250000000000001`", ",", "0.925`"}], "}"}]], "Output",
 ImageSize->{467, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->224171407]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xMid", "=", 
  RowBox[{"NDiscretizeUnitSegment", "[", 
   RowBox[{"10", ",", 
    RowBox[{"PanelOffset", "\[Rule]", "0.5"}]}], "]"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->277556629],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.05`", ",", "0.15000000000000002`", ",", "0.25`", ",", 
   "0.35000000000000003`", ",", "0.45`", ",", "0.55`", ",", 
   "0.6500000000000001`", ",", "0.75`", ",", "0.8500000000000001`", ",", 
   "0.95`"}], "}"}]], "Output",
 ImageSize->{397, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->47660907]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "/@", 
  RowBox[{"{", 
   RowBox[{"xQuarter", ",", "xMid"}], "}"}]}]], "Input",
 CellLabel->"In[7]:=",
 CellID->206100333],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"10", ",", "10"}], "}"}]], "Output",
 ImageSize->{57, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->442272587]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[{
 StyleBox[ButtonBox["NDiscretizeUnitSegment",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/NDiscretizeUnitSegment"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["PanelPoints",
  BaseStyle->"Link",
  ButtonData->"paclet:Aerodynamics/ref/PanelPoints"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->226809566]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["1.1 Introduction To Airfoil Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Aerodynamics/tutorial/IntroductionToAirfoilGeometry"]], "Tutorials",
 CellID->341631938],

Cell[TextData[ButtonBox["1.5 Panel Geometry",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/tutorial/PanelGeometry"]], "Tutorials",
 CellID->67847165]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["AirfoilGeometry",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/AirfoilGeometry"]], "MoreAbout",
 CellID->1665078683]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PanelOffset - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 10, 1, 59.6040000}", "context" -> 
    "Aerodynamics`AirfoilGeometry`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "PanelOffset is an option for the functions NDiscretizeUnitSegment and \
PanelPoints allowing flexibility in locating points.", "synonyms" -> {}, 
    "title" -> "PanelOffset", "type" -> "Symbol", "uri" -> 
    "Aerodynamics/ref/PanelOffset"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5675, 164, 460, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->14262548]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13890, 462}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 76, 1, 70, "SymbolColorBar"],
Cell[683, 24, 191, 5, 70, "LinkTrail"],
Cell[877, 31, 3296, 76, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4198, 111, 54, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[4255, 114, 716, 20, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5008, 139, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->163525005],
Cell[5591, 158, 47, 1, 70, "Notes",
 CellID->918694056]
}, Closed]],
Cell[CellGroupData[{
Cell[5675, 164, 460, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->14262548],
Cell[CellGroupData[{
Cell[6160, 181, 148, 5, 70, "ExampleSection",
 CellID->522622362],
Cell[6311, 188, 132, 6, 70, "ExampleText",
 CellID->819145224],
Cell[6446, 196, 98, 3, 70, "Input",
 CellID->2090244],
Cell[6547, 201, 98, 1, 70, "ExampleText",
 CellID->611747941],
Cell[CellGroupData[{
Cell[6670, 206, 124, 3, 70, "Input",
 CellID->334972181],
Cell[6797, 211, 295, 9, 36, "Output",
 CellID->447038259]
}, Open  ]],
Cell[7107, 223, 126, 3, 70, "ExampleText",
 CellID->141096074],
Cell[CellGroupData[{
Cell[7258, 230, 144, 4, 70, "Input",
 CellID->80434706],
Cell[7405, 236, 382, 10, 36, "Output",
 CellID->457515815]
}, Open  ]],
Cell[7802, 249, 158, 4, 70, "ExampleText",
 CellID->53226141],
Cell[CellGroupData[{
Cell[7985, 257, 103, 3, 70, "Input",
 CellID->2359351],
Cell[8091, 262, 159, 5, 36, "Output",
 CellID->177092830]
}, Open  ]],
Cell[8265, 270, 153, 4, 70, "ExampleText",
 CellID->407722081],
Cell[CellGroupData[{
Cell[8443, 278, 217, 6, 70, "Input",
 CellID->136857109],
Cell[8663, 286, 430, 11, 36, "Output",
 CellID->224171407]
}, Open  ]],
Cell[CellGroupData[{
Cell[9130, 302, 212, 6, 70, "Input",
 CellID->277556629],
Cell[9345, 310, 396, 11, 36, "Output",
 CellID->47660907]
}, Open  ]],
Cell[CellGroupData[{
Cell[9778, 326, 155, 5, 70, "Input",
 CellID->206100333],
Cell[9936, 333, 205, 7, 36, "Output",
 CellID->442272587]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10202, 347, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[10622, 361, 351, 11, 70, "SeeAlso",
 CellID->226809566]
}, Open  ]],
Cell[CellGroupData[{
Cell[11010, 377, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[11432, 391, 196, 4, 70, "Tutorials",
 CellID->341631938],
Cell[11631, 397, 158, 3, 70, "Tutorials",
 CellID->67847165]
}, Open  ]],
Cell[CellGroupData[{
Cell[11826, 405, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[12248, 419, 156, 3, 70, "MoreAbout",
 CellID->1665078683]
}, Open  ]],
Cell[12419, 425, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

