(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     26063,        685]
NotebookOptionsPosition[     22498,        572]
NotebookOutlinePosition[     24263,        620]
CellTagsIndexPosition[     24178,        615]
WindowTitle->PlotSurfacePressureCoefficient - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"PlotAirfoil\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/ref/PlotAirfoil"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"A2 Graphics\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/Graphics"], "\<\"Graphics\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/Graphics"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Aerodynamics/ref/PlotSurfacePressureCoefficient\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/PlotSurfacePressureCoefficient"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
PlotSurfacePressureCoefficient.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/PlotSurfacePressureCoefficient", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PlotSurfacePressureCoefficient", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PlotSurfacePressureCoefficient", "[", 
       RowBox[{
        StyleBox[
         SubscriptBox["x", "c"], "TI"], ",", 
        StyleBox[
         SubscriptBox["c", "p"], "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]plots surface pressure coefficients at collocation \
points versus the ",
     Cell[BoxData[
      StyleBox["x", "TI"]], "InlineFormula"],
     "-components of vectors locating collocation points. "
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->239688629],

Cell[TextData[{
 "Collections of vectors are of the data type ",
 Cell[BoxData[
  ButtonBox["CartesianVectors",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/CartesianVectors"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->556213251],

Cell["\<\
ListPlot is used to generate this plot, and of all its options are available.\
\>", "Notes",
 CellID->285650375],

Cell["New in 1.1   |   Last modified in 1.2", "Notes",
 CellID->246109562]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->274513509],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->939792],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->271529016],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->449283102],

Cell[TextData[{
 "Use the NACA-4412 airfoil at a 6\[Degree] angle of attack and ",
 Cell[BoxData[
  ButtonBox["PMVortexLinearNeumann",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/PMVortexLinearNeumann"]], 
  "InlineFormula"],
 " as the numerical model to compute surface pressure coefficients.  Plot \
surface pressure coefficient using the aerodynamics convention of plotting \
positive values below the ",
 Cell[BoxData[
  StyleBox["x", "TI"]], "InlineFormula"],
 "-axis."
}], "ExampleText",
 CellID->67775542],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rP", "=", 
   RowBox[{"AirfoilSurfacePoints", "[", 
    RowBox[{"NACA4DigitAirfoil", "[", 
     RowBox[{"4412", ",", 
      RowBox[{"NDiscretizeUnitSegment", "[", 
       RowBox[{"75", ",", 
        RowBox[{"Layout", "\[Rule]", "HalfCosineSpacing"}]}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{"6.", " ", "Degree"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "rC", ",", "VMagC"}], "}"}], "=", 
   RowBox[{"PMVortexLinearNeumann", "[", 
    RowBox[{"rP", ",", "\[Alpha]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xC", "=", 
   RowBox[{
    RowBox[{"Components", "[", "rC", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cp", "=", 
   RowBox[{"1", "-", 
    RowBox[{"VMagC", "^", "2"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PlotSurfacePressureCoefficient", "[", 
  RowBox[{"xC", ",", "cp"}], "]"}], "\[IndentingNewLine]"}], "Input",
 CellLabel->"In[2]:=",
 CellID->508498224],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJwVlWk4FHofhmeiIsrSIUsLp8hJB2mTpZ9TNPYtSgg5SJKtRaixRCSFw2Eq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    "]]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  Frame->True,
  FrameLabel->{
    FormBox["\"x\"", TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*SubscriptBox[\\(C\\), \\(p\\)]\\)\"", TraditionalForm]},
  FrameTicks->{Automatic, {{-1, 
      FormBox["\"1\"", TraditionalForm]}, {0, 
      FormBox["\"0\"", TraditionalForm]}, {1, 
      FormBox["\"-1\"", TraditionalForm]}, {2, 
      FormBox["\"-2\"", TraditionalForm]}, {3, 
      FormBox["\"-3\"", TraditionalForm]}}, None, None},
  ImageSize->504,
  PlotRange->{{-0.05, 1.05}, {-1.2, 3}},
  PlotRangeClipping->True,
  RotateLabel->False]], "Output",
 ImageSize->{508, 330},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->495693289]
}, Open  ]],

Cell["\<\
Enhancements to this plot can be made using the option Epilog.  In the \
following example, the airfoil shape is inserted in the plot for surface \
pressure coefficient.\
\>", "ExampleText",
 CellID->155810309],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotSurfacePressureCoefficient", "[", 
  RowBox[{"xC", ",", "cp", ",", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"Inset", "[", 
     RowBox[{
      RowBox[{"PlotAirfoil", "[", 
       RowBox[{"rP", ",", 
        RowBox[{"Frame", "\[Rule]", "False"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}], ",", "Automatic"}], "}"}]}]}], 
       "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], ",", "1"}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->456235213],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3d/LHXV+B/B0S6/b2/au0PaPCLTd1vbCTalYumzbNLREeNAbbYu2oDd6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    "], {{0, 330}, {504, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{504, 330},
  PlotRange->{{0, 504}, {0, 330}}]], "Output",
 ImageSize->{508, 330},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->516812521]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["PlotAirfoil",
   BaseStyle->"Link",
   ButtonData->"paclet:Aerodynamics/ref/PlotAirfoil"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->148423117]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["A2 Graphics",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/tutorial/Graphics"]], "MoreAbout",
 CellID->105375072]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["Graphics",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/Graphics"]], "MoreAbout",
 CellID->490158181]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PlotSurfacePressureCoefficient - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 10, 2, 15.0324000}", "context" -> 
    "Aerodynamics`Graphics`", "keywords" -> {}, "index" -> True, "label" -> 
    "Aerodynamics Package Paclet Symbol", "language" -> "en", "paclet" -> 
    "Aerodynamics Package", "status" -> "None", "summary" -> 
    "PlotSurfacePressureCoefficient[x_c, c_p] plots surface pressure \
coefficients at collocation points versus the x-components of vectors \
locating collocation points. ", "synonyms" -> {}, "title" -> 
    "PlotSurfacePressureCoefficient", "type" -> "Symbol", "uri" -> 
    "Aerodynamics/ref/PlotSurfacePressureCoefficient"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5574, 167, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->274513509]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 24035, 608}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[623, 21, 76, 1, 70, "SymbolColorBar"],
Cell[702, 24, 191, 5, 70, "LinkTrail"],
Cell[896, 31, 2800, 65, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3721, 100, 73, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[3797, 103, 668, 19, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4502, 127, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->239688629],
Cell[5085, 146, 250, 8, 70, "Notes",
 CellID->556213251],
Cell[5338, 156, 122, 3, 70, "Notes",
 CellID->285650375],
Cell[5463, 161, 74, 1, 70, "Notes",
 CellID->246109562]
}, Closed]],
Cell[CellGroupData[{
Cell[5574, 167, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->274513509],
Cell[CellGroupData[{
Cell[6060, 184, 145, 5, 70, "ExampleSection",
 CellID->939792],
Cell[6208, 191, 132, 6, 70, "ExampleText",
 CellID->271529016],
Cell[6343, 199, 100, 3, 70, "Input",
 CellID->449283102],
Cell[6446, 204, 530, 14, 70, "ExampleText",
 CellID->67775542],
Cell[CellGroupData[{
Cell[7001, 222, 1125, 31, 70, "Input",
 CellID->508498224],
Cell[8129, 255, 4062, 78, 351, "Output",
 CellID->495693289]
}, Open  ]],
Cell[12206, 336, 220, 5, 70, "ExampleText",
 CellID->155810309],
Cell[CellGroupData[{
Cell[12451, 345, 695, 20, 47, "Input",
 CellID->456235213],
Cell[13149, 367, 7401, 129, 351, "Output",
 CellID->516812521]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[20611, 503, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[21031, 517, 219, 6, 70, "SeeAlso",
 CellID->148423117]
}, Open  ]],
Cell[CellGroupData[{
Cell[21287, 528, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[21709, 542, 147, 3, 70, "MoreAbout",
 CellID->105375072]
}, Open  ]],
Cell[CellGroupData[{
Cell[21893, 550, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[22315, 564, 141, 3, 70, "MoreAbout",
 CellID->490158181]
}, Open  ]],
Cell[22471, 570, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

