(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     20766,        628]
NotebookOptionsPosition[     16901,        506]
NotebookOutlinePosition[     18760,        555]
CellTagsIndexPosition[     18675,        550]
WindowTitle->ReplicateVector - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"A1  Data Type CartesianVectors\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"MakeCartesianVectors\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/MakeCartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"CartesianVectors\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/ReplicateVector\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/ReplicateVector"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
ReplicateVector.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/ReplicateVector", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["ReplicateVector", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"ReplicateVector", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["2", "TR"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["3", "TR"]], ",", " ", 
          StyleBox["\[Ellipsis]", "TR"], ",", 
          StyleBox["xn", "TI"]}], "}"}], ",", 
        StyleBox["m", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns a collection of vectors consisting of ",
     Cell[BoxData[
      StyleBox["m", "TI"]], "InlineFormula"],
     " copies of a single vector represented by a simple list. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"ReplicateVector", "[", 
       RowBox[{
        StyleBox["v", "TI"], ",", " ", 
        StyleBox["m", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns a collection of vectors consisting of ",
     Cell[BoxData[
      StyleBox["m", "TI"]], "InlineFormula"],
     " copies of the collection of vectors ",
     Cell[BoxData[
      StyleBox["v", "TI"]], "InlineFormula"],
     ", whose components are simple lists."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->41331179],

Cell[TextData[{
 "If a single vector using the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " convention is input, the output is a collection of ",
 Cell[BoxData[
  StyleBox["m", "TI"]], "InlineFormula"],
 " vectors of the data type CartesianVectors, whose components are simple \
lists."
}], "Notes",
 CellID->360117373],

Cell[TextData[{
 "If a collection of vectors of the data type CartesianVectors whose \
components are simple lists is input, a collection of vectors whose \
components are matrices with ",
 Cell[BoxData[
  StyleBox["m", "TI"]], "InlineFormula"],
 " rows is returned.  Each row is a copy of ",
 Cell[BoxData[
  StyleBox["v", "TI"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->285899052],

Cell["New in 1.0", "Notes",
 CellID->918694056]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->525326755],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->116511953],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->225526168],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->69829423],

Cell[TextData[{
 "Replicate a single vector expressed in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " notation 5 times to obtain a collection of 5 identical vectors."
}], "ExampleText",
 CellID->996359],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplicateVector", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"ux", ",", "uy", ",", "uz"}], "}"}], ",", "5"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->3613516],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"ux", ",", "ux", ",", "ux", ",", "ux", ",", "ux"}], "}"}], 
   "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{"uy", ",", "uy", ",", "uy", ",", "uy", ",", "uy"}], "}"}], 
   "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{"uz", ",", "uz", ",", "uz", ",", "uz", ",", "uz"}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{$CellContext`ux, \
$CellContext`ux, $CellContext`ux, $CellContext`ux, $CellContext`ux}, \
{$CellContext`uy, $CellContext`uy, $CellContext`uy, $CellContext`uy, \
$CellContext`uy}, {$CellContext`uz, $CellContext`uz, $CellContext`uz, \
$CellContext`uz, $CellContext`uz}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{406, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->254422367]
}, Open  ]],

Cell["\<\
Specify a collection of 4 vectors whose components are simple lists.\
\>", "ExampleText",
 CellID->391360192],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "=", 
  RowBox[{"MakeCartesianVectors", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Array", "[", 
      RowBox[{"vx", ",", "4"}], "]"}], ",", 
     RowBox[{"Array", "[", 
      RowBox[{"vy", ",", "4"}], "]"}], ",", 
     RowBox[{"Array", "[", 
      RowBox[{"vz", ",", "4"}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->114029401],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vx", "[", "1", "]"}], ",", 
     RowBox[{"vx", "[", "2", "]"}], ",", 
     RowBox[{"vx", "[", "3", "]"}], ",", 
     RowBox[{"vx", "[", "4", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vy", "[", "1", "]"}], ",", 
     RowBox[{"vy", "[", "2", "]"}], ",", 
     RowBox[{"vy", "[", "3", "]"}], ",", 
     RowBox[{"vy", "[", "4", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vz", "[", "1", "]"}], ",", 
     RowBox[{"vz", "[", "2", "]"}], ",", 
     RowBox[{"vz", "[", "3", "]"}], ",", 
     RowBox[{"vz", "[", "4", "]"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{
     $CellContext`vx[1], 
     $CellContext`vx[2], 
     $CellContext`vx[3], 
     $CellContext`vx[4]}, {
     $CellContext`vy[1], 
     $CellContext`vy[2], 
     $CellContext`vy[3], 
     $CellContext`vy[4]}, {
     $CellContext`vz[1], 
     $CellContext`vz[2], 
     $CellContext`vz[3], 
     $CellContext`vz[4]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{583, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->99607303]
}, Open  ]],

Cell["Replicate the collection 5 times.", "ExampleText",
 CellID->124790726],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ReplicateVector", "[", 
   RowBox[{"v", ",", "5"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->277273771],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztna1y40gURl27T7KvkSdYvE8wNSA1bAPDBgYmLHDgwGEODAzMAwQMDAwM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    "], {{0, 72}, {570, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{570, 72},
  PlotRange->{{0, 570}, {0, 72}}]], "Output",
 ImageSize->{574, 72},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->291935952]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[StyleBox[ButtonBox["MakeCartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/ref/MakeCartesianVectors"],
 FontFamily->"Verdana"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["A1  Data Type CartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["CartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/CartesianVectors"]], "MoreAbout",
 CellID->630835379]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"ReplicateVector - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 10, 2, 43.4400000}", "context" -> 
    "Aerodynamics`CartesianVectors`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "ReplicateVector[{x_1, x_2, x_3, ..., xn}, m] returns a collection of \
vectors consisting of m copies of a single vector represented by a simple \
list. ReplicateVector[v, m] returns a collection of vectors consisting of m \
copies of the collection of vectors v, whose components are simple lists.", 
    "synonyms" -> {}, "title" -> "ReplicateVector", "type" -> "Symbol", "uri" -> 
    "Aerodynamics/ref/ReplicateVector"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6942, 207, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->525326755]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 18532, 543}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[608, 21, 76, 1, 70, "SymbolColorBar"],
Cell[687, 24, 191, 5, 70, "LinkTrail"],
Cell[881, 31, 3081, 72, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3987, 107, 58, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[4048, 110, 1469, 42, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5554, 157, 579, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->41331179],
Cell[6136, 176, 329, 10, 70, "Notes",
 CellID->360117373],
Cell[6468, 188, 387, 11, 70, "Notes",
 CellID->285899052],
Cell[6858, 201, 47, 1, 70, "Notes",
 CellID->918694056]
}, Closed]],
Cell[CellGroupData[{
Cell[6942, 207, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->525326755],
Cell[CellGroupData[{
Cell[7428, 224, 148, 5, 70, "ExampleSection",
 CellID->116511953],
Cell[7579, 231, 132, 6, 70, "ExampleText",
 CellID->225526168],
Cell[7714, 239, 99, 3, 70, "Input",
 CellID->69829423],
Cell[7816, 244, 212, 6, 70, "ExampleText",
 CellID->996359],
Cell[CellGroupData[{
Cell[8053, 254, 194, 6, 70, "Input",
 CellID->3613516],
Cell[8250, 262, 854, 22, 36, "Output",
 CellID->254422367]
}, Open  ]],
Cell[9119, 287, 119, 3, 70, "ExampleText",
 CellID->391360192],
Cell[CellGroupData[{
Cell[9263, 294, 387, 12, 70, "Input",
 CellID->114029401],
Cell[9653, 308, 1233, 40, 36, "Output",
 CellID->99607303]
}, Open  ]],
Cell[10901, 351, 76, 1, 70, "ExampleText",
 CellID->124790726],
Cell[CellGroupData[{
Cell[11002, 356, 168, 5, 28, "Input",
 CellID->277273771],
Cell[11173, 363, 3761, 69, 87, "Output",
 CellID->291935952]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14995, 439, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[15415, 453, 195, 4, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[15647, 462, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[16069, 476, 174, 3, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[16280, 484, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[16702, 498, 157, 3, 70, "MoreAbout",
 CellID->630835379]
}, Open  ]],
Cell[16874, 504, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

