(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     18054,        529]
NotebookOptionsPosition[     14458,        413]
NotebookOutlinePosition[     16161,        460]
CellTagsIndexPosition[     16076,        455]
WindowTitle->TrailingEdgeAngle - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"1.5 Panel Geometry\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/tutorial/PanelGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ThickAirfoilQ\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/ref/ThickAirfoilQ"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AirfoilGeometry\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/AirfoilGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/TrailingEdgeAngle\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/TrailingEdgeAngle"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
TrailingEdgeAngle.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/TrailingEdgeAngle", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["TrailingEdgeAngle", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TrailingEdgeAngle", "[", 
       StyleBox[
        SubscriptBox["r", "p"], "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns the angle between the two trailing-edge panels \
of the airfoil specified by the collection of vectors ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["r", "TI"], 
       StyleBox["p", "TI"]]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->463501498],

Cell["New in 1.0", "Notes",
 CellID->918694056]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->580972217],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->21472573],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->227801669],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->210252242],

Cell["\<\
Import the data file for the Eppler-205 airfoil and plot the airfoil.\
\>", "ExampleText",
 CellID->246240456],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rD", "=", 
   RowBox[{
   "AirfoilFromDataFile", "[", 
    "\"\<Aerodynamics\\\\Airfoil Data\\\\e205.dat\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"grD", "=", 
  RowBox[{"PlotAirfoil", "[", "rD", "]"}]}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->43842758],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3c+LG+cdx3GV/iX9NxZKD8aHkINxwfhgfNkFkVyai31JLu2lvdggkosN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    "], {{0, 180}, {504, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{504, 180},
  PlotRange->{{0, 504}, {0, 180}}]], "Output",
 ImageSize->{508, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->297627841]
}, Open  ]],

Cell["Determine the angle between the two trailing-edge panels.", \
"ExampleText",
 CellID->32561414],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Theta]TE", "=", 
  RowBox[{"TrailingEdgeAngle", "[", "rD", "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->320799349],

Cell[BoxData["0.12116139262963699`"], "Output",
 ImageSize->{60, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->92043984]
}, Open  ]],

Cell["Express the angle in degrees.", "ExampleText",
 CellID->391585135],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Theta]TE", "/", "Degree"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->272859992],

Cell[BoxData["6.942036437605679`"], "Output",
 ImageSize->{53, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->506898606]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[StyleBox[ButtonBox["ThickAirfoilQ",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/ref/ThickAirfoilQ"],
 FontFamily->"Verdana"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["1.5 Panel Geometry",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/tutorial/PanelGeometry"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["AirfoilGeometry",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/AirfoilGeometry"]], "MoreAbout",
 CellID->544795534]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"TrailingEdgeAngle - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 10, 3, 0.4128000}", "context" -> 
    "Aerodynamics`AirfoilGeometry`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "TrailingEdgeAngle[r_p] returns the angle between the two trailing-edge \
panels of the airfoil specified by the collection of vectors r_p.", 
    "synonyms" -> {}, "title" -> "TrailingEdgeAngle", "type" -> "Symbol", 
    "uri" -> "Aerodynamics/ref/TrailingEdgeAngle"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5328, 156, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->580972217]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15933, 448}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[610, 21, 76, 1, 70, "SymbolColorBar"],
Cell[689, 24, 191, 5, 70, "LinkTrail"],
Cell[883, 31, 3042, 70, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3950, 105, 60, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[4013, 108, 611, 18, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4661, 131, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->463501498],
Cell[5244, 150, 47, 1, 70, "Notes",
 CellID->918694056]
}, Closed]],
Cell[CellGroupData[{
Cell[5328, 156, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->580972217],
Cell[CellGroupData[{
Cell[5814, 173, 147, 5, 70, "ExampleSection",
 CellID->21472573],
Cell[5964, 180, 132, 6, 70, "ExampleText",
 CellID->227801669],
Cell[6099, 188, 100, 3, 70, "Input",
 CellID->210252242],
Cell[6202, 193, 120, 3, 70, "ExampleText",
 CellID->246240456],
Cell[CellGroupData[{
Cell[6347, 200, 309, 10, 47, "Input",
 CellID->43842758],
Cell[6659, 212, 5001, 89, 201, "Output",
 CellID->297627841]
}, Open  ]],
Cell[11675, 304, 101, 2, 70, "ExampleText",
 CellID->32561414],
Cell[CellGroupData[{
Cell[11801, 310, 146, 4, 70, "Input",
 CellID->320799349],
Cell[11950, 316, 176, 5, 36, "Output",
 CellID->92043984]
}, Open  ]],
Cell[12141, 324, 72, 1, 70, "ExampleText",
 CellID->391585135],
Cell[CellGroupData[{
Cell[12238, 329, 106, 3, 70, "Input",
 CellID->272859992],
Cell[12347, 334, 175, 5, 36, "Output",
 CellID->506898606]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12583, 346, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[13003, 360, 181, 4, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[13221, 369, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[13643, 383, 159, 3, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[13839, 391, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[14261, 405, 155, 3, 70, "MoreAbout",
 CellID->544795534]
}, Open  ]],
Cell[14431, 411, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

