(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15541,        524]
NotebookOptionsPosition[     12061,        411]
NotebookOutlinePosition[     13714,        457]
CellTagsIndexPosition[     13629,        452]
WindowTitle->TwoDimQ - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"A1 Data Type CartesianVectors\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ThreeDimQ\"\>":>Documentation`HelpLookup[
       "paclet:Aerodynamics/ref/ThreeDimQ"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"CartesianVectors\"\>":>
       Documentation`HelpLookup["paclet:Aerodynamics/guide/CartesianVectors"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/ref/TwoDimQ\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/ref/TwoDimQ"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/ref/\
TwoDimQ.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/ref/TwoDimQ", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["TwoDimQ", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TwoDimQ", "[", 
       StyleBox["v", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns True if ",
     Cell[BoxData[
      StyleBox["v", "TI"]], "InlineFormula"],
     " is a collection of two-dimensional vectors of the data type ",
     Cell[BoxData[
      ButtonBox["CartesianVectors",
       BaseStyle->"Link",
       ButtonData->"paclet:Aerodynamics/ref/CartesianVectors"]], 
      "InlineFormula"],
     ", False if not."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->106389861],

Cell["New in 1.0", "Notes",
 CellID->918694056]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->383799858],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->142142919],

Cell[TextData[{
 "Load the ",
 StyleBox["Aerodynamics",
  FontSlant->"Italic"],
 " packages."
}], "ExampleText",
 CellID->371969155],

Cell[BoxData[
 RowBox[{"<<", "Aerodynamics`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->689484102],

Cell["\<\
Specify a collection of two-dimensional vectors and a collection of \
three-dimensional vectors.\
\>", "ExampleText",
 CellID->315076144],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"u2D", "=", 
  RowBox[{"MakeCartesianVectors", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Array", "[", 
      RowBox[{"ux", ",", "5"}], "]"}], ",", 
     RowBox[{"Array", "[", 
      RowBox[{"uy", ",", "5"}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->309418216],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ux", "[", "1", "]"}], ",", 
     RowBox[{"ux", "[", "2", "]"}], ",", 
     RowBox[{"ux", "[", "3", "]"}], ",", 
     RowBox[{"ux", "[", "4", "]"}], ",", 
     RowBox[{"ux", "[", "5", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uy", "[", "1", "]"}], ",", 
     RowBox[{"uy", "[", "2", "]"}], ",", 
     RowBox[{"uy", "[", "3", "]"}], ",", 
     RowBox[{"uy", "[", "4", "]"}], ",", 
     RowBox[{"uy", "[", "5", "]"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{
     $CellContext`ux[1], 
     $CellContext`ux[2], 
     $CellContext`ux[3], 
     $CellContext`ux[4], 
     $CellContext`ux[5]}, {
     $CellContext`uy[1], 
     $CellContext`uy[2], 
     $CellContext`uy[3], 
     $CellContext`uy[4], 
     $CellContext`uy[5]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{479, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->962930055]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v3D", "=", 
  RowBox[{"MakeCartesianVectors", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Array", "[", 
      RowBox[{"vx", ",", "5"}], "]"}], ",", 
     RowBox[{"Array", "[", 
      RowBox[{"vy", ",", "5"}], "]"}], ",", 
     RowBox[{"Array", "[", 
      RowBox[{"vz", ",", "5"}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->843452585],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vx", "[", "1", "]"}], ",", 
     RowBox[{"vx", "[", "2", "]"}], ",", 
     RowBox[{"vx", "[", "3", "]"}], ",", 
     RowBox[{"vx", "[", "4", "]"}], ",", 
     RowBox[{"vx", "[", "5", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vy", "[", "1", "]"}], ",", 
     RowBox[{"vy", "[", "2", "]"}], ",", 
     RowBox[{"vy", "[", "3", "]"}], ",", 
     RowBox[{"vy", "[", "4", "]"}], ",", 
     RowBox[{"vy", "[", "5", "]"}]}], "}"}], "\[UpArrow]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vz", "[", "1", "]"}], ",", 
     RowBox[{"vz", "[", "2", "]"}], ",", 
     RowBox[{"vz", "[", "3", "]"}], ",", 
     RowBox[{"vz", "[", "4", "]"}], ",", 
     RowBox[{"vz", "[", "5", "]"}]}], "}"}]}],
  Infix[
   Aerodynamics`CartesianVectors`CartesianVectors[{
     $CellContext`vx[1], 
     $CellContext`vx[2], 
     $CellContext`vx[3], 
     $CellContext`vx[4], 
     $CellContext`vx[5]}, {
     $CellContext`vy[1], 
     $CellContext`vy[2], 
     $CellContext`vy[3], 
     $CellContext`vy[4], 
     $CellContext`vy[5]}, {
     $CellContext`vz[1], 
     $CellContext`vz[2], 
     $CellContext`vz[3], 
     $CellContext`vz[4], 
     $CellContext`vz[5]}], "\[UpArrow]"],
  Editable->False]], "Output",
 ImageSize->{487, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->75429641]
}, Open  ]],

Cell["Test the two collections using TwoDimQ.", "ExampleText",
 CellID->295597101],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TwoDimQ", "/@", 
  RowBox[{"{", 
   RowBox[{"u2D", ",", "v3D"}], "}"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->512567239],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"True", ",", "False"}], "}"}]], "Output",
 ImageSize->{92, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->754915042]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[StyleBox[ButtonBox["ThreeDimQ",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/ref/ThreeDimQ"],
 FontFamily->"Verdana"]], "SeeAlso",
 CellID->88624347]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 CellID->250839057],

Cell[TextData[ButtonBox["A1 Data Type CartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/tutorial/CartesianVectors"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["CartesianVectors",
 BaseStyle->"Link",
 ButtonData->"paclet:Aerodynamics/guide/CartesianVectors"]], "MoreAbout",
 CellID->704837555]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"TwoDimQ - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 10, 3, 3.7980000}", "context" -> 
    "Aerodynamics`CartesianVectors`", "keywords" -> {}, "index" -> True, 
    "label" -> "Aerodynamics Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "Aerodynamics Package", "status" -> "None", "summary" -> 
    "TwoDimQ[v] returns True if v is a collection of two-dimensional vectors \
of the data type CartesianVectors, False if not.", "synonyms" -> {}, "title" -> 
    "TwoDimQ", "type" -> "Symbol", "uri" -> "Aerodynamics/ref/TwoDimQ"}, 
  "LinkTrails" -> "", "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5353, 159, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->383799858]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13486, 445}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 76, 1, 70, "SymbolColorBar"],
Cell[679, 24, 191, 5, 70, "LinkTrail"],
Cell[873, 31, 3016, 71, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3914, 106, 50, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[3967, 109, 682, 20, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4686, 134, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->106389861],
Cell[5269, 153, 47, 1, 70, "Notes",
 CellID->918694056]
}, Closed]],
Cell[CellGroupData[{
Cell[5353, 159, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->383799858],
Cell[CellGroupData[{
Cell[5839, 176, 148, 5, 70, "ExampleSection",
 CellID->142142919],
Cell[5990, 183, 132, 6, 70, "ExampleText",
 CellID->371969155],
Cell[6125, 191, 100, 3, 70, "Input",
 CellID->689484102],
Cell[6228, 196, 147, 4, 70, "ExampleText",
 CellID->315076144],
Cell[CellGroupData[{
Cell[6400, 204, 316, 10, 70, "Input",
 CellID->309418216],
Cell[6719, 216, 1048, 34, 36, "Output",
 CellID->962930055]
}, Open  ]],
Cell[CellGroupData[{
Cell[7804, 255, 389, 12, 70, "Input",
 CellID->843452585],
Cell[8196, 269, 1437, 46, 54, "Output",
 CellID->75429641]
}, Open  ]],
Cell[9648, 318, 82, 1, 70, "ExampleText",
 CellID->295597101],
Cell[CellGroupData[{
Cell[9755, 323, 150, 5, 70, "Input",
 CellID->512567239],
Cell[9908, 330, 210, 7, 36, "Output",
 CellID->754915042]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10179, 344, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[10599, 358, 172, 4, 70, "SeeAlso",
 CellID->88624347]
}, Open  ]],
Cell[CellGroupData[{
Cell[10808, 367, 419, 12, 70, "TutorialsSection",
 CellID->250839057],
Cell[11230, 381, 173, 3, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[11440, 389, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[11862, 403, 157, 3, 70, "MoreAbout",
 CellID->704837555]
}, Open  ]],
Cell[12034, 409, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

