(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      8243,        271]
NotebookOptionsPosition[      5487,        189]
NotebookOutlinePosition[      7392,        239]
CellTagsIndexPosition[      7349,        236]
WindowTitle->Equations - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS TUTORIAL", "PacletNameCell"], Cell[TextData[Cell[
    BoxData[
     ActionMenuBox[
      FrameBox["\<\"URL \[RightGuillemet]\"\>",
       StripOnInput->False], {"\<\"Aerodynamics/tutorial/Equations\"\>":>
      None, "\<\"Copy Mathematica url\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["Aerodynamics/tutorial/Equations"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web url\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/mathematica/Aerodynamics/\
tutorial/Equations.html"], StandardForm]], "Input", TextClipboardType -> 
             "PlainText"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
           "http://reference.wolfram.com/mathematica/", 
            "Aerodynamics/tutorial/Equations", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic]],
     LineSpacing->{1.4, 0}]], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Equations", "Title",
 CellID->509267359],

Cell["\<\
This is a temporary tutorial to experiment with prodedures for writing \
equations.\
\>", "Text",
 CellID->1534169418],

Cell[CellGroupData[{

Cell["Basic equations", "Subsection",
 CellID->186654114],

Cell["\<\
Use keyboard shortcuts listed in Insert>Typesetting.  Note that this is not \
the look of an equation written in a notebook.  Note that individual symbols \
are Courier New Regular 11.\
\>", "Text",
 CellID->14313774],

Cell[TextData[Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["a", "j"], "+", 
   RowBox[{
    SubscriptBox["b", "j"], " ", 
    SubscriptBox["\[Delta]", "j"]}]}], "=", 
  SubscriptBox["a", 
   RowBox[{"j", "+", "1"}]]}]], "InlineFormula"]], "Text",
 CellID->644822206],

Cell["\<\
Copy above cell and use Documentation Tools to apply Traditional Math \
formatting.  This appears to be formatted correctly for an equation.  \
Individual symbols are Times New Roman italic 12.\
\>", "Text",
 CellID->656567920],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    SubscriptBox["a", "j"], "+", 
    RowBox[{
     SubscriptBox["b", "j"], " ", 
     SubscriptBox["\[Delta]", "j"]}]}], "=", 
   SubscriptBox["a", 
    RowBox[{"j", "+", "1"}]]}], TraditionalForm]], "InlineMath"]], "Text",
 CellID->19566054],

Cell["Write the equation in form for Template Input.", "Text",
 CellID->384366327],

Cell["a$j+b$j \[Delta]$j=a$j+1", "Text",
 CellID->585300967],

Cell["\<\
Copy and paste below and use Template Input.  Note that last term in equation \
is changed.\
\>", "Text",
 CellID->326007726],

Cell[TextData[Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox[
    StyleBox["a", "TI"], 
    StyleBox["j", "TI"]], "+", 
   RowBox[{
    SubscriptBox[
     StyleBox["b", "TI"], 
     StyleBox["j", "TI"]], " ", 
    SubscriptBox[
     StyleBox["\[Delta]", "TR"], 
     StyleBox["j", "TI"]]}]}], "=", 
  RowBox[{
   SubscriptBox[
    StyleBox["a", "TI"], 
    StyleBox["j", "TI"]], "+", "1"}]}]], "InlineFormula"]], "Text",
 CellID->503805601],

Cell["Copy, paste and alter.", "Text",
 CellID->10097974],

Cell[TextData[Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox[
    StyleBox["a", "TI"], 
    StyleBox["j", "TI"]], "+", 
   RowBox[{
    SubscriptBox[
     StyleBox["b", "TI"], 
     StyleBox["j", "TI"]], " ", 
    SubscriptBox[
     StyleBox["\[Delta]", "TR"], 
     StyleBox["j", "TI"]]}]}], "=", 
  SubscriptBox[
   StyleBox["a", "TI"], 
   StyleBox[
    RowBox[{"j", 
     StyleBox["+",
      FontSlant->"Plain"], 
     StyleBox["1",
      FontSlant->"Plain"]}], "TI"]]}]], "InlineFormula"]], "Text",
 CellID->433151550]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Equations - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 10, 3, 50.9880000}", "context" -> 
    "Aerodynamics`", "keywords" -> {}, "index" -> True, "label" -> 
    "Aerodynamics Tutorial", "language" -> "en", "paclet" -> "Aerodynamics", 
    "status" -> "None", "summary" -> 
    "This is a temporary tutorial to experiment with prodedures for writing \
equations. Use keyboard shortcuts listed in Insert>Typesetting. Note that \
this is not the look of an equation written in a notebook. Note that \
individual symbols are Courier New Regular 11. a_j+b_j \\[Delta]_j=a_j+1", 
    "synonyms" -> {}, "title" -> "Equations", "type" -> "Tutorial", "uri" -> 
    "Aerodynamics/tutorial/Equations"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 78, 1, 70, "TutorialColorBar"],
Cell[683, 24, 191, 5, 70, "LinkTrail"],
Cell[877, 31, 1897, 42, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[2799, 77, 46, 1, 70, "Title",
 CellID->509267359],
Cell[2848, 80, 128, 4, 70, "Text",
 CellID->1534169418],
Cell[CellGroupData[{
Cell[3001, 88, 57, 1, 70, "Subsection",
 CellID->186654114],
Cell[3061, 91, 227, 5, 70, "Text",
 CellID->14313774],
Cell[3291, 98, 272, 9, 70, "Text",
 CellID->644822206],
Cell[3566, 109, 237, 5, 70, "Text",
 CellID->656567920],
Cell[3806, 116, 304, 10, 70, "Text",
 CellID->19566054],
Cell[4113, 128, 82, 1, 70, "Text",
 CellID->384366327],
Cell[4198, 131, 60, 1, 70, "Text",
 CellID->585300967],
Cell[4261, 134, 135, 4, 70, "Text",
 CellID->326007726],
Cell[4399, 140, 444, 17, 70, "Text",
 CellID->503805601],
Cell[4846, 159, 57, 1, 70, "Text",
 CellID->10097974],
Cell[4906, 162, 527, 21, 70, "Text",
 CellID->433151550]
}, Open  ]]
}, Open  ]],
Cell[5460, 187, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

