(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      8329,        256]
NotebookOptionsPosition[      5090,        156]
NotebookOutlinePosition[      7554,        228]
CellTagsIndexPosition[      7400,        220]
WindowTitle->References - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Aerodynamics",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Aerodynamics/guide/Aerodynamics"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["AERODYNAMICS TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"3.7 Worksheet for Airfoil Aerodynamics\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/WorksheetForAirfoilAerodynamics"], \
"\<\"A1 Data Type CartesianVectors\"\>":>Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/CartesianVectors"], "\<\"Overview\"\>":>
       Documentation`HelpLookup[
       "paclet:Aerodynamics/tutorial/AerodynamicsOverview"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Aerodynamics/tutorial/References\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Aerodynamics/tutorial/References"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Aerodynamics/\
tutorial/References.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Aerodynamics/tutorial/References", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["References", "Title",
 CellID->509267359],

Cell["\<\
Anderson, J. D. (1984).  Fundamentals of Aerodynamics, 2nd ed.\
\>", "Text",
 CellTags->"anderson1984",
 CellID->712199631],

Cell["\<\
Abbott, I. H. and von Doenhoff, A. E. (1959).  Theory of Wing Sections, \
Including a Summary of Airfoil Data, Dover Edition, Dover edition.\
\>", "Text",
 CellTags->"abbott1959",
 CellID->171382246],

Cell[TextData[{
 "Hess, J. L. (1990).  Panel Methods in Computational Fluid Dynamics, ",
 StyleBox["Annual Review of Fluid Mechanics",
  FontSlant->"Italic"],
 ", ",
 StyleBox["22",
  FontWeight->"Bold"],
 ", 255-274."
}], "Text",
 CellTags->"hess1990",
 CellID->218650378],

Cell["\<\
Katz, J. and Plotkin, A. (2001).  Low-Speed Aerodynamics, 2nd ed.\
\>", "Text",
 CellTags->"katz2001",
 CellID->443890195],

Cell[CellGroupData[{

Cell["RELATED TUTORIALS", "RelatedTutorialsSection",
 CellID->415694126],

Cell[TextData[ButtonBox["3.7 Worksheet for Airfoil Aerodynamics",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Aerodynamics/tutorial/WorksheetForAirfoilAerodynamics"]], \
"RelatedTutorials",
 CellID->59868671],

Cell[TextData[ButtonBox["A1 Data Type CartesianVectors",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Aerodynamics/tutorial/CartesianVectors"]], "RelatedTutorials",
 CellID->806871991],

Cell[TextData[ButtonBox["Overview",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Aerodynamics/tutorial/AerodynamicsOverview"]], "RelatedTutorials",
 CellID->280152894]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"References - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2010, 12, 15, 10, 4, 49.1448000}", "context" -> 
    "Aerodynamics`", "keywords" -> {}, "index" -> True, "label" -> 
    "Aerodynamics Tutorial", "language" -> "en", "paclet" -> "Aerodynamics", 
    "status" -> "None", "summary" -> 
    "Anderson, J. D. (1984). Fundamentals of Aerodynamics, 2nd ed. Abbott, I. \
H. and von Doenhoff, A. E. (1959). Theory of Wing Sections, Including a \
Summary of Airfoil Data, Dover Edition, Dover edition. Hess, J. L. (1990). \
Panel Methods in Computational Fluid Dynamics, Annual Review of Fluid \
Mechanics, 22, 255-274.", "synonyms" -> {}, "title" -> "References", "type" -> 
    "Tutorial", "uri" -> "Aerodynamics/tutorial/References"}, "LinkTrails" -> 
  "", "SearchTextTranslated" -> ""},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "anderson1984"->{
  Cell[3617, 97, 133, 4, 70, "Text",
   CellTags->"anderson1984",
   CellID->712199631]},
 "abbott1959"->{
  Cell[3753, 103, 209, 5, 70, "Text",
   CellTags->"abbott1959",
   CellID->171382246]},
 "hess1990"->{
  Cell[3965, 110, 273, 10, 70, "Text",
   CellTags->"hess1990",
   CellID->218650378]},
 "katz2001"->{
  Cell[4241, 122, 132, 4, 70, "Text",
   CellTags->"katz2001",
   CellID->443890195]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"anderson1984", 6976, 201},
 {"abbott1959", 7083, 205},
 {"hess1990", 7187, 209},
 {"katz2001", 7290, 213}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 78, 1, 70, "TutorialColorBar"],
Cell[684, 24, 191, 5, 70, "LinkTrail"],
Cell[878, 31, 2664, 59, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3567, 94, 47, 1, 70, "Title",
 CellID->509267359],
Cell[3617, 97, 133, 4, 70, "Text",
 CellTags->"anderson1984",
 CellID->712199631],
Cell[3753, 103, 209, 5, 70, "Text",
 CellTags->"abbott1959",
 CellID->171382246],
Cell[3965, 110, 273, 10, 70, "Text",
 CellTags->"hess1990",
 CellID->218650378],
Cell[4241, 122, 132, 4, 70, "Text",
 CellTags->"katz2001",
 CellID->443890195],
Cell[CellGroupData[{
Cell[4398, 130, 72, 1, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[4473, 133, 208, 5, 70, "RelatedTutorials",
 CellID->59868671],
Cell[4684, 140, 183, 4, 70, "RelatedTutorials",
 CellID->806871991],
Cell[4870, 146, 166, 4, 70, "RelatedTutorials",
 CellID->280152894]
}, Open  ]]
}, Open  ]],
Cell[5063, 154, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

